﻿using System.Runtime.Serialization;

namespace Butterfly.Core
{
    [DataContract]
    public class ButterflyConfiguration
    {
        [DataMember]
        public Networking Networking { get; set; }

        [DataMember]
        public Database Database { get; set; }

        [DataMember]
        public string DefaultUserClub { get; set; }

        [DataMember]
        public bool PixelCronEnabled { get; set; }

        [DataMember]
        public int PixelCronAmount { get; set; }

        [DataMember]
        public uint PixelCronCycleTime { get; set; }

        [DataMember]
        public int PixelLoginAmount { get; set; }

        [DataMember]
        public bool CreditsCronEnabled { get; set; }

        [DataMember]
        public int CreditsCronAmount { get; set; }

        [DataMember]
        public uint CreditsCronCycleTime { get; set; }

        [DataMember]
        public int CreditsLoginAmount { get; set; }

        [DataMember]
        public bool WiredEnabled { get; set; }

        [DataMember]
        public bool WelcomeMessageEnabled { get; set; }

        [DataMember]
        public string WelcomeMessage { get; set; }
        
        [DataMember]
        public bool IgnoreUserLoginIP { get; set; }

        [DataMember]
        public bool GroupsEnabled { get; set; }

        [DataMember]
        public bool SyncCrystalsOnPurchase { get; set; }

        [DataMember]
        public bool WatchdogEnabled { get; set; }
    }

    [DataContract]
    public class Networking
    {
        [DataMember]
        public uint GamePort { get; set; }

        [DataMember]
        public uint GamePortConnectionLimit { get; set; }

        [DataMember]
        public bool EnableAglesAlgorithm { get; set; }

        [DataMember]
        public uint MusPort { get; set; }

        [DataMember]
        public int MonitoringPort { get; set; }

        [DataMember]
        public string[] AllowedMusIPAddresses { get; set; }

        [DataMember]
        public bool ClientPingEnabled { get; set; }

        [DataMember]
        public uint ClientPingInterval { get; set; }
    }

    [DataContract]
    public class Database
    {
        [DataMember]
        public string Host { get; set; }

        [DataMember]
        public uint Port { get; set; }

        [DataMember]
        public string Username { get; set; }

        [DataMember]
        public string Password { get; set; }

        [DataMember]
        public string DatabaseName { get; set; }

        [DataMember]
        public uint MinPoolSize { get; set; }

        [DataMember]
        public uint MaxPoolSize { get; set; }
    }
}
