﻿using Butterfly.Messages.Parsing;
using ConnectivityAsync;
using System;

namespace Butterfly.Core
{
    public class ConnectionHandeling
    {
        private ConnectionManager manager;

        public ConnectionHandeling(uint port, uint maxConnections, bool enabeNagles)
        {
            this.manager = new ConnectionManager((int)port, (int)maxConnections, new InitialPacketParser(), !enabeNagles);
            this.manager.connectionEvent += OnConnectionEvent;
        }

        private void OnConnectionEvent(ConnectionInformation connection)
        {
			uint ID = connection.GetConnectionID();
			try
			{
				connection.OnConnectionClosed += ConnectionChanged;
				ButterflyEnvironment.Game.GetClientManager().CreateAndStartClient(connection.GetConnectionID(), connection);
                Logging.WriteLine("Accepting connection ID " + ID + " from " + connection.GetIP());
			}
			catch (Exception e)
			{
				Console.WriteLine(e.ToString() + Environment.NewLine + ID);
			}
        }

		private void ConnectionChanged(ConnectionInformation connection)
		{
			connection.Destroy();
			connection.OnConnectionClosed -= ConnectionChanged;
            ButterflyEnvironment.Game.GetClientManager().GetClient(connection.GetConnectionID())?.Disconnect();
		}

        internal void Start()
        {
			manager.StartListening();
        }

        internal void Destroy()
        {
            manager.Destroy();   
        }

		internal void SetDebugState(bool isDebugging)
		{
			manager.WriteDebugLines = isDebugging;
		}
    }
}
