using System.IO;
using System.Runtime.Serialization.Json;

namespace Butterfly.Core
{
    class JsonReader<T>
    {
        internal static T FromFile(string path, bool useSimpleFormat = false)
        {
            DataContractJsonSerializerSettings settings = new DataContractJsonSerializerSettings();
			
			settings.UseSimpleDictionaryFormat = useSimpleFormat;
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(T), settings);

            using (StreamReader file = new StreamReader(ButterflyEnvironment.StartupPath + path))
            {
                return (T)serializer.ReadObject(file.BaseStream);
            }
        }
    }
}
