﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Butterfly.Messages;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Achievements.Composer
{
    class AchievementListComposer
    {
        internal static ServerMessage Compose(GameClient Session, List<Achievement> Achievements)
        {
            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.AchievementsEvent); //436
            Message.AddInt32(Achievements.Count);

            foreach (Achievement Achievement in Achievements)
            {
                UserAchievement UserData = Session.GetHabbo().GetAchievementData(Achievement.GroupName);
                int TargetLevel = (UserData != null ? UserData.Level + 1 : 1);
                int TotalLevels = Achievement.Levels.Count;

                if (TargetLevel > TotalLevels)
                {
                    TargetLevel = TotalLevels;
                }

                AchievementLevel TargetLevelData = Achievement.Levels[TargetLevel];

                Message.AddInt32((int)Achievement.Id);                                                           // Unknown (ID?)
                Message.AddInt32(TargetLevel);                                                   // Target level
                Message.AddString(Achievement.GroupName + TargetLevel);                 // Target name/desc/badge
                Message.AddInt32(TargetLevelData.Requirement);                                   // Progress req/target        
                Message.AddInt32(TargetLevelData.RewardPixels);                                   // Pixel reward       
                Message.AddInt32(TargetLevelData.RewardPoints);                                   // Pixel reward       
                Message.AddInt32(0);        
                // Unknown(??)
                Message.AddInt32(UserData != null ? UserData.Progress : 0);                      // Current progress
                Message.AddBoolean(UserData != null ? (UserData.Level >= TotalLevels) : false);  // Set 100% completed(??)
                Message.AddString(Achievement.Category);                                // Category
                Message.AddString(string.Empty);                                // Category
                
                Message.AddInt32(TotalLevels);           // Total amount of levels 
                Message.AddInt32(0);
            }
            Message.AddString("identity");
            return Message;
        }
    }
}
