﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Achievements.Composer
{
    class AchievementProgressComposer
    {
        internal static ServerMessage Compose(Achievement Achievement, int TargetLevel, AchievementLevel TargetLevelData,
            int TotalLevels, UserAchievement UserData)
        {
            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.AchievementEvent);
            Message.AddUInt32(Achievement.Id);                                               // Unknown (ID?)
            Message.AddInt32(TargetLevel);                                                   // Target level
            Message.AddString(Achievement.GroupName + TargetLevel);                 // Target name/desc/badge
            Message.AddInt32(TargetLevelData.Requirement);                                   // Progress req/target        
            Message.AddInt32(TargetLevelData.RewardPixels);                                   // Pixel reward       
            Message.AddInt32(TargetLevelData.RewardPoints);                                  // Unknown(??)
            Message.AddInt32(0); // ?
            Message.AddInt32(UserData != null ? UserData.Progress : 0);                      // Current progress
            Message.AddBoolean(UserData != null ? (UserData.Level >= TotalLevels) : false);  // Set 100% completed(??)
            Message.AddString(Achievement.Category);                               // Category
            Message.AddString(String.Empty);
            Message.AddInt32(TotalLevels);                                                   // Total amount of levels 
            Message.AddInt32(0);                                      // Total amount of levels 
            return Message;
        }
    }
}
