﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Achievements.Composer
{
    class AchievementUnlockedComposer
    {
        internal static ServerMessage Compose(Achievement Achievement, int Level, int PointReward, int PixelReward)
        {
            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.HabboAchievementNotificationMessageEvent);
            Message.AddUInt32(Achievement.Id);                                           // Achievement ID
            Message.AddInt32(Level);                                                     // Achieved level
            Message.AddInt32(144);                                                         // Unknown. Random useless number.
            Message.AddString(Achievement.GroupName + Level);                   // Achieved name
            Message.AddInt32(PointReward);                                               // Point reward
            Message.AddInt32(PixelReward);                                               // Pixel reward
            Message.AddInt32(0);                                                         // Unknown.
            Message.AddInt32(10);                                                         // Unknown.
            Message.AddInt32(21);                                                         // Unknown. (Extra reward?)
            Message.AddString(Level > 1 ? Achievement.GroupName + (Level - 1) : string.Empty);
            Message.AddString(Achievement.Category);
            Message.AddString(String.Empty);
            Message.AddInt32(0);
            Message.AddInt32(0);

            return Message;
        }
    }
}
