﻿using System;
using System.Data;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages;
using Database_Manager.Database.Session_Details.Interfaces;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Catalogs
{
    class VoucherHandler
    {
        private static Boolean IsValidCode(string Code)
        {
            bool exists = false;
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT id FROM credit_vouchers WHERE code = @code");
                dbClient.addParameter("code", Code);
                exists = dbClient.findsResult();
            }

            return exists;
        }

        internal static int GetVoucherValue(string Code)
        {
            DataRow Data;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT value FROM credit_vouchers WHERE code = @code");
                dbClient.addParameter("code", Code);

                Data = dbClient.getRow();
            }

            if (Data != null)
            {
                return (int)Data[0];
            }

            return 0;
        }

        private static void TryDeleteVoucher(string Code)
        {
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("DELETE FROM credit_vouchers WHERE code = @code");
                dbClient.addParameter("code", Code);
                dbClient.runQuery();
            }
        }

        internal static void TryRedeemVoucher(GameClient Session, string Code)
        {
            if (!IsValidCode(Code))
            {
                Session.SendNotif("Invalid voucher code");
                return;
            }

            int Value = GetVoucherValue(Code);

            TryDeleteVoucher(Code);

            Session.GetHabbo().Credits += Value;
            Session.GetHabboDataContainer().UpdateCreditsBalance();

            Session.SendNotif(string.Format("You just reedemed a voucher with a value of {0} credits", Value));
            //ServerMessage msg = new ServerMessage(OutputCode.VoucherRedeemOkMessageEvent);
            //msg.AddString("Credits");
            //msg.AddString(string.Empty);
            //Session.SendMessage(msg);
        }
    }
}
