﻿using Butterfly.HabboHotel.Users;
using Butterfly.HabboHotel.Users.Authenticator;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.GameClients
{
    class HabboDataManager
    {
        private Hashtable loadedHabboData;

        public HabboDataManager()
        {
            this.loadedHabboData = new Hashtable();
        }

        internal Habbo LoadHabboData(uint userID)
        {
            Habbo data = null;
            DataRow dRow;
            DataTable group = new DataTable();

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT users.* FROM users WHERE id = @id LIMIT 1");
                dbClient.addParameter("id", userID);
                dRow = dbClient.getRow();

                if (dRow != null)
                {
                    if (ButterflyEnvironment.Configuration.GroupsEnabled)
                    {
                        dbClient.setQuery("SELECT * FROM groups_memberships WHERE groups_memberships.userid = " + userID + "");
                        group = dbClient.getTable();
                    }
                }
                else
                {
                    return null;
                }
            }

            data = HabboFactory.GenerateHabbo(dRow, group);
            while ((loadedHabboData[userID] != null))
            {
                loadedHabboData.Remove(userID);
            }
            loadedHabboData.Add(userID, data);
            return data;
        }

        internal Habbo GetHabboData(uint userID)
        {
            Habbo data = (Habbo)this.loadedHabboData[userID];

            if (data == null)
                return LoadHabboData(userID);
            else
                return data;
        }
        internal void ItemUpdated(Habbo updatable)
        {
            this.loadedHabboData.Remove(updatable.Id);
        }
    }
}
