﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Butterfly.HabboHotel.Items.FurniInitializers;
using Butterfly.HabboHotel.Items.FurniInitializers.Initializers;
using Butterfly.HabboHotel.Items.FurniInteractors.Interactors;
using Butterfly.Util;
using Butterfly.Exceptions;

namespace Butterfly.HabboHotel.Items.FurniInteractors
{
    static class FurniIInitializerFactory
    {
        private static Type[] listOfIgnores = new Type[] {typeof(IInitializer<RoomItem>), typeof(BaseTeamInitializer)};

        private readonly static Hashtable tableOfInteractors = new Hashtable(131);

        internal static void LoadType(Type type)
        {
            if (type.IsDefined(typeof(FurniInitializerAttribute), true))
            {
                if (typeof(IInitializer<RoomItem>).IsAssignableFrom(type))
                {
                    IEnumerable<FurniInitializerAttribute> atts = type.GetCustomAttributes<FurniInitializerAttribute>();
                    foreach (FurniInitializerAttribute att in atts)
                    {
                        tableOfInteractors.Add(att.name, (IInitializer<RoomItem>)Activator.CreateInstance(type));
                    }
                }
                else
                {
                    throw new ModuleInitializationException("Initializer [" + type.GetTypeInfo().FullName + "] does not implement IInteractable");
                }
            }
            else if (typeof(IInitializer<RoomItem>).IsAssignableFrom(type) && !listOfIgnores.Contains(type))
            {
                throw new ModuleInitializationException("Found IInitializer<RoomItem> without attribute, maybe forgot to add attribute? [" + type.GetTypeInfo().FullName + "]");
            }
        }

        public static IInitializer<RoomItem> GetInteractable(InteractionType type)
        {
            return (IInitializer<RoomItem>)tableOfInteractors[type];
        }
    }
}
