﻿using Butterfly.Exceptions;
using Butterfly.HabboHotel.Items.FurniInteractors.Interactors;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace Butterfly.HabboHotel.Items.FurniInteractors
{
    static class FurniInteractorFactory
    {
        private static Type[] listOfIgnores = new Type[] { typeof(BaseRandomExtraDataItemInteractor), typeof(IInteractable)};

        private readonly static Hashtable tableOfInteractors = new Hashtable(131);

        internal static void LoadType(Type type)
        {
            if (type.IsDefined(typeof(InteractorAttribute), true))
            {
                if (typeof(IInteractable).IsAssignableFrom(type))
                {
                    IEnumerable<InteractorAttribute> atts = type.GetCustomAttributes<InteractorAttribute>();
                    foreach (InteractorAttribute att in atts)
                    {
                        tableOfInteractors.Add(att.name, (IInteractable)Activator.CreateInstance(type));
                        //ConsoleWriter.Writer.LogMessage("Interactor for type [" + att.name + "] loaded");
                    }
                }
                else
                {
                    throw new ModuleInitializationException("Interactor [" + type.GetTypeInfo().FullName + "] does not implement IInteractable");
                }
            }
            else if (typeof(IInteractable).IsAssignableFrom(type) && !listOfIgnores.Contains(type))
            {
                throw new ModuleInitializationException("Found IInteractable without attribute, maybe forgot to add attribute? [" + type.GetTypeInfo().FullName + "]");
            }
        }

        public static IInteractable GetInteractable(InteractionType type)
        {
            return (IInteractable)tableOfInteractors[type];
        }
    }
}
