﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Butterfly.HabboHotel.Rooms.Games;

namespace Butterfly.HabboHotel.Items.FurniInteractors.Interactors
{
    [InteractorAttribute(InteractionType.banzaifloor)]
    class BanzaiFloorInteractor : IInteractable
    {
        /*
    3 = Red 1
    4 = Red 2
    5 = Red 3

    6 = Green 1
    7 = Green 2
    8 = Green 3

    9 = Blue 1
    10= Blue 2
    11= Blue 3

    12= Yellow 1
    13= Yellow 2
    14= Yellow 3
    */

        public void ExecuteAction(RoomItem theItem)
        {
            if (theItem.value == 3)
            {
                if (theItem.interactionCountHelper == 1)
                {
                    theItem.interactionCountHelper = 0;

                    switch (theItem.team)
                    {
                        case Team.blue:
                            {
                                theItem.ExtraData = "11";
                                break;
                            }

                        case Team.green:
                            {
                                theItem.ExtraData = "8";
                                break;
                            }

                        case Team.red:
                            {
                                theItem.ExtraData = "5";
                                break;
                            }

                        case Team.yellow:
                            {
                                theItem.ExtraData = "14";
                                break;
                            }
                    }
                }
                else
                {
                    theItem.ExtraData = "";
                    theItem.interactionCountHelper++;
                }

                theItem.UpdateState();

                theItem.interactionCount++;

                if (theItem.interactionCount < 16)
                {
                    theItem.UpdateCounter = 1;
                }
                else
                    theItem.UpdateCounter = 0;
            }
        }
    }
}
