﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniInteractors.Interactors
{
    [InteractorAttribute(InteractionType.freezetimer)]
    class FreezeTimerInteractor : IInteractable
    {
        public void ExecuteAction(RoomItem theItem)
        {
            if (string.IsNullOrEmpty(theItem.ExtraData))
                return;

            if (!theItem.GetRoom().GetFreeze().GameIsStarted)
                theItem.GetRoom().GetFreeze().StartGame();

            int seconds = 0;

            try
            {
                seconds = int.Parse(theItem.ExtraData);
            }
            catch { }

            if (seconds > 0)
            {
                if (theItem.interactionCountHelper == 1)
                {
                    seconds--;
                    theItem.interactionCountHelper = 0;

                    theItem.ExtraData = seconds.ToString();
                    theItem.UpdateState();
                }
                else
                    theItem.interactionCountHelper++;

                theItem.UpdateCounter = 1;
            }
            else
            {
                theItem.UpdateNeeded = false;
                theItem.GetRoom().GetFreeze().StopGame();
            }

        }
    }
}
