﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniTriggers;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.HabboHotel.Items.FurniInteractors.Interactors
{
    [InteractorAttribute(InteractionType.groupGate)]
    class GroupGateInteractor : IInteractable
    {
        private void SetExtraData(string data, RoomItem item)
        {
            string[] extraData = item.ExtraData.Split(':');
            item.ExtraData = extraData[0] + ':' + data;
        }
        
     private string GetExtradata(RoomItem item)
        {
            string[] extraData = item.ExtraData.Split(':');
            if (extraData.Length <= 1)
                return item.ExtraData;
            else return extraData[1];
        }
        
        public void ExecuteAction(RoomItem theItem)
        {
            RoomUser User = null;

            if (theItem.InteractingUser > 0)
            {
                User = theItem.GetRoom().GetRoomUserManager().GetRoomUserByHabbo(theItem.InteractingUser);
                //GetRoom().FreeSqareForUsers(mX, mY);
            }

            if (User != null && User.X == theItem.GetX && User.Y == theItem.GetY)
            {
                SetExtraData("1", theItem);

                User.MoveTo(theItem.SquareBehind);

                theItem.ReqUpdate(1, false);
                theItem.UpdateState(false, true);
            }
            else if (User != null && User.Coordinate == theItem.SquareBehind)
            {
                User.UnlockWalking();

                SetExtraData("0", theItem);
                theItem.InteractingUser = 0;

                theItem.UpdateState(false, true);
            }
            else if (GetExtradata(theItem) == "1")
            {
                SetExtraData("0", theItem);
                theItem.UpdateState(false, true);
            }

            if (User == null)
            {
                theItem.InteractingUser = 0;
            }
        }
    }
}
