﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.HabboHotel.Items.FurniInteractors.Interactors
{
    [InteractorAttribute(InteractionType.onewaygate)]
    class OnewayGateInteractor : IInteractable
    {
        public void ExecuteAction(RoomItem theItem)
        {
            RoomUser User = null;

            if (theItem.InteractingUser > 0)
            {
                User = theItem.GetRoom().GetRoomUserManager().GetRoomUserByHabbo(theItem.InteractingUser);
                //GetRoom().FreeSqareForUsers(mX, mY);
            }

            if (User != null && User.X == theItem.GetX && User.Y == theItem.GetY)
            {
                theItem.ExtraData = "1";

                User.MoveTo(theItem.SquareBehind);

                theItem.ReqUpdate(1, false);
                theItem.UpdateState(false, true);
            }
            else if (User != null && User.Coordinate == theItem.SquareBehind)
            {
                User.UnlockWalking();

                theItem.ExtraData = "0";
                theItem.InteractingUser = 0;

                theItem.UpdateState(false, true);
            }
            else if (theItem.ExtraData == "1")
            {
                theItem.ExtraData = "0";
                theItem.UpdateState(false, true);
            }

            if (User == null)
            {
                theItem.InteractingUser = 0;
            }
        }
    }
}
