﻿using Butterfly.Exceptions;
using Butterfly.HabboHotel.Items.FurniTriggers;
using Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace Butterfly.HabboHotel.Items.FurniInteractors
{
    static class FurniTriggerFactory
    {
        private static Type[] listOfIgnores = new Type[] {typeof(IFurniTrigger) , typeof(BaseWiredInteractor)};

        private readonly static Hashtable tableOfInteractors = new Hashtable(131);

        internal static void LoadType(Type type)
        {
            if (type.IsDefined(typeof(TriggerAttribute), true))
            {
                if (typeof(IFurniTrigger).IsAssignableFrom(type))
                {
                    IEnumerable<TriggerAttribute> atts = type.GetCustomAttributes<TriggerAttribute>();
                    foreach (TriggerAttribute att in atts)
                    {
                        tableOfInteractors.Add(att.name, (IFurniTrigger)Activator.CreateInstance(type));
                        //ConsoleWriter.Writer.LogMessage("Trigger for type [" + att.name + "] loaded");
                    }
                }
                else
                {
                    throw new ModuleInitializationException("Interactor [" + type.GetTypeInfo().FullName + "] does not implement IInteractable");
                }
            }
            else if (typeof(IFurniTrigger).IsAssignableFrom(type) && !listOfIgnores.Contains(type))
            {
                throw new ModuleInitializationException("Found IFurniTrigger without attribute, maybe forgot to add attribute? [" + type.GetTypeInfo().FullName + "]");
            }
        }

        public static IFurniTrigger GetInteractable(InteractionType type)
        {
            return (IFurniTrigger)tableOfInteractors[type];
        }
    }
}
