﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms.Games;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers
{
    [TriggerAttribute(InteractionType.banzaiscoreblue)]
    [TriggerAttribute(InteractionType.banzaiscoregreen)]
    [TriggerAttribute(InteractionType.banzaiscorered)]
    [TriggerAttribute(InteractionType.banzaiscoreyellow)]
    class BanzaiScoreCounterTrigger : IFurniTrigger
    {
        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            return true;
        }
        void IFurniTrigger.OnPlace(GameClient Session, RoomItem Item)
        {
            if (Item.team == Team.none)
                return;

            Item.ExtraData = Item.GetRoom().GetGameManager().Points[(int)Item.team].ToString();
            Item.UpdateState(false, true);
        }
        void IFurniTrigger.OnRemove(GameClient Session, RoomItem Item) { }

        void IFurniTrigger.OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            if (!UserHasRights)
            {
                return;
            }


            Item.GetRoom().GetGameManager().Points[(int)Item.team] = 0;

            Item.ExtraData = "0";
            Item.UpdateState();
        }

        private static void UpdateTeamPoints(int points, Team team, RoomItem Item)
        {
            if (team == Team.none)
                return;

            Item.GetRoom().GetGameManager().Points[(int)Item.team] = points;
            Item.UpdateState();
        }
    }
}
