﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniInteractors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers
{
    [TriggerAttribute(InteractionType.gate)]
    internal class GateTrigger : IFurniTrigger
    {
        void IFurniTrigger.OnPlace(GameClient Session, RoomItem Item) { }
        void IFurniTrigger.OnRemove(GameClient Session, RoomItem Item) { }
        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            return true;
        }
        void IFurniTrigger.OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            int Modes = Item.GetBaseItem().Modes;
            if (Modes < 0)
                Modes = 0;

            if (!UserHasRights)
            {
                return;
            }

            if (Modes == 0)
            {
                Item.UpdateState(false, true);
            }

            int currentMode = 0;
            int newMode = 0;

            try
            {
                currentMode = int.Parse(Item.ExtraData);
            }
            catch {
            }

            if (currentMode <= 0)
            {
                newMode = 1;
            }
            else if (currentMode == 1)
            {
                newMode = 0;
            }
            else
            {
                newMode = currentMode + 1;
            }

            //if (newMode == 0)
            //{
            //    if (!Item.GetRoom().GetGameMap().itemCanBePlacedHere(Item.GetX, Item.GetY))
            //    {
            //        return;
            //    }
            //}

            Item.ExtraData = newMode.ToString();
            Item.UpdateState();
            Item.GetRoom().GetGameMap().updateMapForItem(Item);
        }
    }
}
