﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers
{

    [TriggerAttribute(InteractionType.floorswitch1)]
    [TriggerAttribute(InteractionType.floorswitch2)]
    class GenericStandNextToTriggerWithModes : IFurniTrigger
    {
        public static readonly GenericStandNextToTriggerWithModes defaultTrigger = new GenericStandNextToTriggerWithModes();
        void IFurniTrigger.OnPlace(GameClient Session, RoomItem Item) { }
        void IFurniTrigger.OnRemove(GameClient Session, RoomItem Item) { }
        
        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            RoomUser User = null;
            if (Session != null)
                User = Item.GetRoom().GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (User == null)
                return false;

            if (Gamemap.TilesTouching(Item.GetX, Item.GetY, User.X, User.Y))
            {
                return true;
            }
            return false;
        }
        void IFurniTrigger.OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            RoomUser User = null;
            if (Session != null)
                User = Item.GetRoom().GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (User == null)
                return;

            if (!Gamemap.TilesTouching(Item.GetX, Item.GetY, User.X, User.Y))
            {
                return;
            }

            int Modes = (Item.GetBaseItem().Modes - 1);

            if (Modes < 0)
            {
                Modes = 0;
            }

            if (Session != null)
                ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(Session, HabboHotel.Quests.QuestType.FURNI_SWITCH);
            if (!UserHasRights)
            {
                return;
            }

            if (Modes == 0)
            {
                return;
            }

            int currentMode = 0;
            int newMode = 0;

            try
            {
                currentMode = int.Parse(Item.ExtraData);
            }
            catch // (Exception e)
            {
                //Logging.HandleException(e, "InteractorGenericSwitch.OnTrigger");
            }

            if (currentMode <= 0)
            {
                newMode = 1;
            }
            else if (currentMode >= Modes)
            {
                newMode = 0;
            }
            else
            {
                newMode = currentMode + 1;
            }

            Item.ExtraData = newMode.ToString();
            Item.UpdateState();
        }
    }
}
