﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniInteractors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers
{
    [TriggerAttribute(InteractionType.groupClickable)]
    class GroupClickableTrigger : IFurniTrigger
    {
        void IFurniTrigger.OnPlace(GameClient Session, RoomItem Item) { }
        void IFurniTrigger.OnRemove(GameClient Session, RoomItem Item) { }
        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            return true;
        }
        void IFurniTrigger.OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            string[] extraData = Item.ExtraData.Split(':');
            int state = 0;
            if (extraData.Length > 1)
                state = TextHandling.ParseInt32(extraData[1]);
            state++;

            if (state > Item.GetBaseItem().Modes)
                state = 0;

            Item.ExtraData = extraData[0] + ':' + state;
            Item.UpdateState();
        }
    }
}
