﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers
{
    [TriggerAttribute(InteractionType.mannequin)]
    class MannequinTrigger : IFurniTrigger
    {
        void IFurniTrigger.OnPlace(GameClient Session, RoomItem Item) { }
        void IFurniTrigger.OnRemove(GameClient Session, RoomItem Item) { }
        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            return true;
        }
        void IFurniTrigger.OnTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            if (Item.ExtraData != string.Empty)
            {
                ServerMessage message;

                Session.GetHabbo().Look = Item.ExtraData + "." + TextHandling.GetHair(Session.GetHabbo().Look);
                
                message = PacketHandelingManager.GetRecycledItem(Outgoing.UpdateUserInformation);
                message.AddInt32(-1);
                message.AddString(Session.GetHabbo().Look);
                message.AddString(Session.GetHabbo().Gender.ToLower());
                message.AddString(Session.GetHabbo().Motto);
                message.AddInt32(Session.GetHabbo().AchievementPoints);
                Session.SendMessage(message);


                if (Session.GetHabbo().InRoom)
                {
                    Room Room = Session.GetHabbo().CurrentRoom;

                    if (Room == null)
                        return;

                    RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);

                    if (User == null)
                        return;

                    message = PacketHandelingManager.GetRecycledItem(Outgoing.UpdateUserInformation);
                    message.AddInt32(User.VirtualId);
                    message.AddString(Session.GetHabbo().Look);
                    message.AddString(Session.GetHabbo().Gender.ToLower());
                    message.AddString(Session.GetHabbo().Motto);
                    message.AddInt32(Session.GetHabbo().AchievementPoints);
                    Room.SendMessage(message);
                }
            }
        }
    }
}
