﻿using Butterfly.Messages;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Text;
namespace Butterfly.HabboHotel.Items
{
    class GiftData
    {
        internal string sendingUser;
        internal string message;
        internal int spriteID;
        internal int wrappingPaper;
        internal int decorationType;
        internal bool showUsername;
        private string look;

        private readonly Encoding ENCODING = Encoding.UTF8;

        public GiftData() { }
        public GiftData(string input)
        {
            byte[] body = ENCODING.GetBytes(input);
            int position = 0;

            showUsername = body[position++] == 1;
            uint userID = (uint)EncodingUtillity.ToInt32(body, ref position);

            sendingUser = ButterflyEnvironment.Game.GetClientManager().GetNameById(userID);
            wrappingPaper = EncodingUtillity.ToInt32(body, ref position);
            decorationType = EncodingUtillity.ToInt32(body, ref position);

            message = ENCODING.GetString(body, position, body.Length - position);
        }

        internal string SerializeExtraData(uint senderID)
        {
            byte[] data = new byte[13 + message.Length];
            int pos = 0;

            data[pos++] = showUsername ? (byte)1 : (byte)0;
            WriteUInt(senderID, data, ref pos);
            WriteInt(wrappingPaper, data, ref pos);
            WriteInt(decorationType, data, ref pos);

            for (int i = 0; i < message.Length; i++)
                data[pos++] = (byte)message[i];

            return ENCODING.GetString(data);
        }

        private void WriteInt(int value, byte[] data, ref int position)
        {
			data[position++] = (byte)(255 & (value >> 24));
			data[position++] = (byte)(255 & (value >> 16));
			data[position++] = (byte)(255 & (value >> 8));
			data[position++] = (byte)(255 & (value));
        }

        private void WriteUInt(uint value, byte[] data, ref int position)
        {
            data[position++] = (byte)(255 & (value >> 24));
            data[position++] = (byte)(255 & (value >> 16));
            data[position++] = (byte)(255 & (value >> 8));
            data[position++] = (byte)(255 & (value));
        }

        internal string GetUserLook()
        {
            if (look != null)
                return look;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT look FROM users WHERE username = @name");
                dbClient.addParameter("name", sendingUser);

                look = dbClient.getString();
            }

            return look;
        }
    }
}
