﻿using System;

namespace Butterfly.HabboHotel.Items
{
     internal enum InteractionType
    {
        none, //None == default
        gate,
        postit,
        roomeffect,
        dimmer,
        trophy,
        bed,
        scoreboard,
        vendingmachine,
        alert,
        onewaygate,
        loveshuffler,
        habbowheel,
        dice,
        bottle,
        teleport,
        rentals,
        pet,
        pool,
        roller,
        fbgate,
        pet0,
        pet1,
        pet2,
        pet3,
        pet4,
        pet5,
        pet6,
        pet7,
        pet8,
        pet9,
        pet10,
        pet11,
        pet12,
        pet13,
        pet14,
        pet15,
        pet16,
        pet17,
        pet18,
        pet19,
        pet20,
        pet21,
        pet22,
        iceskates,
        normslaskates,
        lowpool,
        haloweenpool,
        football,
        footballgoalgreen,
        footballgoalyellow,
        footballgoalblue,
        footballgoalred,
        footballcountergreen,
        footballcounteryellow,
        footballcounterblue,
        footballcounterred,
        banzaigateblue,
        banzaigatered,
        banzaigateyellow,
        banzaigategreen,
        banzaifloor,
        banzaiscoreblue,
        banzaiscorered,
        banzaiscoreyellow,
        banzaiscoregreen,
        banzaicounter,
        banzaitele,
        banzaipuck,
        banzaipyramid,
        freezetimer,
        freezeexit,
        freezeredcounter,
        freezebluecounter,
        freezeyellowcounter,
        freezegreencounter,
        freezeyellowgate,
        freezeredgate,
        freezegreengate,
        freezebluegate,
        freezetileblock,
        freezetile,
        jukebox,
        musicdisc,
        puzzlebox,


        //Wired:
        triggertimer,
        triggerroomenter,
        triggergameend,
        triggergamestart,
        triggerrepeater,
        triggeronusersay,
        triggerscoreachieved,
        triggerstatechanged,
        triggerwalkonfurni,
        triggerwalkofffurni,

        actiongivescore,
        actionposreset,
        actionmoverotate,
        actionresettimer,
        actionshowmessage,
        actionteleportto,
        actiontogglestate,

        conditionfurnishaveusers,
        conditionstatepos,
        conditiontimelessthan,
        conditiontimemorethan,
        conditiontriggeronfurni,
        conditionhasfurnionfurni,

        arrowplate,
        preassureplate,
        ringplate,
        colortile,
        colorwheel,
        floorswitch1,
        floorswitch2,
        firegate,
        glassfoor,

        specialrandom,
        specialunseen,

        wire,
        wireCenter,
        wireCorner,
        wireSplitter,
        wireStandard,
        levelupfloor,
        snowboard,
        mannequin,
        groupClickable,
        groupGate,
		bot
    }

    class InterractionTypes
    {
        internal static InteractionType GetTypeFromString(string pType)
        {
            switch (pType)
            {
                case "1":
                case "":
                case "Default":
                case "default":
                    return InteractionType.none;
                case "gate":
                    return InteractionType.gate;
                case "postit":
                    return InteractionType.postit;
                case "roomeffect":
                    return InteractionType.roomeffect;
                case "dimmer":
                    return InteractionType.dimmer;
                case "trophy":
                    return InteractionType.trophy;
                case "bed":
                    return InteractionType.bed;
                case "scoreboard":
                    return InteractionType.scoreboard;
                case "vendingmachine":
                    return InteractionType.vendingmachine;
                case "alert":
                    return InteractionType.alert;
                case "onewaygate":
                    return InteractionType.onewaygate;
                case "loveshuffler":
                    return InteractionType.loveshuffler;
                case "habbowheel":
                    return InteractionType.habbowheel;
                case "dice":
                    return InteractionType.dice;
                case "bottle":
                    return InteractionType.bottle;
                case "teleport":
                    return InteractionType.teleport;
                case "rentals":
                    return InteractionType.rentals;
                case "pet":
                    return InteractionType.pet;
                case "pool":
                    return InteractionType.pool;
                case "roller":
                    return InteractionType.roller;
                case "fbgate":
                    return InteractionType.fbgate;
                case "pet0":
                    return InteractionType.pet0;
                case "pet1":
                    return InteractionType.pet1;
                case "pet2":
                    return InteractionType.pet2;
                case "pet3":
                    return InteractionType.pet3;
                case "pet4":
                    return InteractionType.pet4;
                case "pet5":
                    return InteractionType.pet5;
                case "pet6":
                    return InteractionType.pet6;
                case "pet7":
                    return InteractionType.pet7;
                case "pet8":
                    return InteractionType.pet8;
                case "pet9":
                    return InteractionType.pet9;
                case "pet10":
                    return InteractionType.pet10;
                case "pet11":
                    return InteractionType.pet11;
                case "pet12":
                    return InteractionType.pet12;
                case "pet13":
                    return InteractionType.pet13;
                case "pet14":
                    return InteractionType.pet14;
                case "pet15":
                    return InteractionType.pet15;
                case "pet16":
                    return InteractionType.pet16;
                case "pet17":
                    return InteractionType.pet17;
                case "pet18":
                    return InteractionType.pet18;
                case "pet19":
                    return InteractionType.pet19;
                case "pet20":
                    return InteractionType.pet20;
                case "pet21":
                    return InteractionType.pet21;
                case "pet22":
                    return InteractionType.pet22;
                case "iceskates":
                    return InteractionType.iceskates;
                case "normalskates":
                    return InteractionType.normslaskates;
                case "lowpool":
                    return InteractionType.lowpool;
                case "haloweenpool":
                    return InteractionType.haloweenpool;
                case "football":
                    return InteractionType.football;

                case "footballgoalgreen":
                    return InteractionType.footballgoalgreen;
                case "footballgoalyellow":
                    return InteractionType.footballgoalyellow;
                case "footballgoalred":
                    return InteractionType.footballgoalred;
                case "footballgoalblue":
                    return InteractionType.footballgoalblue;

                case "footballcountergreen":
                    return InteractionType.footballcountergreen;
                case "footballcounteryellow":
                    return InteractionType.footballcounteryellow;
                case "footballcounterblue":
                    return InteractionType.footballcounterblue;
                case "footballcountered":
                    return InteractionType.footballcounterred;

                case "banzaigateblue":
                    return InteractionType.banzaigateblue;
                case "banzaigatered":
                    return InteractionType.banzaigatered;
                case "banzaigateyellow":
                    return InteractionType.banzaigateyellow;
                case "banzaigategreen":
                    return InteractionType.banzaigategreen;
                case "banzaifloor":
                    return InteractionType.banzaifloor;

                case "banzaiscoreblue":
                    return InteractionType.banzaiscoreblue;
                case "banzaiscorered":
                    return InteractionType.banzaiscorered;
                case "banzaiscoreyellow":
                    return InteractionType.banzaiscoreyellow;
                case "banzaiscoregreen":
                    return InteractionType.banzaiscoregreen;

                case "banzaicounter":
                    return InteractionType.banzaicounter;
                case "banzaitele":
                    return InteractionType.banzaitele;
                case "banzaipuck":
                    return InteractionType.banzaipuck;
                case "banzaipyramid":
                    return InteractionType.banzaipyramid;

                case "freezetimer":
                    return InteractionType.freezetimer;
                case "freezeexit":
                    return InteractionType.freezeexit;
                case "freezeredcounter":
                    return InteractionType.freezeredcounter;
                case "freezebluecounter":
                    return InteractionType.freezebluecounter;
                case "freezeyellowcounter":
                    return InteractionType.freezeyellowcounter;
                case "freezegreencounter":
                    return InteractionType.freezegreencounter;
                case "freezeyellowgate":
                    return InteractionType.freezeyellowgate;
                case "freezeredgate":
                    return InteractionType.freezeredgate;
                case "freezegreengate":
                    return InteractionType.freezegreengate;
                case "freezebluegate":
                    return InteractionType.freezebluegate;
                case "freezetileblock":
                    return InteractionType.freezetileblock;
                case "freezetile":
                    return InteractionType.freezetile;
                case "jukebox":
                    return InteractionType.jukebox;
                case "musicdisc":
                    return InteractionType.musicdisc;

                case "triggertimer":
                    return InteractionType.triggertimer;
                case "triggerroomenter":
                    return InteractionType.triggerroomenter;
                case "triggergameend":
                    return InteractionType.triggergameend;
                case "triggergamestart":
                    return InteractionType.triggergamestart;
                case "triggerrepeater":
                    return InteractionType.triggerrepeater;
                case "triggeronusersay":
                    return InteractionType.triggeronusersay;
                case "triggerscoreachieved":
                    return InteractionType.triggerscoreachieved;
                case "triggerstatechanged":
                    return InteractionType.triggerstatechanged;
                case "triggerwalkonfurni":
                    return InteractionType.triggerwalkonfurni;
                case "triggerwalkofffurni":
                    return InteractionType.triggerwalkofffurni;
                case "actiongivescore":
                    return InteractionType.actiongivescore;
                case "actionposreset":
                    return InteractionType.actionposreset;
                case "actionmoverotate":
                    return InteractionType.actionmoverotate;
                case "actionresettimer":
                    return InteractionType.actionresettimer;
                case "actionshowmessage":
                    return InteractionType.actionshowmessage;
                case "actionteleportto":
                    return InteractionType.actionteleportto;
                case "actiontogglestate":
                    return InteractionType.actiontogglestate;
                case "conditionfurnishaveusers":
                    return InteractionType.conditionfurnishaveusers;
                case "conditionstatepos":
                    return InteractionType.conditionstatepos;
                case "conditionhasfurnionfurni":
                    return InteractionType.conditionhasfurnionfurni;

                case "conditiontimelessthan":
                    return InteractionType.conditiontimelessthan;
                case "conditiontimemorethan":
                    return InteractionType.conditiontimemorethan;
                case "conditiontriggeronfurni":
                    return InteractionType.conditiontriggeronfurni;
                case "arrowplate":
                    return InteractionType.arrowplate;
                case "preassureplate":
                    return InteractionType.preassureplate;
                case "ringplate":
                    return InteractionType.ringplate;
                case "colortile":
                    return InteractionType.colortile;
                case "colorwheel":
                    return InteractionType.colorwheel;
                case "floorswitch1":
                    return InteractionType.floorswitch1;
                case "floorswitch2":
                    return InteractionType.floorswitch2;
                case "firegate":
                    return InteractionType.firegate;
                case "glassfoor":
                    return InteractionType.glassfoor;
                case "specialrandom":
                    return InteractionType.specialrandom;
                case "specialunseen":
                    return InteractionType.specialunseen;
                case "wire":
                    return InteractionType.wire;
                case "wireCenter":
                    return InteractionType.wireCenter;
                case "wireCorner":
                    return InteractionType.wireCorner;
                case "wireSplitter":
                    return InteractionType.wireSplitter;
                case "wireStandard":
                    return InteractionType.wireStandard;
                case "puzzlebox":
                    return InteractionType.puzzlebox;
                case "levelupfloor":
                    return InteractionType.levelupfloor;
                case "snowboard":
                    return InteractionType.snowboard;
				case "bot":
					return InteractionType.bot;
                case "mannequin":
                    return InteractionType.mannequin;
                case "groupClickable":
                    return InteractionType.groupClickable;
                case "groupGate":
                    return InteractionType.groupGate;

                default:
                    {
                        //Console.WriteLine("Unknown interaction type in parse code: " + pType);
                        return InteractionType.none;
                    }
            }
        }
    }
}
