﻿using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Effects;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired.Action
{
    [TriggerAttribute(InteractionType.actionposreset)]
    class ActionPositionResetWired : BaseWiredInteractor
    {
        protected override void DoTrigger(GameClients.GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.WiredFurniActionEvent);

            if (Item.wiredHandler != null)
            {
                PositionReset handler = (PositionReset)Item.wiredHandler;
                message.AddBoolean(false);
                message.AddInt32(MAX_FURNI_SELECTION);
                message.AddInt32(handler.items.Count);
                foreach (RoomItem item in handler.items)
                {
                    message.AddInt32((int)item.Id);
                }
                message.AddInt32(Item.GetBaseItem().SpriteId);
                message.AddUInt32(Item.Id);


                message.AddString(string.Empty);
                message.AddInt32(0);
                message.AddInt32(8);
                message.AddInt32(0);
                message.AddInt32(handler.delay); //Timeout
                message.AddInt32(0); //Incompatible shit
                message.AddString(string.Empty);
            }
            else
            {

                PositionReset handler = (PositionReset)Item.wiredHandler;
                message.AddBoolean(false);
                message.AddInt32(MAX_FURNI_SELECTION);
                message.AddInt32(0);
                message.AddInt32(Item.GetBaseItem().SpriteId);
                message.AddUInt32(Item.Id);

                message.AddString(string.Empty);
                message.AddInt32(0); //Furni count
                message.AddInt32(8);
                message.AddInt32(0);
                message.AddInt32(0); //Timeout
                message.AddInt32(0);
                message.AddString(string.Empty);
            }

            Session.SendMessage(message);
        }
    }
}
