﻿using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Effects;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired.Action
{
    [TriggerAttribute(InteractionType.actionresettimer)]
    class ActionTimerResetWired : BaseWiredInteractor
    {
        protected override void DoTrigger(GameClients.GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.WiredFurniActionEvent);
            TimerReset handler = null;

            message.AddBoolean(false);
            message.AddInt32(BaseWiredInteractor.MAX_FURNI_SELECTION);

            if (Item.wiredHandler != null && (handler = ((TimerReset)Item.wiredHandler)) != null)
            {
                message.AddInt32(handler.items.Count);
                foreach (RoomItem item in handler.items)
                    message.AddInt32((int)item.Id);
            }
            else
            {
                message.AddInt32(0);
            }

            message.AddInt32(Item.GetBaseItem().SpriteId);
            message.AddUInt32(Item.Id);

            message.AddString(string.Empty);
            message.AddInt32(1);
            message.AddInt32(0);
            message.AddInt32(0);

            message.AddInt32(0);
            message.AddInt32(handler != null ? handler.delay : 0);


            message.AddInt32(0);

            message.AddInt32(0);
            message.AddString(string.Empty);

            Session.SendMessage(message);
            /*
             * 
 message.AddBoolean(false);
            message.AddInt32(BaseWiredInteractor.MAX_FURNI_SELECTION);

            //if (Item.wiredHandler != null && (handler = ((ToggleItemState)Item.wiredHandler)) != null)
            //{
            //    message.AddInt32(handler.items.Count);
            //    foreach (RoomItem item in handler.items)
            //        message.AddInt32((int)item.Id);
            //}
            //else
            {
                message.AddInt32(0);
                message.AddInt32(0);
            }

            message.AddInt32(Item.GetBaseItem().SpriteId);
            message.AddUInt32(Item.Id);

            message.AddString(string.Empty);
            message.AddInt32(1);
            message.AddInt32(0);
            message.AddInt32(0);

            message.AddInt32(0);
            message.AddInt32(handler != null ? handler.delay : 0);


            message.AddInt32(0);

            message.AddInt32(0);
            message.AddString(string.Empty);

            Session.SendMessage(message);
                        
             */
        }
    }
}
