﻿using Butterfly.HabboHotel.GameClients;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired
{

    abstract class BaseWiredInteractor : IFurniTrigger
    {
        public static readonly int MAX_FURNI_SELECTION = 10;

        public void OnPlace(GameClients.GameClient Session, RoomItem Item)
        {
        }

        public void OnRemove(GameClients.GameClient Session, RoomItem Item)
        {
        }

        public void OnTrigger(GameClients.GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            if (Session == null || Item == null)
                return;

            if (!UserHasRights)
                return;
            this.DoTrigger(Session, Item, Request, UserHasRights);
        }

        protected abstract void DoTrigger(GameClient Session, RoomItem Item, int Request, bool UserHasRights);


        public bool CanBeTriggered(GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            return true;
        }
    }
}
