﻿using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Triggers;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired.Trigger
{
    [TriggerAttribute(InteractionType.triggeronusersay)]
    class OnUserSayTriggerWired  : BaseWiredInteractor
    {
        protected override void DoTrigger(GameClients.GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.WiredFurniTriggerEvent);
            message.AddBoolean(false);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddInt32(Item.GetBaseItem().SpriteId);
            message.AddUInt32(Item.Id);

            if (Item.wiredHandler != null)
            {
                UserSays trigger = (UserSays)Item.wiredHandler;
                message.AddString(trigger.triggerMessage);
            }
            else
            {
                message.AddString(string.Empty);  // What is said
            }

            message.AddInt32(1);
            if (Item.wiredHandler != null && Item.wiredHandler as UserSays != null)
            {
                UserSays says = (Item.wiredHandler as UserSays);
                message.AddInt32(says.IsOwnerOnly ? 1 : 0);
            }
            else
            {
                message.AddInt32(0);
            }
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddString(string.Empty);


            Session.SendMessage(message);
        }
    }
}
