﻿using Butterfly.HabboHotel.Items.FurniInteractors;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Triggers;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Butterfly.HabboHotel.Items.FurniTriggers.Triggers.Wired.Trigger
{
    [TriggerAttribute(InteractionType.triggertimer)]
    class TimerTriggerWired : BaseWiredInteractor
    {
        protected override void DoTrigger(GameClients.GameClient Session, RoomItem Item, int Request, bool UserHasRights)
        {
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.WiredFurniTriggerEvent);
            if (Item.wiredHandler != null)
            {
                Timer handler = (Timer)Item.wiredHandler;


                message.AddBoolean(false);
                message.AddInt32(5);
                message.AddInt32(0);
                message.AddInt32(Item.GetBaseItem().SpriteId);
                message.AddUInt32(Item.Id);

                message.AddString(string.Empty);
                message.AddInt32(1);
                message.AddInt32(handler.requiredCycles);
                message.AddInt32(0);
                message.AddInt32(3);
                message.AddInt32(0);
                message.AddString(string.Empty);
            }
            else
            {
                message.AddBoolean(false);
                message.AddInt32(5);
                message.AddInt32(0);
                message.AddInt32(Item.GetBaseItem().SpriteId);
                message.AddUInt32(Item.Id);

                message.AddString(string.Empty);
                message.AddInt32(1);
                message.AddInt32(0);
                message.AddInt32(1);
                message.AddInt32(3);
                message.AddInt32(0);
                message.AddString(string.Empty);
            }

            Session.SendMessage(message);
                        
        }
    }
}
