﻿using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Items.FurniTriggers.Triggers;
using Butterfly.HabboHotel.Rooms.Games;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Interfaces;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Effects
{
    class ShowMessage : IWiredTrigger, IWiredEffect , IWiredSettingsTrigger
    {
        private WiredHandler handler;
        private RoomItem item;
        
        internal string message;

        public ShowMessage(string message, WiredHandler handler, RoomItem item)
        {
            this.item = item;
            this.handler = handler;
            this.message = message;
        }

        public bool Handle(RoomUser user, Team team, RoomItem item)
        {
            if (user != null && !user.IsBot && user.GetClient() != null)
            {
                GenericTriggerWithModes.DoAnimation(this.item);
                ServerMessage servermsg = PacketHandelingManager.GetRecycledItem(OutputCode.WhisperMessageEvent);
                servermsg.AddInt32(user.VirtualId);
                servermsg.AddString(message);

                servermsg.AddInt32(0);
                servermsg.AddInt32(0);
                servermsg.AddInt32(0);
                servermsg.AddInt32(-1);

                user.GetClient().SendMessage(servermsg);
                handler.OnEvent(this.item.Id);
                return true;
            }
            else if (user == null)
            {
                return false;
                // ServerBroadcaster
                /*ServerMessage servermsg = PacketHandelingManager.GetRecycledItem(OutputCode.ChatMessageEvent);
                servermsg.AddInt32(-1);
                servermsg.AddString(message);

                servermsg.AddInt32(0);
                servermsg.AddInt32(1);
                servermsg.AddInt32(0);
                servermsg.AddInt32(-1);
                Room r = item.GetRoom();
                r.QueueRoomMessage(servermsg);*/
            }
            return false;
        }

        public void Dispose()
        {
            message = null;
            handler = null;
        }

        public bool IsSpecial(out SpecialEffects function)
        {
            function = SpecialEffects.None;
            return false;
        }

        public bool WiredConditionsMet(RoomUser user, Room theRoom)
        {
            if (handler.conditionHandler != null)
            {
                return handler.conditionHandler.AllowsHandling(item.GetX, item.GetY, user, theRoom);
            }
            return true;
        }

        public string[] GetSettings()
        {
            return new string[] { this.message };
        }


        public void LoadFromWiredObject(WiredLoader.WiredLoaderObject loadedData)
        {
            this.message = loadedData.StringSettings[0];
        }

        public RoomItem GetOriginalWiredItem()
        {
            return item;
        }
    }
}
