﻿using System.Collections.Generic;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.WiredLoader;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.HabboHotel.Rooms.Wired.WiredHandlers.Interfaces
{
    interface IWiredTrigger
    {
        void Dispose();
        void LoadFromWiredObject(WiredLoaderObject loadedData);
        RoomItem GetOriginalWiredItem();
        bool WiredConditionsMet(RoomUser userRef, Room theRoom);
        
    }
    interface IWiredSettingsTrigger
    {
        string[] GetSettings();
    }

    interface IWiredFurniTrigger : IWiredTrigger
    {
        List<RoomItem> getAffectedItemList();
        bool onItemRemove(RoomItem item);
    }

    interface IWiredOriginalItemTrigger : IWiredFurniTrigger
    {
        Dictionary<uint, OriginalItemLocation> GetOriginalItemLocation();
    }
}
