﻿using System;
using System.Threading;
using Butterfly.Core;
using Butterfly.Net;
using System.Text;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Diagnostics;

namespace Butterfly.HabboHotel.Misc
{
    internal class LowPriorityWorker
    {
        private static int UserPeak;
        private static bool isExecuted = false;

        private static string FormatToBytes(int Num)
        {
            if (Num < 1024)
                return Num + "B/s";
            else if (Num < 1048576) //KB/s
            {
                double Traffic = Num / 1024;
                return String.Format("{0:0.##}", Traffic) + "KB/s";
            }
            else //MB/s
            {
                double Traffic = Num / 1048576;
                return String.Format("{0:0.##}", Traffic) + "MB/s";
            }
        }

        private static string mColdTitle;
        private static Stopwatch consoleTitleWorkerWatch;
        internal static void ConsoleTitleWorker()
        {
			//if (consoleTitleWorkerWatch.ElapsedMilliseconds >= 1000)
			//{
			//	consoleTitleWorkerWatch.Restart();
			//	try
			//	{
			//		//int TotalBytesSent = TcpConnection.GetNumberOfSentBytes();
			//		//int TotalBytesReceived = TcpConnection.GetNumberOfReceivedBytes();

			//		Console.Title = mColdTitle;//+ "In: " + FormatToBytes(TotalBytesReceived) + " Out: " + FormatToBytes(TotalBytesSent);
			//	}
			//	catch (Exception Exception)
			//	{
			//		Logging.LogThreadException(Exception.ToString(), "ConsoleTitleWorker");
			//	}
			//}
        }

        internal static void Init(IQueryAdapter dbClient)
        {
            dbClient.setQuery("SELECT userpeak FROM server_status");
            UserPeak = dbClient.getInteger();
            mColdTitle = string.Empty;

            lowPriorityProcessWatch = new Stopwatch();
            consoleTitleWorkerWatch = new Stopwatch();
            lowPriorityProcessWatch.Start();
            consoleTitleWorkerWatch.Start();
            Process();
        }


        private static Stopwatch lowPriorityProcessWatch;
        internal static void Process()
		{
            if (lowPriorityProcessWatch.ElapsedMilliseconds >= 30000 || !isExecuted)
            {
                isExecuted = true;
                lowPriorityProcessWatch.Restart();
                try
                {
                    //TimeSpan Uptime = DateTime.Now - ButterflyEnvironment.ServerStarted;
					//string addOn = string.Empty;
					//if (ButterflyEnvironment.isDebugging)
					//	addOn = "[DEBUG] ";
                    
					//mColdTitle = addOn + "Butterfly | Uptime: " + Uptime.Days + " day " + Uptime.Hours + " hours " + Uptime.Minutes + " minutes | " +
					//	"Online users: " + ButterflyEnvironment.Game.GetClientManager().ClientCount + " | Loaded rooms: " + ButterflyEnvironment.Game.GetRoomManager().LoadedRoomsCount;

                    #region Garbage Collection
                    //GC.Collect();
                    //GC.WaitForPendingFinalizers();
                    #endregion

                    #region Statistics
                    int Status = 1;
                    int UsersOnline = ButterflyEnvironment.Game.GetClientManager().ClientCount;

                    if (UsersOnline > UserPeak)
                        UserPeak = UsersOnline;

                    int RoomsLoaded = ButterflyEnvironment.Game.GetRoomManager().LoadedRoomsCount;

                    using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                    {
                        dbClient.runFastQuery("UPDATE server_status SET stamp = '" + TextHandling.GetUnixTimestamp() + "', status = " + Status + ", users_online = " + UsersOnline + ", rooms_loaded = " + RoomsLoaded + ", server_ver = '" + ButterflyEnvironment.VersionString + "', userpeak = " + UserPeak + "");
                    }
                    #endregion
                }
                catch (Exception e) { Logging.LogThreadException(e.ToString(), "Server status update task"); }
            }
        }
    }
}