﻿using System.Collections;
using System.Data;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Collections.Generic;

namespace Butterfly.HabboHotel.Pets
{
    class PetRaceHandler
    {
        private static Hashtable raceRegister;

        internal static void Initialize(IQueryAdapter dbClient)
        {
            DataTable dTable;
            dbClient.setQuery("SELECT * FROM pet_races");
            dTable = dbClient.getTable();

            raceRegister = new Hashtable();

            int raceID;
            int colorPrimary;
            int colorSecondary;
            bool hasPrimaryColor;
            bool hasSecondaryColor;

            foreach (DataRow dRow in dTable.Rows)
            {
                raceID = (int)dRow[0];
                colorPrimary = (int)dRow[1];
                colorSecondary = (int)dRow[2];
                hasPrimaryColor = ((int)dRow[3] == 1);
                hasSecondaryColor = ((int)dRow[4] == 1);

                PetRace race = new PetRace(raceID, colorPrimary, colorSecondary, hasPrimaryColor, hasSecondaryColor);

                if (raceRegister.ContainsKey(raceID))
                {
                    List<PetRace> races = (List<PetRace>)raceRegister[raceID];
                    races.Add(race);
                }
                else
                {
                    List<PetRace> races = new List<PetRace>();
                    races.Add(race);
                    raceRegister.Add(raceID, races);
                }
            }
        }

        internal static bool TryGetPetRace(int raceID, out List<PetRace> races)
        {
            if (raceRegister.ContainsKey(raceID))
            {
                races = (List<PetRace>)raceRegister[raceID];
                return true;
            }
            else
            {
                races = null;
                return false;
            }
        }
    }
}
