﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using Butterfly.Collections;
using Butterfly.Core;
using Butterfly.HabboHotel.ChatMessageStorage;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Rooms.RoomIvokedItems;
using Butterfly.Messages;
using Database_Manager.Database.Session_Details.Interfaces;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Support
{
    public class ModerationTool
    {
        #region General

        internal List<SupportTicket> Tickets;

        internal List<string> UserMessagePresets;
        internal List<string> RoomMessagePresets;

        internal ModerationTool()
        {
            Tickets = new List<SupportTicket>();
            UserMessagePresets = new List<string>();
            RoomMessagePresets = new List<string>();
        }

        internal ServerMessage SerializeTool()
        {

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.ModeratorInitMessageEvent);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddInt32(0);

            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);

            message.AddInt32(0);

            
            /*
             * 
            message.AddInt32(this.UserMessagePresets.Count);
            foreach (string str in this.UserMessagePresets)
            {
                message.AddString(str);
            }
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddInt32(this.RoomMessagePresets.Count);
            foreach (string str in this.RoomMessagePresets)
            {
                message.AddString(str);
            }

            /*message.AddInt32(-1);

            message.AddInt32(UserMessagePresets.Count);
            foreach (String Preset in UserMessagePresets)
            {
                message.AddString(Preset);
            }
            message.AddInt32(6); //Mod Actions Count

            message.AddString("Room Problems"); // modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Door Problem"); // mod action Cata
            message.AddString("Stop blocking the doors Please"); // Msg
            message.AddString("Ban-Problem"); // Mod Action Cata
            message.AddString("This your last warning or you received a ban"); // Msg
            message.AddString("Help Support");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Bobba Filter"); // Mod Cata
            message.AddString("Please stop Playing with the Bobba Filter"); // Msg
            message.AddString("Kick user"); // Mod Cata
            message.AddString("Please stop Kicking people without a Reason"); // Msg
            message.AddString("Ban Room"); // Mod Cata
            message.AddString("Please stop banning people without a good reason"); // Msg
            message.AddString("RoomName"); // Mod Cata
            message.AddString("Please Change your RoomName otherwish we will do it."); // Msg
            message.AddString("PH box"); // Mod Cata
            message.AddString("Please Contact A administrator about your problem"); // Msg

            message.AddString("Player Support");// modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Player Bug"); // mod action Cata
            message.AddString("Thank you for supporting us and reporting this bug"); // Msg
            message.AddString("Login Problem"); // Mod Action Cata
            message.AddString("We contact to the player support and will work on your problem"); // Msg
            message.AddString("Help Support");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Call for help Filter"); // Mod Cata
            message.AddString("Please stop Playing with the CFH Filter"); // Msg
            message.AddString("Privacy"); // Mod Cata
            message.AddString("You should not give your privacy stuff away."); // Msg
            message.AddString("Warning Swf."); // Mod Cata
            message.AddString("Please Contact a administrator/moderator."); // Msg
            message.AddString("Cache"); // Mod Cata
            message.AddString("if you got problems with memmory Please report it"); // Msg
            message.AddString("Temp Problem"); // Mod Cata
            message.AddString("Delete your temp!"); // Msg

            message.AddString("Users Problems");// modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Scamming"); // mod action Cata
            message.AddString("We will Check the problem for you now can you give us more infomation about what's happens"); // Msg
            message.AddString("Trading Scam"); // Mod Action Cata
            message.AddString("What happens and how happens please explain us"); // Msg
            message.AddString("Disconnection");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Room blocking"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Freezing"); // Mod Cata
            message.AddString("Can explain us what happens?"); // Msg
            message.AddString("Error page"); // Mod Cata
            message.AddString("What was the code from your error Example 404"); // Msg
            message.AddString("Can't login"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Updates"); // Mod Cata
            message.AddString("We always do our best to update everything"); // Msg

            message.AddString("Debug Problems");// modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Lag"); // mod action Cata
            message.AddString("We will Check the problem for you now can you give us more infomation about what's happens"); // Msg
            message.AddString("Disconnection"); // Mod Action Cata
            message.AddString("What happens and how happens please explain us"); // Msg
            message.AddString("SSO problem");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Char Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("System check"); // Mod Cata
            message.AddString("We already checking every debug stuff"); // Msg
            message.AddString("Error from WireEncoding"); // Mod Cata
            message.AddString("Can you say explain us what happens"); // Msg
            message.AddString("Error from BASE64"); // Mod Cata
            message.AddString("Can you explain us what happens"); // Msg
            message.AddString("Error from Flash player"); // Mod Cata
            message.AddString("Can you explain us what happens"); // Msg

            message.AddString("System Problems");// modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Version"); // mod action Cata
            message.AddString("Ask a Administrator For more Information"); // Msg
            message.AddString("Swf Version?"); // Mod Action Cata
            message.AddString("Currenly We use the same version like Habbo.com"); // Msg
            message.AddString("Freeze");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Name Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Nickname Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("System Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Cursing Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Update Filter"); // Mod Cata
            message.AddString("We will update your words in the filter Thanks for report."); // Msg

            message.AddString("Swf Problems");// modaction Cata
            message.AddInt32(8); // ModAction Count
            message.AddString("Version"); // mod action Cata
            message.AddString("Ask a Administrator For more Information"); // Msg
            message.AddString("Swf Version?"); // Mod Action Cata
            message.AddString("Currenly We use the same version like Habbo.com"); // Msg
            message.AddString("Freeze");// Mod Action Cata
            message.AddString("Please Contact The Player Support For this problem"); // Msg
            message.AddString("Name Filter"); // Mod Cata
            message.AddString("Can you say The usersname and explain us what happens"); // Msg
            message.AddString("Crash on loading"); // Mod Cata
            message.AddString("Can you explain us what happens"); // Msg
            message.AddString("Crash on login"); // Mod Cata
            message.AddString("Can you say the usersname and explain us what happens"); // Msg
            message.AddString("Crash in room"); // Mod Cata
            message.AddString("Can you say the usersname and explain us what happens"); // Msg
            message.AddString("Website error"); // Mod Cata
            message.AddString("Can you say the usersname and explain us what happens"); // Msg

            message.AddBoolean(true); // ticket_queue fuse
            message.AddBoolean(true); // chatlog fuse
            message.AddBoolean(true); // message / caution fuse
            message.AddBoolean(true); // kick fuse
            message.AddBoolean(true); // band fuse
            message.AddBoolean(true); // broadcastshit fuse
            message.AddBoolean(true); // other shit fuse

            message.AddInt32(RoomMessagePresets.Count);
            foreach (String Preset in RoomMessagePresets)
            {
                message.AddString(Preset);
            }
            message.AddInt32(0); // undef
            message.AddString(""); // undef
            message.AddString(""); // undef
            message.AddInt32(0); // count of actions
            */
            return message;
        }

        #endregion

        #region Message Presets

        internal void LoadMessagePresets(IQueryAdapter dbClient)
        {
            UserMessagePresets.Clear();
            RoomMessagePresets.Clear();

            dbClient.setQuery("SELECT type,message FROM moderation_presets WHERE enabled = 2");
            DataTable Data = dbClient.getTable();

            if (Data == null)
                return;

            foreach (DataRow Row in Data.Rows)
            {
                String Message = (String)Row["message"];

                switch (Row["type"].ToString().ToLower())
                {
                    case "message":

                        UserMessagePresets.Add(Message);
                        break;

                    case "roommessage":

                        RoomMessagePresets.Add(Message);
                        break;
                }
            }
        }

        #endregion

        #region Support Tickets

        internal void LoadPendingTickets(IQueryAdapter dbClient)
        {
            dbClient.runFastQuery("TRUNCATE TABLE moderation_tickets");
            //dbClient.setQuery("SELECT moderation_tickets.*, p1.username AS sender_username, p2.username AS reported_username, p3.username AS moderator_username FROM moderation_tickets LEFT OUTER JOIN users AS p1 ON moderation_tickets.sender_id = p1.id LEFT OUTER JOIN users AS p2 ON moderation_tickets.reported_id = p2.id LEFT OUTER JOIN users AS p3 ON moderation_tickets.moderator_id = p3.id WHERE moderation_tickets.status != 'resolved'");
            //DataTable Data = dbClient.getTable();

            //if (Data == null)
            //{
            //    return;
            //}

            //foreach (DataRow Row in Data.Rows)
            //{
            //    SupportTicket Ticket = new SupportTicket(Convert.ToUInt32(Row["id"]), (int)Row["score"], (int)Row["type"], Convert.ToUInt32(Row["sender_id"]), Convert.ToUInt32(Row["reported_id"]), (String)Row["message"], Convert.ToUInt32(Row["room_id"]), (String)Row["room_name"], (Double)Row["timestamp"], Row["sender_username"], Row["reported_username"], Row["moderator_username"]);

            //    if (Row["status"].ToString().ToLower() == "picked")
            //    {
            //        Ticket.Pick(Convert.ToUInt32(Row["moderator_id"]), false);
            //    }

            //    Tickets.Add(Ticket);
            //}
        }

        internal void CloseAllTickets()
        {
            foreach (SupportTicket ticket in Tickets)
            {
                if (ticket.Status == TicketStatus.OPEN)
                {
                    ticket.Close(TicketStatus.DELETED, true);
                    SendTicketToModerators(ticket);
                }
            }
        }

        internal void SendNewTicket(GameClient Session, int Category, uint ReportedUser, String Message)
        {
            RoomData Data = ButterflyEnvironment.Game.GetRoomManager().GenerateNullableRoomData(Session.GetHabbo().CurrentRoomId);

            uint TicketId = 0;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
				//if (dbClient.dbType == Database_Manager.Database.DatabaseType.MSSQL)
				//	dbClient.setQuery("INSERT INTO moderation_tickets (score,type,status,sender_id,reported_id,moderator_id,message,room_id,room_name,timestamp) OUTPUT INSERTED.* VALUES (1,'" + Category + "','open','" + Session.GetHabbo().Id + "','" + ReportedUser + "','0',@message,'" + Data.Id + "',@name,'" + TextHandling.GetUnixTimestamp() + "')");
				//else
                dbClient.setQuery("INSERT INTO moderation_tickets (score,type,status,sender_id,reported_id,moderator_id,message,room_id,room_name,timestamp) VALUES (1,'" + Category + "','open','" + Session.GetHabbo().Id + "','" + ReportedUser + "','0',@message,'" + Data.Id + "',@name,'" + TextHandling.GetUnixTimestamp() + "')");
                dbClient.addParameter("message", Message);
                dbClient.addParameter("name", Data.Name);
                TicketId = (uint)dbClient.insertQuery();

                dbClient.runFastQuery("UPDATE user_info SET cfhs = cfhs + 1 WHERE user_id = " + Session.GetHabbo().Id + "");

                //dbClient.setQuery("SELECT id FROM moderation_tickets WHERE sender_id = " + Session.GetHabbo().Id + " ORDER BY id DESC LIMIT 1");
                //TicketId = (uint)dbClient.getRow()[0];
            }

            SupportTicket Ticket = new SupportTicket(TicketId, 1, Category, Session.GetHabbo().Id, ReportedUser, Message, Data.Id, Data.Name, TextHandling.GetUnixTimestamp());

            Tickets.Add(Ticket);

            SendTicketToModerators(Ticket);
        }

        internal void SerializeOpenTickets(GameClient client, uint userID)
        {
            foreach (SupportTicket ticket in Tickets)
            {
                if (ticket.Status == TicketStatus.OPEN || (ticket.Status == TicketStatus.PICKED && ticket.ModeratorId == userID))
                    client.SendMessage(ticket.Serialize());
            }
        }

        internal SupportTicket GetTicket(uint TicketId)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.TicketId == TicketId)
                {
                    return Ticket;
                }
            }
            return null;
        }

        internal void PickTicket(GameClient Session, uint TicketId)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.OPEN)
            {
                return;
            }

            Ticket.Pick(Session.GetHabbo().Id, true);
            SendTicketToModerators(Ticket);
        }

        internal void ReleaseTicket(GameClient Session, uint TicketId)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.PICKED || Ticket.ModeratorId != Session.GetHabbo().Id)
            {
                return;
            }

            Ticket.Release(true);
            SendTicketToModerators(Ticket);
        }

        internal void CloseTicket(GameClient Session, uint TicketId, int Result)
        {
            SupportTicket Ticket = GetTicket(TicketId);

            if (Ticket == null || Ticket.Status != TicketStatus.PICKED || Ticket.ModeratorId != Session.GetHabbo().Id)
            {
                return;
            }

            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(Ticket.SenderId);

            TicketStatus NewStatus;
            int ResultCode;

            switch (Result)
            {
                case 1:

                    ResultCode = 1;
                    NewStatus = TicketStatus.INVALID;
                    break;

                case 2:

                    ResultCode = 2;
                    NewStatus = TicketStatus.ABUSIVE;

                    using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                    {
                        dbClient.runFastQuery("UPDATE user_info SET cfhs_abusive = cfhs_abusive + 1 WHERE user_id = " + Ticket.SenderId + "");
                    }

                    break;

                case 3:
                default:

                    ResultCode = 0;
                    NewStatus = TicketStatus.RESOLVED;
                    break;
            }

            if (Client != null)
            {
                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.IssueCloseNotificationMessageEvent);
                message.AddInt32(ResultCode);
                Client.SendMessage(message); 
            }

            Ticket.Close(NewStatus, true);
            SendTicketToModerators(Ticket);
        }

        internal Boolean UsersHasPendingTicket(UInt32 Id)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.SenderId == Id && Ticket.Status == TicketStatus.OPEN)
                {
                    return true;
                }
            }
            return false;
        }

        internal void DeletePendingTicketForUser(UInt32 Id)
        {
            foreach (SupportTicket Ticket in Tickets)
            {
                if (Ticket.SenderId == Id)
                {
                    Ticket.Delete(true);
                    SendTicketToModerators(Ticket);
                    return;
                }
            }
        }

        internal static void SendTicketToModerators(SupportTicket Ticket)
        {
            ButterflyEnvironment.Game.GetClientManager().QueueBroadcaseMessage(Ticket.Serialize(), "fuse_mod");
        }

        internal void LogStaffEntry(string modName, string target, string type, string description)
        {
            LogStaffEntry(modName, target, type, description, null);
        }
        internal void LogStaffEntry(string modName, string target, string type, string description, string extraData)
        {
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("INSERT INTO staff_log (staffuser,target,action_type,description,extra_info) VALUES (@username,@target,@type,@desc,@extra)");
                dbClient.addParameter("username", modName);
                dbClient.addParameter("target", target);
                dbClient.addParameter("type", type);
                dbClient.addParameter("desc", description);
                dbClient.addParameter("extra", description);
                dbClient.runQuery();
            }
        }
        #endregion

        #region Room Moderation

        internal static void PerformRoomAction(GameClient ModSession, uint RoomId, Boolean KickUsers, Boolean LockRoom, Boolean InappropriateRoom)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(RoomId);

            if (Room == null)
            {
                return;
            }

            if (LockRoom)
            {
                Room.State = 1;
                Room.RoomData.State = 1;

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE rooms SET state = 'locked' WHERE id = " + Room.RoomId);
                }
                Room.RoomData.Name = LanguageLocale.GetValue("moderation.room.roomclosed");
            }

            if (InappropriateRoom)
            {
                Room.RoomData.Name = LanguageLocale.GetValue("moderation.room.roomclosed");
                Room.RoomData.Description = LanguageLocale.GetValue("moderation.room.roomclosed");
                Room.Name = LanguageLocale.GetValue("moderation.room.roomclosed");
                Room.Description = LanguageLocale.GetValue("moderation.room.roomclosed");
                Room.ClearTags();
                Room.RoomData.Tags.Clear();

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE rooms SET caption = 'Inappropriate to Hotel Management', description = 'Inappropriate to Hotel Management', tags = '' WHERE id = " + Room.RoomId + "");
                }
            }

            if (KickUsers)
            {
                onCycleDoneDelegate kick = new onCycleDoneDelegate(Room.onRoomKick);
                Room.GetRoomUserManager().UserList.QueueDelegate(kick);
            }
        }


        internal static void RoomAlert(uint RoomId, Boolean Caution, String Message)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(RoomId);

            if (Room == null || Message.Length <= 1)
            {
                return;
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.HabboBroadcastMessageEvent);
            message.AddString(Message);

            Room.SendMessage(message);
        }

        internal static ServerMessage SerializeRoomTool(RoomData Data)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(Data.Id);
            UInt32 OwnerId = 0;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                try
                {
                    dbClient.setQuery("SELECT id FROM users WHERE username = @owner");
                    dbClient.addParameter("owner", Data.Owner);
                    OwnerId = Convert.ToUInt32(dbClient.getRow()[0]);
                }
                catch (Exception e)
                {
                    Logging.HandleException(e, "ModerationTool.SerializeRoomTool");
                }
            }

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.ModeratorRoomInfoEvent);
            Message.AddUInt32(Data.Id);
            Message.AddInt32(Data.UsersNow); // user count

            if (Room != null)
            {
                Message.AddBoolean((Room.GetRoomUserManager().GetRoomUserByHabbo(Data.Owner) != null));
            }
            else
            {
                Message.AddBoolean(false);
            }

            Message.AddUInt32(OwnerId);
            Message.AddString(Data.Owner);
            Message.AddBoolean(true);
            Message.AddString(Data.Name);
            Message.AddString(Data.Description);
            Message.AddInt32(Data.TagCount);

            foreach (string Tag in Data.Tags)
            {
                Message.AddString(Tag);
            }

            if (Room != null)
            {
                Message.AddBoolean(Room.HasOngoingEvent);

                if (Room.Event != null)
                {
                    Message.AddString(Room.Event.Name);
                    Message.AddString(Room.Event.Description);
                    Message.AddInt32(Room.Event.Tags.Count);

                    foreach (string Tag in Room.Event.Tags.ToArray())
                    {
                        Message.AddString(Tag);
                    }
                }
            }
            else
            {
                Message.AddBoolean(false);
            }

            return Message;
        }

        #endregion

        #region User Moderation

        internal static void KickUser(GameClient ModSession, uint UserId, String Message, Boolean Soft)
        {
            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(UserId);

            if (Client == null || Client.GetHabbo().CurrentRoomId < 1 || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif(LanguageLocale.GetValue("moderation.kick.missingrank"));
                return;
            }

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(Client.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            Room.GetRoomUserManager().RemoveUserFromRoom(Client, true, false);

            if (!Soft)
            {
                Client.SendNotif(Message);

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE user_info SET cautions = cautions + 1 WHERE user_id = " + UserId + "");
                }
            }
        }

        internal static void AlertUser(GameClient ModSession, uint UserId, String Message, Boolean Caution)
        {
            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(UserId);

            if (Client == null || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Caution && Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif(LanguageLocale.GetValue("moderation.caution.missingrank"));
                Caution = false;
            }

            Client.SendNotif(Message, Caution);

            if (Caution)
            {
                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE user_info SET cautions = cautions + 1 WHERE user_id = " + UserId + "");
                }
            }
        }

        internal static void BanUser(GameClient ModSession, uint UserId, int Length, String Message)
        {
            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(UserId);

            if (Client == null || Client.GetHabbo().Id == ModSession.GetHabbo().Id)
            {
                return;
            }

            if (Client.GetHabbo().Rank >= ModSession.GetHabbo().Rank)
            {
                ModSession.SendNotif(LanguageLocale.GetValue("moderation.ban.missingrank"));
                return;
            }

            Double dLength = Length;

            ButterflyEnvironment.Game.GetBanManager().BanUser(Client, ModSession.GetHabbo().Username, dLength, Message, false);
        }

        #endregion

        #region User Info

        internal static ServerMessage SerializeUserInfo(uint UserId)
        {
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT id,username,online,mail,look FROM users WHERE id = " + UserId + "");
                DataRow User = dbClient.getRow();

                dbClient.setQuery("SELECT reg_timestamp, login_timestamp, cfhs, cfhs_abusive, cautions, bans FROM user_info WHERE user_id = " + UserId + "");
                DataRow Info = dbClient.getRow();

                if (User == null)
                {
                    throw new NullReferenceException("No user found in database");
                }

                ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.ModeratorUserInfoEvent);

                Message.AddUInt32(Convert.ToUInt32(User["id"]));
                Message.AddString((string)User["username"]);
                Message.AddString((string)User["look"]);

                if (Info != null)
                {
                    Message.AddInt32((int)Math.Ceiling((TextHandling.GetUnixTimestamp() - (Double)Info["reg_timestamp"]) / 60));
                    Message.AddInt32((int)Math.Ceiling((TextHandling.GetUnixTimestamp() - (Double)Info["login_timestamp"]) / 60));
                }
                else
                {
                    Message.AddInt32(0);
                    Message.AddInt32(0);
                }

                if (User["online"].ToString() == "1")
                {
                    Message.AddBoolean(true);
                }
                else
                {
                    Message.AddBoolean(false);
                }

                if (Info != null)
                {
                    Message.AddInt32((int)Info["cfhs"]);
                    Message.AddInt32((int)Info["cfhs_abusive"]);
                    Message.AddInt32((int)Info["cautions"]);
                    Message.AddInt32((int)Info["bans"]);
                }
                else
                {
                    Message.AddInt32(0); // cfhs
                    Message.AddInt32(0); // abusive cfhs
                    Message.AddInt32(0); // cautions
                    Message.AddInt32(0); // bans
                }
                Message.AddString(string.Empty); // last_purchase_txt
                Message.AddInt32(0); // identityinformationtool.url + this
                Message.AddInt32(0); // id_bans_txt
                Message.AddString((string)User["mail"]); // email_address_txt
                return Message;
            }
        }

        //internal static ServerMessage SerializeRoomVisits(UInt32 UserId)
        //{
        //    //using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
        //    {
        //        //dbClient.setQuery("SELECT room_id,hour,minute FROM user_roomvisits WHERE user_id = " + UserId + " ORDER BY entry_timestamp DESC LIMIT 50");
        //        //DataTable Data = dbClient.getTable();

        //        ServerMessage Message = new ServerMessage(OutputCode.RoomVisitsEvent);
        //        Message.AddUInt32(UserId);
        //        Message.AddString(ButterflyEnvironment.Game.GetClientManager().GetNameById(UserId));

        //        //if (Data != null)
        //        //{
        //        //    Message.AddInt32(Data.Rows.Count);

        //        //    foreach (DataRow Row in Data.Rows)
        //        //    {
        //        //        RoomData RoomData = ButterflyEnvironment.Game.GetRoomManager().GenerateNullableRoomData(Convert.ToUInt32(Row["room_id"]));

        //        //        Message.AddBoolean(RoomData.IsPublicRoom);
        //        //        Message.AddUInt32(RoomData.Id);
        //        //        Message.AddString(RoomData.Name);
        //        //        Message.AddInt32((int)Row["hour"]);
        //        //        Message.AddInt32((int)Row["minute"]);
        //        //    }
        //        //}
        //        //else
        //        //{
        //            Message.AddInt32(0);
        //        //}

        //        return Message;
        //    }
        //}

        #endregion

        #region Chatlogs

        internal static ServerMessage SerializeUserChatlog(UInt32 UserId)
        {
            GameClient client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(UserId);

            if (client == null || client.GetHabbo() == null)
            {
                ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.UserChatlogEvent);
                Message.AddUInt32(UserId);
                Message.AddString("User not online");
                Message.AddInt32(0);

                return Message;
            }
            else
            {
                ChatMessageManager manager = client.GetHabboDataContainer().GetChatMessageManager();
                Dictionary<int, List<ChatMessage>> messages = manager.GetSortedMessages();

                ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.UserChatlogEvent);
                Message.AddUInt32(UserId);
                Message.AddString(client.GetHabbo().Username);

                foreach (KeyValuePair<int, List<ChatMessage>> valuePair in messages)
                {

                    List<ChatMessage> sortedMessages = valuePair.Value;
                    ChatMessage firstMessage = sortedMessages.First();

                    Message.AddBoolean(false);
                    Message.AddUInt32(firstMessage.roomID);
                    Message.AddString(firstMessage.roomName);

                    Message.AddInt32(sortedMessages.Count);

                    foreach (ChatMessage message in sortedMessages)
                    {
                        message.Serialize(ref Message);
                    }
                }

                return Message;
            }

            //using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            //{
            //    dbClient.setQuery("SELECT room_id,entry_timestamp,exit_timestamp FROM user_roomvisits WHERE user_id = " + UserId + " ORDER BY entry_timestamp DESC LIMIT 5");
            //    DataTable Visits = dbClient.getTable();


            //    ServerMessage Message = new ServerMessage(536);
            //    Message.AddUInt32(UserId);
            //    Message.AddString(ButterflyEnvironment.Game.GetClientManager().GetNameById(UserId));

            //    if (Visits != null)
            //    {
            //        Message.AddInt32(Visits.Rows.Count);

            //        foreach (DataRow Visit in Visits.Rows)
            //        {
            //            DataTable Chatlogs = null;

            //            if ((Double)Visit["exit_timestamp"] <= 0.0)
            //            {
            //                Visit["exit_timestamp"] = TextHandling.GetUnixTimestamp();
            //            }

            //            //using (DatabaseClient dbClient = ButterflyEnvironment.GetDatabase().GetClient())
            //            //{
            //            //Chatlogs = dbClient.getTable("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = " + (uint)Visit["room_id"] + " AND timestamp > " + (Double)Visit["entry_timestamp"] + " AND timestamp < " + (Double)Visit["exit_timestamp"] + " ORDER BY timestamp DESC");
            //            //}

            //            RoomData RoomData = ButterflyEnvironment.Game.GetRoomManager().GenerateNullableRoomData((UInt32)Visit["room_id"]);

            //            Message.AddBoolean(RoomData.IsPublicRoom);
            //            Message.AddUInt32(RoomData.Id);
            //            Message.AddString(RoomData.Name);

            //            if (Chatlogs != null)
            //            {
            //                Message.AddInt32(Chatlogs.Rows.Count);

            //                foreach (DataRow Log in Chatlogs.Rows)
            //                {
            //                    Message.AddInt32((int)Log["hour"]);
            //                    Message.AddInt32((int)Log["minute"]);
            //                    Message.AddUInt32((UInt32)Log["user_id"]);
            //                    Message.AddString((string)Log["user_name"]);
            //                    Message.AddString((string)Log["message"]);
            //                }
            //            }
            //            else
            //            {
            //                Message.AddInt32(0);
            //            }
            //        }
            //    }
            //    else
            //    {
            //        Message.AddInt32(0);
            //    }

            //    return Message;
           // }
        }

        internal static ServerMessage SerializeTicketChatlog(SupportTicket Ticket, RoomData RoomData, Double Timestamp)
        {
            Room currentRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(RoomData.Id);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.CfhChatlogEvent);
            Message.AddUInt32(Ticket.TicketId);
            Message.AddUInt32(Ticket.SenderId);
            Message.AddUInt32(Ticket.ReportedId);
            Message.AddBoolean(false);
            Message.AddUInt32(RoomData.Id);
            Message.AddString(RoomData.Name);

            if (currentRoom == null)
            {
                Message.AddInt32(0);
                return Message;
            }
            else
            {
                ChatMessageManager manager = currentRoom.GetChatMessageManager();
                Message.AddInt32(manager.messageCount);
                manager.Serialize(ref Message);

                return Message;
            }


            //using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            //{
            //    dbClient.setQuery("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = " + RoomData.Id + " AND timestamp >= " + (Timestamp - 300) + " AND timestamp <= " + Timestamp + " ORDER BY timestamp DESC");
            //    DataTable Data = dbClient.getTable();

            //    ServerMessage Message = new ServerMessage(534);
            //    Message.AddUInt32(Ticket.TicketId);
            //    Message.AddUInt32(Ticket.SenderId);
            //    Message.AddUInt32(Ticket.ReportedId);
            //    Message.AddBoolean(RoomData.IsPublicRoom);
            //    Message.AddUInt32(RoomData.Id);
            //    Message.AddString(RoomData.Name);

            //    if (Data != null)
            //    {
            //        Message.AddInt32(Data.Rows.Count);

            //        foreach (DataRow Row in Data.Rows)
            //        {
            //            Message.AddInt32((int)Row["hour"]);
            //            Message.AddInt32((int)Row["minute"]);
            //            Message.AddUInt32((UInt32)Row["user_id"]);
            //            Message.AddString((String)Row["user_name"]);
            //            Message.AddString((String)Row["message"]);
            //        }
            //    }
            //    else
            //    {
            //        Message.AddInt32(0);
            //    }

            //    return Message;
            //}
        }

        internal static ServerMessage SerializeRoomChatlog(UInt32 roomID)
        {
            Room currentRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(roomID);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.CfhChatlogEvent);
            //Message.AddBoolean(currentRoom.IsPublic);
            //Message.AddUInt32(currentRoom.RoomId);
            //Message.AddString(currentRoom.Name);
            Message.AddInt32(0);
            Message.AddInt32(0);
            Message.AddInt32(0);
            Message.AddInt32(0);
            Message.AddBoolean(false);
            Message.AddInt32(0);
            Message.AddString(string.Empty);
            Message.AddInt32(0);

            return Message;
            //if (currentRoom == null)
            //{
            //    Message.AddInt32(0);
            //    return Message;
            //}
            //else
            //{
            //    ChatMessageManager manager = currentRoom.GetChatMessageManager();
            //    Message.AddInt32(manager.messageCount);
            //    manager.Serialize(ref Message);

            //    return Message;
            //}

            //Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(RoomId);

            //if (Room == null)
            //{
            //    throw new NullReferenceException("Noo room found.");
            //}

            //Boolean IsPublic = false;

            //if (Room.Type.ToLower() == "public")
            //{
            //    IsPublic = true;
            //}

            //using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            //{
            //    dbClient.setQuery("SELECT user_id,user_name,hour,minute,message FROM chatlogs WHERE room_id = " + Room.RoomId + " ORDER BY timestamp DESC LIMIT 150");
            //    DataTable Data = dbClient.getTable();

            //    ServerMessage Message = new ServerMessage(535);
            //    Message.AddBoolean(IsPublic);
            //    Message.AddUInt32(Room.RoomId);
            //    Message.AddString(Room.Name);

            //    if (Data != null)
            //    {
            //        Message.AddInt32(Data.Rows.Count);

            //        foreach (DataRow Row in Data.Rows)
            //        {
            //            Message.AddInt32((int)Row["hour"]);
            //            Message.AddInt32((int)Row["minute"]);
            //            Message.AddUInt32((UInt32)Row["user_id"]);
            //            Message.AddString((string)Row["user_name"]);
            //            Message.AddString((string)Row["message"]);
            //        }
            //    }
            //    else
            //    {
            //        Message.AddInt32(0);
            //    }

            //    return Message;
            //}
        }
        #endregion
    }
}
