﻿using System;
using System.Data;
using Butterfly.HabboHotel.GameClients;
using System.Collections.Generic;

namespace Butterfly.HabboHotel.Users.Authenticator
{
    static class HabboFactory
    {
        internal static Habbo GenerateHabbo(DataRow dRow, DataTable group)
        {
            uint id = Convert.ToUInt32(dRow["id"]);
            string username = (string)dRow["username"];
            string realname = (string)dRow["real_name"];
            uint rank = Convert.ToUInt32(dRow["rank"]);
            string motto = (string)dRow["motto"];
            string lastOnline = (string)dRow["last_online"];
            string look = (string)dRow["look"];
            string gender = (string)dRow["gender"];
            int credits = (int)dRow["credits"];
			int crystals = (int)dRow["crystals"];
            int activityPoints = (int)dRow["activity_points"];
            double activityPointsLastUpdate = Convert.ToDouble(dRow["activity_points_lastupdate"]);
            bool isMuted = TextHandling.EnumToBool(dRow["is_muted"].ToString());
            uint homeRoom = Convert.ToUInt32(dRow["home_room"]);
            int respect = (Int32)dRow["respect"];
            int dailyRespect = (int)dRow["daily_respect_points"];
            int dailyPetRespect = (int)dRow["daily_pet_respect_points"];
            bool mtantPenalty = (dRow["mutant_penalty"].ToString() != "0");
            bool blockFriends = TextHandling.EnumToBool(dRow["block_newfriends"].ToString());
            uint questID = Convert.ToUInt32(dRow["currentquestid"]);
            int questProgress = (int)dRow["currentquestprogress"];
            int achiecvementPoints = (int)dRow["achievement_points"];
            string creditsTimestamp = (string)dRow["lastdailycredits"];

            List<uint> groupMemberships = new List<uint>();
            List<uint> groupMembershipPending = new List<uint>();
            uint currentGroup = (uint)dRow["group_favorite"];
            foreach (DataRow imaRow in group.Rows)
            {
                uint groupID = (uint)imaRow["groupid"];
                if ((bool)imaRow["is_pending"])
                    groupMembershipPending.Add(groupID);
                else
                {
                    //to-do: report to group that a user is online
                    groupMemberships.Add(groupID);
                }
            }


            return new Habbo(id, username, realname, rank, motto, lastOnline, look, gender, credits, crystals, creditsTimestamp,activityPoints, activityPointsLastUpdate, isMuted, homeRoom, respect, dailyRespect, dailyPetRespect, mtantPenalty, blockFriends, questID, questProgress, achiecvementPoints, groupMemberships, groupMembershipPending, currentGroup);
        }
    }
}
