using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Data;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class CopyLookCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
			if (Params.Length < 2)
				return;

            string copyTarget = Params[1];

            string gender = null;
            string figure = null;
            DataRow dRow;
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT gender,look FROM users WHERE username = @username");
                dbClient.addParameter("username", copyTarget);
                dRow = dbClient.getRow();

                if (dRow != null)
                {
                    gender = (string)dRow[0];
                    figure = (string)dRow[1];

                    dbClient.setQuery("UPDATE users SET gender = @gender, look = @look WHERE username = @username");
                    dbClient.addParameter("gender", gender);
                    dbClient.addParameter("look", figure);
                    dbClient.addParameter("username", Session.GetHabbo().Username);
                    dbClient.runQuery();
                }
            }

			if (dRow != null)
            {
                Session.GetHabbo().Gender = gender;
                Session.GetHabbo().Look = figure;
                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.UserChangeMessageEvent);
                message.AddInt32(-1);
                message.AddString(Session.GetHabbo().Look);
                message.AddString(Session.GetHabbo().Gender.ToLower());
                message.AddString(Session.GetHabbo().Motto);
                message.AddInt32(Session.GetHabbo().AchievementPoints);
                Session.SendMessage(message);

                if (Session.GetHabbo().InRoom)
                {
                    Room Room = Session.GetHabbo().CurrentRoom;

                    if (Room == null)
                    {
                        return;
                    }

                    RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);

                    if (User == null)
                    {
                        return;
                    }

                    ServerMessage RoomUpdate = PacketHandelingManager.GetRecycledItem(OutputCode.UserChangeMessageEvent);
                    RoomUpdate.AddInt32(User.VirtualId);
                    RoomUpdate.AddString(Session.GetHabbo().Look);
                    RoomUpdate.AddString(Session.GetHabbo().Gender.ToLower());
                    RoomUpdate.AddString(Session.GetHabbo().Motto);
                    RoomUpdate.AddInt32(Session.GetHabbo().AchievementPoints);
                    Room.SendMessage(RoomUpdate);
                }
            }
        }
    }
}