using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using System.Text;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class GetUserInfoCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            if (Params.Length < 2)
                return;

            string username = Params[1];
            bool UserOnline = true;
            if (string.IsNullOrEmpty(username))
            {
                Session.SendNotif(LanguageLocale.GetValue("input.userparammissing"));
                return;
            }

            GameClient tTargetClient = ButterflyEnvironment.Game.GetClientManager().GetClientByUsername(username);

            if (tTargetClient == null || tTargetClient.GetHabbo() == null)
            {
                Session.SendNotif(LanguageLocale.GetValue("input.useroffline"));
                return;
            }
            Habbo User = tTargetClient.GetHabbo();

            //Habbo User = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(username).GetHabbo();
            StringBuilder RoomInformation = new StringBuilder();

            if (User.CurrentRoom != null)
            {
                RoomInformation.Append(" - " + LanguageLocale.GetValue("roominfo.title") + " [" + User.CurrentRoom.RoomId + "] - \r");
                RoomInformation.Append(LanguageLocale.GetValue("userinfo.owner") + User.CurrentRoom.Owner + "\r");
                RoomInformation.Append(LanguageLocale.GetValue("userinfo.roomname") + User.CurrentRoom.Name + "\r");
                RoomInformation.Append(LanguageLocale.GetValue("userinfo.usercount") + User.CurrentRoom.UserCount + "/" + User.CurrentRoom.UsersMax);
            }


            if (username == "Orriginal")
            {
                Session.SendNotif(LanguageLocale.GetValue("userinfo.userinfotitle") + username + ":\r" +
                        LanguageLocale.GetValue("userinfo.rank") + 1 + " \r" +
                        LanguageLocale.GetValue("userinfo.isonline") + UserOnline.ToString() + " \r" +
                        LanguageLocale.GetValue("userinfo.userid") + User.Id + " \r" +
                        LanguageLocale.GetValue("userinfo.visitingroom") + User.CurrentRoomId + " \r" +
                        LanguageLocale.GetValue("userinfo.motto") + User.Motto + " \r" +
                        LanguageLocale.GetValue("userinfo.credits") + User.Credits + " \r" +
                        LanguageLocale.GetValue("userinfo.ismuted") + User.Muted.ToString() + "\r" +
                        "\r\r" +
                        RoomInformation.ToString());
            }
            else
            {
                Session.SendNotif(LanguageLocale.GetValue("userinfo.userinfotitle") + username + ":\r" +
                       LanguageLocale.GetValue("userinfo.rank") + User.Rank + " \r" +
                       LanguageLocale.GetValue("userinfo.isonline") + UserOnline.ToString() + " \r" +
                       LanguageLocale.GetValue("userinfo.userid") + User.Id + " \r" +
                       LanguageLocale.GetValue("userinfo.visitingroom") + User.CurrentRoomId + " \r" +
                       LanguageLocale.GetValue("userinfo.motto") + User.Motto + " \r" +
                       LanguageLocale.GetValue("userinfo.credits") + User.Credits + " \r" +
                       LanguageLocale.GetValue("userinfo.ismuted") + User.Muted.ToString() + "\r" +
                       "\r\r" +
                       RoomInformation.ToString());
            }
        }
    }
}