using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class HotelAlertCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            string Notice = TextHandling.ConcatArray(Params).Substring(4);

            ServerMessage notification = PacketHandelingManager.GetRecycledItem(OutputCode.HabboBroadcastMessageEvent);
            notification.AddString(LanguageLocale.GetValue("hotelallert.notice") + "\n" +
            Notice + "\n\n- " + Session.GetHabbo().Username, true);
            ButterflyEnvironment.Game.GetClientManager().QueueBroadcaseMessage(notification);

            ButterflyEnvironment.Game.GetModerationTool().LogStaffEntry(Session.GetHabbo().Username, string.Empty, "HotelAlert", "Hotel alert [" + Notice + "]", null);
        }
    }
}