using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Util;
using System.Collections.Generic;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class PullUserCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            Room room = Session.GetHabbo().CurrentRoom;
            if (room == null)
                return;

            RoomUser roomuser = room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (roomuser == null)
                return;

            if (Params.Length == 1)
            {
                Point squareInFront = CoordinationUtil.GetPointInFront(roomuser.Coordinate, roomuser.RotBody);
                Point squareInFrontInFront = CoordinationUtil.GetPointBehind(squareInFront, CoordinationUtil.RotationIverse(roomuser.RotBody));
				List<RoomUser> users = room.GetGameMap().GetRoomUsers(Formatting.PointToInt(squareInFrontInFront));

                foreach (RoomUser user in users)
                {
                    room.GetGameMap().PullUser(user, roomuser);
                    roomuser.Chat(Session, string.Format(LanguageLocale.GetValue("commands.pulluser"), user.GetUsername()), true);
                }
            }
            else if (Params.Length == 2)
            {
                RoomUser roomuserTarget = room.GetRoomUserManager().GetRoomUserByHabbo(Params[1]);
                room.GetGameMap().PullUser(roomuserTarget, roomuser);
                roomuser.Chat(Session, string.Format(LanguageLocale.GetValue("commands.pulluser"), roomuserTarget.GetUsername()), true);
            }

            roomuser.Chat(Session, LanguageLocale.GetValue("commands.pulluser"), true);
        }
    }
}