using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Util;
using System.Collections.Generic;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class PushUserCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            Room room = Session.GetHabbo().CurrentRoom;
            if (room == null)
                return;

            RoomUser roomuser = room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);
            if (roomuser == null)
                return;

            if (Params.Length == 1)
            {

                Point squareInfront = CoordinationUtil.GetPointInFront(roomuser.Coordinate, roomuser.RotBody);
                List<RoomUser> users = room.GetGameMap().GetRoomUsers(Formatting.PointToInt(squareInfront));

                Point squareInFrontOfUserInFront = CoordinationUtil.GetPointInFront(squareInfront, roomuser.RotBody); //Yo dawg, we heard yo like coordinates, so we put a coordinate inside yo coordinate
                foreach (RoomUser user in users)
                {
                    //user.MoveTo(squareInFrontOfUserInFront);
                    //roomuser.Chat(Session, string.Format(LanguageLocale.GetValue("commands.pushuser"), Params[1]), true);
                    room.GetGameMap().PushUser(user, roomuser);
                    roomuser.Chat(Session, string.Format(LanguageLocale.GetValue("commands.pushuser"), user.GetUsername()), true);
                }
            }
            else
            {
                RoomUser roomuserTarget = room.GetRoomUserManager().GetRoomUserByHabbo(Params[1]);
                room.GetGameMap().PushUser(roomuserTarget, roomuser);
                roomuser.Chat(Session, string.Format(LanguageLocale.GetValue("commands.pushuser"), roomuserTarget.GetUsername()), true);
            }
        }
    }
}