using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages;
using Butterfly.Messages.IOCodes;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class RoomAlertCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            Room TargetRoom = Session.GetHabbo().CurrentRoom;
            TargetRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(Session.GetHabbo().CurrentRoomId);

            if (TargetRoom == null)
                return;

            string Msg = TextHandling.ConcatArray(Params, 1);

            ServerMessage nMessage = PacketHandelingManager.GetRecycledItem(OutputCode.HabboBroadcastMessageEvent);
            nMessage.AddString(Msg);
            //nMessage.AddString(string.Empty);

            ButterflyEnvironment.Game.GetModerationTool().LogStaffEntry(Session.GetHabbo().Username, string.Empty, "Alert", "Room alert with message [" + Msg + "]", null);
            TargetRoom.SendMessage(nMessage);
        }
    }
}