using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class SummonUserCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            if (Params.Length < 1)
            {
                Session.SendNotif("No user specified");
                return;
            }
            string username = Params[1];
            GameClient client = ButterflyEnvironment.Game.GetClientManager().GetClientByUsername(username);
            if (client == null)
            {
                Session.SendNotif("User is offline");
                return;
            }

            Room room = Session.GetHabbo().CurrentRoom;

            client.PrepareRoomForUser(room.RoomId, room.Password);
        }
    }
}