using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.HabboHotel.Users.ChatMessageHandling
{
    class TriggerSitCommandHandler : CommandMetaData, IChatMessageHandler
    {
        public void RunCommand(GameClient Session, string[] Params)
        {
            Room room = Session.GetHabbo().CurrentRoom;
            if (room == null)
                return;

            RoomUser roomuser = room.GetRoomUserManager().GetRoomUserByHabbo(Session.GetHabbo().Id);

            if (roomuser.Statusses.ContainsKey("sit"))
            {
                roomuser.Statusses.Remove("sit");
                roomuser.forcesit = false;
            }
            else
            {
                if (roomuser.RotBody % 2 == 0)
                {
                    roomuser.Statusses.Add("sit", TextHandling.GetString(roomuser.Z + 0.5 - room.GetGameMap().GetHeightForSquareFromData(roomuser.X, roomuser.Y)));
                    roomuser.forcesit = true;
                }
            }

            roomuser.UpdateNeeded = true;
        }
    }
}