﻿using System;
using System.Collections.Generic;
using System.Data;
using Butterfly.Core;
using Butterfly.HabboHotel.Achievements;
using Butterfly.HabboHotel.ChatMessageStorage;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users.Badges;
using Butterfly.HabboHotel.Users.Inventory;
using Butterfly.HabboHotel.Users.Messenger;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.Messages;
using Butterfly.ServerManager;
using Database_Manager.Database.Session_Details.Interfaces;
using Butterfly.HabboHotel.Users.UserDataManagement;
using System.Collections;
using Butterfly.Messages.IOCodes;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Users.Group;

namespace Butterfly.HabboHotel.Users
{
    class Habbo : IUpdateable<Habbo>
    {
        internal UInt32 Id;

        internal string Username;
        internal string RealName;

        internal int forceRot = -1;
        internal int buyItemLoop = 1;

        internal uint Rank;
        internal string Motto;
        internal string LastOnline;

        internal string tempLook;
        internal string tempGender;

        internal string Look;
        internal string Gender;
        internal Int32 Credits;
        internal int Crystals;

        internal int AchievementPoints;
        internal Int32 ActivityPoints;
        internal Double LastActivityPointsUpdate;
        internal string creditsTimestamp;
        internal bool Muted;
        internal int Respect;

        internal int DailyRespectPoints; 
        internal int DailyPetRespectPoints; 

        internal uint LoadingRoom;
        internal Boolean LoadingChecksPassed;
        internal uint CurrentRoomId;
        internal uint HomeRoom;

        internal bool IsTeleporting;
        internal uint TeleportingRoomID;
        internal UInt32 TeleporterId;

        internal ArrayList FavoriteRooms;
        internal List<string> Tags;
        internal Dictionary<string, UserAchievement> Achievements;
        internal List<uint> RatedRooms;

		internal uint EquippedGroup;

		internal bool IsGroupMember
		{
			get
			{
                return GroupList.Count > 0;
			}
		}

		internal bool SpectatorMode;
        internal bool Disconnected;

        internal bool CalledGuideBot;
        internal bool MutantPenalty;

        internal bool HasFriendRequestsDisabled;

        internal List<RoomData> UsersRooms;

        internal Dictionary<uint, int> quests;
        internal uint CurrentQuestId;
        internal uint LastCompleted;
        internal int CurrentQuestProgress;
        internal uint LastQuestId;

        internal List<uint> GroupList;
        internal List<uint> PendingGroupJoins;

        internal Boolean InRoom
        {
            get
            {
                if (CurrentRoomId >= 1)
                {
                    return true;
                }

                return false;
            }
        }

        internal Room CurrentRoom
        {
            get
            {
                if (CurrentRoomId <= 0)
                {
                    return null;
                }

                return ButterflyEnvironment.Game.GetRoomManager().GetRoom(CurrentRoomId);
            }
        }

        internal Habbo(UInt32 Id, string Username, string RealName,
            uint Rank, string Motto, string LastOnline, string Look, string Gender, Int32 Credits, int crystals, string creditsTimestamp,
            Int32 ActivityPoints, Double LastActivityPointsUpdate, bool Muted,
            UInt32 HomeRoom, Int32 Respect, Int32 DailyRespectPoints, Int32 DailyPetRespectPoints,
            bool MutantPenalty, bool HasFriendRequestsDisabled, uint currentQuestID, int currentQuestProgress, int achievementPoints, List<uint> groups, List<uint> pendingJoins, uint currentGroup)
        {
            this.Id = Id;
            this.Username = Username;
            this.RealName = RealName;
            this.Rank = Rank;
            this.Motto = Motto;
            this.Look = TextHandling.FilterFigure(Look.ToLower());
            this.LastOnline = LastOnline;
            this.Crystals = crystals;
            this.Gender = Gender.ToLower();
            this.Credits = Credits;
            this.ActivityPoints = ActivityPoints;
            this.AchievementPoints = achievementPoints;
            this.LastActivityPointsUpdate = LastActivityPointsUpdate;
            this.Muted = Muted;
            this.LoadingRoom = 0;
            this.LoadingChecksPassed = false;
            this.CurrentRoomId = 0;
            this.HomeRoom = HomeRoom;
            this.FavoriteRooms = new ArrayList();
            this.Tags = new List<string>();
            this.Achievements = new Dictionary<string, UserAchievement>();
            this.RatedRooms = new List<uint>();
            this.Respect = Respect;
            this.DailyRespectPoints = DailyRespectPoints;
            this.DailyPetRespectPoints = DailyPetRespectPoints;
            this.CalledGuideBot = false;
            this.MutantPenalty = MutantPenalty;
            this.IsTeleporting = false;
            this.TeleporterId = 0;
            this.UsersRooms = new List<RoomData>();
            this.HasFriendRequestsDisabled = HasFriendRequestsDisabled;
            this.creditsTimestamp = creditsTimestamp;
            this.LastQuestId = 0;
            this.CurrentQuestId = currentQuestID;
            this.CurrentQuestProgress = currentQuestProgress;

            if (this.DailyPetRespectPoints > 3)
                this.DailyPetRespectPoints = 3;
            if (this.DailyRespectPoints > 3)
                this.DailyRespectPoints = 3;
            this.EquippedGroup = currentGroup;
            this.GroupList = groups;
            this.PendingGroupJoins = pendingJoins;
        }
        
       

        //internal HabboData GetUserData
        //{
        //    get
        //    {
        //        return mUserData;
        //    }
        //}

        internal void UpdateRooms(IQueryAdapter dbClient)
        {
            UsersRooms.Clear();
            dbClient.setQuery("SELECT rooms.*, users.id AS ownerid FROM rooms LEFT JOIN room_active ON (room_active.roomid = rooms.id) JOIN users ON (users.username = rooms.owner) " + 
                "WHERE owner = @name ORDER BY id ASC");
            dbClient.addParameter("name", Username);
            DataTable dbTable = dbClient.getTable();

            foreach (DataRow Row in dbTable.Rows)
                UsersRooms.Add(ButterflyEnvironment.Game.GetRoomManager().FetchRoomData(Convert.ToUInt32(Row["id"]), Row));
        }

       

        //internal void SerializeQuests(ref QueuedServerMessage response)
        //{
        //    ButterflyEnvironment.Game.GetQuestManager().GetList(mClient, null);
        //}

        internal void LoadFavorites(List<uint> roomID)
        {
            FavoriteRooms = new ArrayList();
            foreach (uint id in roomID)
            {
                FavoriteRooms.Add(id);
            }
        }

        internal void LoadTags(List<string> tags)
        {
            this.Tags = tags;

            //if (Tags.Count >= 5)
            //    ButterflyEnvironment.Game.GetAchievementManager().UnlockAchievement(GetClient(), 7, 1);
        }

        internal void LoadAchievements(Dictionary<string, UserAchievement> achievements)
        {
            this.Achievements = achievements;
        }

        private bool HabboinfoSaved = false;
       

        internal string GetQueryString
        {
            get
            {
                HabboinfoSaved = true;
                return "UPDATE users SET users.last_online = '" + DateTime.Now.ToString() + "', activity_points = '" + ActivityPoints + "', activity_points_lastupdate = '" + LastActivityPointsUpdate + "', credits = '" + Credits + "', achievement_points = " + AchievementPoints + " WHERE id = '" + Id + "'; "
                    + "DELETE FROM user_online WHERE userid = " + Id + "; ";
            }
        }

        internal void SynchronizeCrystalBalance()
        {
            int newBalance;
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT crystals FROM users WHERE id = @userid");
                dbClient.addParameter("userid", this.Id);
                newBalance = dbClient.getInteger();
            }

            if (newBalance != this.Crystals)
            {
                this.Crystals = newBalance;
            }
        }

        internal void OnDisconnect(GameClient mClient)
        {
            
            if (this.Disconnected)
                return;

            this.Disconnected = true;
            ButterflyEnvironment.Game.GetClientManager().UnregisterClient(Id, Username);
            SessionManagement.IncreaseDisconnection();
            Logging.WriteLine(Username + " has logged out.");
            
            if (!HabboinfoSaved)
            {
                if (ButterflyEnvironment.Configuration.SyncCrystalsOnPurchase)
                {
                    SynchronizeCrystalBalance();
                }
                HabboinfoSaved = true;
                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE users SET users.last_online = '" + DateTime.Now.ToString() + "', activity_points = " + ActivityPoints + ", activity_points_lastupdate = '" + LastActivityPointsUpdate + "', credits = " + Credits + ", crystals = " + Crystals + ", achievement_points = " + AchievementPoints + " WHERE id = " + Id + " ;");
                }
            }

            if (InRoom && CurrentRoom != null)
            {
                CurrentRoom.GetRoomUserManager().RemoveUserFromRoom(mClient, false, false);
            }
        }

        internal void GiveUserCrystals(int p)
        {
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE users SET crystals = crystals + " + p + " WHERE id = '" + Id + "'");
            }
        }

        internal int GetQuestProgress(uint p)
        {
            int progress = 0;
            quests.TryGetValue(p, out progress);
            return progress;
        }

        internal UserAchievement GetAchievementData(string p)
        {
            UserAchievement achievement = null;
            Achievements.TryGetValue(p, out achievement);
            return achievement;
        }

        public override bool Equals(object obj)
        {
            Habbo data = obj as Habbo;

            if (data != null)
                return data.Id == this.Id;
            return false;
        }

        public override int GetHashCode()
        {
            return (int)this.Id;
        }

        internal override void RemoveUpdater(IUpdateListener<Habbo> item)
        {
            base.RemoveUpdater(item);
            ReportBack();
        }

        internal void ReportBack()
        {
            if (ActiveListenerCount == 0)
                ButterflyEnvironment.Game.GetHabboDataManager().ItemUpdated(this);
        }

        internal GroupMember GetEquippedGroup()
        {
            UpdateGroupCache();
            return gDataCache;
        }

        private void UpdateGroupCache()
        {
            if (gDataCache == null || gDataCache.Group == null || gDataCache.Group.ID != EquippedGroup)
            {
                if (EquippedGroup == 0)
                    return ;
				gDataCache = GetGroupMember(EquippedGroup);
			}
        }
        private GroupMember gDataCache;

        internal GroupMember GetGroupMember(uint groupID)
        {
			if (this.GroupList.Contains(groupID))
			{
				GroupData d =ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
				if (d == null)//group was invalid for some reason
				{
					this.GroupList.Remove(groupID);
					return null;
				}
				return d.GetMembership(this.Id);
			}

            return null;
        }

        internal void RemovePendingGroupJoin(GroupMember m)
        {
            this.PendingGroupJoins.Remove(m.Group.ID);
        }

        internal void AddPendingGroupJoin(GroupMember m)
        {
            this.PendingGroupJoins.Add(m.Group.ID);
        }

        internal void AddNewMembership(GroupMember m)
        {
            this.GroupList.Add(m.Group.ID);
        }

        internal void RemoveExistingGroupMembership(GroupMember m)
        {
            this.GroupList.Remove(m.Group.ID);
        }
        
        internal void ClearRoomLoading()
        {
            this.LoadingRoom = 0;
            this.LoadingChecksPassed = true;
        }

        internal ServerMessage SendUserInfo(uint userID, bool idIsClient)
        {
            Habbo client = null;
            if (!idIsClient)
            {
                client = ButterflyEnvironment.Game.GetHabboDataManager().GetHabboData(userID);
            }
            else
            {
                client = this;
            }

            if (client == null)
                return null;

            int friendCount = 0;
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT COUNT(*) FROM messenger_friendships WHERE sender = " + userID + " OR receiver = " + userID + "");
                friendCount = dbClient.getInteger();
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.UserObjectEvent);

            message.AddUInt32(client.Id);
            message.AddString(client.Username);
            message.AddString(client.Look);
            message.AddString(client.Motto);
            message.AddString(client.LastOnline);
            message.AddInt32(client.AchievementPoints);
            message.AddInt32(friendCount);
            message.AddBoolean(userID == Id); //is my friend
            message.AddBoolean(false);
            message.AddBoolean(ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(userID) != null);

            message.AddInt32(client.GroupList.Count);

            foreach (uint groupID in client.GroupList)
            {
                GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
                message.AddUInt32(groupID); // Group ID
                message.AddString(group.Name); // name
                message.AddString(group.image); // Image
                message.AddString(group.Description); // Descripotion
                message.AddString(string.Empty); //? rank maybe
                message.AddBoolean(client.EquippedGroup == groupID); // Is Favorite
            }

            message.AddInt32(0);
            message.AddBoolean(true);
            client.ReportBack();
            return message;
        }
    }
}
