﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages;

namespace Butterfly.HabboHotel.Users.Messenger
{
    class MessengerBuddy
    {
        #region Fields
        private readonly uint UserId;
        private readonly string mUsername;
        private readonly string mLook;
        private readonly string mMotto;
        private readonly string mLastOnline;
        internal RelationshipStatus relationship;

        private HabboMessenger messenger { get {return MessengerManager.instance.GetUserMessenger(this.Id); } }
        #endregion

        #region Return values
        internal uint Id
        {
            get
            {
                return UserId;
            }
        }
        
        internal bool IsOnline
        {
            get
            {
                return messenger.isOnline();
            }
        }

        internal bool InRoom
        {
            get
            {
                return messenger.isInRoom();
            }
        }

        internal Room CurrentRoom
        {
            get
            {
                if (messenger.isInRoom())
                {
                    return messenger.GetRoom();
                }
                return null;
            }
        }

        internal string Username
        {
            get
            {
                return mUsername;
            }
        }
        #endregion

        #region Constructor
        internal MessengerBuddy(uint UserId, string pUsername, string pLook, string pMotto, string pLastOnline, int relationship)
        {
            this.UserId = UserId;
            this.mUsername = pUsername;
            this.mLook = pLook;
            this.mMotto = pMotto;
            this.mLastOnline = pLastOnline;
            this.relationship = (RelationshipStatus)relationship;
        }
        #endregion

        #region Methods
      
        internal void Serialize(ServerMessage reply)
        {
            bool online = IsOnline;

            reply.AddUInt32(UserId);
            reply.AddString(mUsername);
            reply.AddInt32(1);
            reply.AddBoolean(online);
            reply.AddBoolean(online ? InRoom : false);
            reply.AddString(mLook);
            reply.AddInt32(0);
            reply.AddString(mMotto);
            reply.AddString(string.Empty);
            reply.AddString(string.Empty);
            reply.AddBoolean(true);
            reply.AddInt32((int)relationship);
        }
        #endregion
    }
}
