﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Data;
using Database_Manager.Database.Session_Details.Interfaces;
using Butterfly.HabboHotel.Users.UserDataManagement;

namespace Butterfly.HabboHotel.Users.Messenger
{
    class MessengerManager
    {
		private Hashtable userMessengers = new Hashtable(324449); //PRIME for extra speed
        private static MessengerManager singleton = new MessengerManager();

        public static MessengerManager instance
        {
            get
            {
                return singleton;
            }
        }

        public static void Init()
        {
            if (singleton != null)
            {
                singleton.Destroy();
            }
            singleton = new MessengerManager();
        }

        private void Destroy()
        {

        }
        public MessengerManager()
        {
        }

        public HabboMessenger GetUserMessenger(uint uid, bool loadData = false, UserData data = null)
        {
            if (userMessengers.ContainsKey(uid) && data == null)
                return (HabboMessenger)userMessengers[uid];
            else
            {
                HabboMessenger result = new HabboMessenger(uid);
                Dictionary<uint, MessengerBuddy> friends = new Dictionary<uint, MessengerBuddy>();

                if (loadData)
                {
                    DataTable dFriends;
                    using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                    {
                        dbClient.setQuery("SELECT users.id,users.username,users.motto,users.look,users.last_online,messenger_friendships.relationship " +
                                    "FROM users " +
                                    "JOIN messenger_friendships " +
                                    "ON users.id = messenger_friendships.sender " +
                                    "WHERE messenger_friendships.receiver = " + uid + " " +
                                    "UNION ALL " +
                                    "SELECT users.id,users.username,users.motto,users.look,users.last_online,messenger_friendships.relationship " +
                                    "FROM users " +
                                    "JOIN messenger_friendships " +
                                    "ON users.id = messenger_friendships.receiver " +
                                    "WHERE messenger_friendships.sender = " + uid);
                        dFriends = dbClient.getTable();
                    }

                    UInt32 friendID;
                    foreach (DataRow dRow in dFriends.Rows)
                    {
                        friendID = (uint)dRow["id"];
                        if (friendID != uid && !friends.ContainsKey(friendID))
                            friends.Add(friendID, new MessengerBuddy(friendID, (string)dRow["username"], (string)dRow["look"], (string)dRow["motto"], (string)dRow["last_online"], (int)dRow["relationship"]));
                    }

                    result.Init(friends, new Dictionary<uint, MessengerRequest>());
                }
                else if (data != null)
                {
                    result.Init(data.friends, data.requests);
                }

                result.Init(new Dictionary<uint, MessengerBuddy>(), new Dictionary<uint, MessengerRequest>());

                if (userMessengers.ContainsKey(uid))
                    userMessengers[uid] = result;
                else
                    userMessengers.Add(uid, result);
                return result;
            }
        }

        internal Hashtable GetAllUsersAsClone()
        {
            return (Hashtable)userMessengers.Clone();
        }
    }
}
