﻿using Butterfly.HabboHotel.Users.UserDataManagement;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Collections.Generic;

namespace Butterfly.HabboHotel.Users.Subscriptions
{
    class SubscriptionManager
    {
        private uint userID;
        private Subscription currentSubscription;

        internal const string SUBSCRIPTION_TYPE_VIP = "habbo_vip";
        internal const string SUBSCRIPTION_TYPE_CLUB = "habbo_club";

        internal SubscriptionManager(uint userID, UserData userData)
        {
            this.userID = userID;
            this.currentSubscription = userData.subscription;
        }

        internal void Destroy()
        {
            currentSubscription = null;
        }

        internal Subscription GetSubscription()
        {
            return currentSubscription;
        }

        internal Boolean HasSubscription(string type)
        {
            if (currentSubscription != null)
            {
                if (type == SubscriptionManager.SUBSCRIPTION_TYPE_CLUB)
                    return currentSubscription.IsValid();

                return currentSubscription.IsValid() && currentSubscription.SubscriptionId == type;
            }
            return false;
        }

        internal void AddOrExtendSubscription(int DurationSeconds, string type)
        {
            if (this.currentSubscription != null && this.currentSubscription.SubscriptionId == type)
            {
                currentSubscription.AddSubscriptionTime(DurationSeconds);
                
                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.setQuery("UPDATE user_subscriptions SET timestamp_expire = " + currentSubscription.ExpireTime + " WHERE user_id = " + userID + " AND subscription_id = @subcrbr");
                    dbClient.addParameter("subcrbr", type);
                    dbClient.runQuery();
                }

                return;
            }

            int timestamp_created = TextHandling.GetUnixTimestamp();
            int timestamp_exire = TextHandling.GetUnixTimestamp() + DurationSeconds;

            currentSubscription = new Subscription(type, timestamp_exire);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("REPLACE INTO user_subscriptions (user_id,subscription_id,timestamp_activated,timestamp_expire) VALUES (" + userID + ",@subcrbr," + timestamp_created + "," + timestamp_exire + ")");
                dbClient.addParameter("subcrbr", type);
                dbClient.runQuery();
            }
        }

        internal bool HasSubscription()
        {
            if (currentSubscription != null)
            {
                return currentSubscription.IsValid();
            }
            return false;
        }
    }
}
