﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Users.Subscriptions;
using System.Runtime.Serialization;

namespace Butterfly.Messages
{
    [DataContract]
    class ChatCommand
    {
        [DataMember]
        public int commandID { get; set; }

        [DataMember]
        public string input { get; set; }
        
        [DataMember]
        public int minrank { get; set; }

        [DataMember]
        public string description { get; set; }

        [DataMember]
        public string prefix { get; set; }

        [DataMember]
        public List<string> clubsAllowed { get; set; }

        public ChatCommand(int pCommandID, string pInput, int pRank, string pDescription, string pPrefix, List<string> clubsAllowed)
        {
            this.commandID = pCommandID;
            this.input = pInput;
            this.minrank = pRank;
            this.description = pDescription;
            this.prefix = pPrefix;
            this.clubsAllowed = clubsAllowed;
        }

        internal bool UserGotAuthorization(GameClient session)
        {
            foreach (string subsciption in this.clubsAllowed)
            {
                if (!session.GetHabboDataContainer().GetSubscriptionManager().HasSubscription(subsciption) && subsciption != string.Empty)
                    return false;
            }

            if (minrank == 0)
                return true;
            else if (minrank > 0)
            {
                if (minrank <= session.GetHabbo().Rank)
                    return true;
            }
            else if (minrank < 0)
            {
                if (minrank == -1)
                {
                    if (session.GetHabbo().CurrentRoom.CheckRights(session, false))
                        return true;
                }
                else if (minrank == -2)
                {
                    if (session.GetHabbo().CurrentRoom.CheckRights(session, true))
                        return true;
                }
            }

            return false;
        }
    }
}
