﻿using System.Collections;

namespace Butterfly.Messages.ClientMessages
{
    class ClientMessageFactory
    {
        private static Queue freeObjects;

        internal static void Init()
        {
            freeObjects = new Queue();
        }

        internal static ClientMessage GetClientMessage(byte[] body, int position, int packetLength)
        {
            ClientMessage message;
            lock (freeObjects.SyncRoot)
            {
                if (freeObjects.Count > 0)
                {
                    message = (ClientMessage)freeObjects.Dequeue();
                    message.Init(body, position, packetLength);

                    return message;
                }
            }

            return new ClientMessage(body, position, packetLength);
        }

        internal static void ObjectCallback(ClientMessage message)
        {
            lock (freeObjects.SyncRoot)
            {
                freeObjects.Enqueue(message);
            }
        }
    }
}
