﻿using System.Runtime.CompilerServices;

namespace Butterfly.Messages
{
    class EncodingUtillity
    {
        private const int SHORT_LENGTH = sizeof(short);
        private const int INT_LENGTH   = sizeof(int);

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        internal static int ToInt16(byte[] v, ref int position)
        {
			if (position + SHORT_LENGTH > v.Length || position < 0)
                return 0;

            return (v[position++] << 8) + v[position++];
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        internal static int ToInt32(byte[] v, ref int position)
        {
            if (position + INT_LENGTH > v.Length || position < 0)
                return 0;

            return (v[position++] << 24) + (v[position++] << 16) + (v[position++] << 8) + v[position++];
        }
    }
}
