﻿namespace Butterfly.Messages.IOCodes
{
   class OutputCode
    {
        internal static readonly ushort Empty = 0;
        internal static readonly ushort SWFVersionCheck = 4000;
        internal static readonly ushort UserObjectEvent = Outgoing.ProfileInformation;
        internal static readonly ushort CreditBalanceEvent = Outgoing.CreditsBalance;
        internal static readonly ushort MessengerInitEvent = Outgoing.InitFriends;
        internal static readonly ushort FriendListUpdateEvent = Outgoing.FriendUpdate;
        internal static readonly ushort CloseConnectionMessageEvent = Outgoing.OutOfRoom;
        internal static readonly ushort ChatMessageEvent = Outgoing.Talk;
        internal static readonly ushort WhisperMessageEvent = Outgoing.Whisp;
        internal static readonly ushort ShoutMessageEvent = Outgoing.Shout;
        internal static readonly ushort FloodControlMessageEvent = Outgoing.FloodFilter;
        internal static readonly ushort UsersMessageEvent = Outgoing.SetRoomUser;
        internal static readonly ushort UserRemoveMessageEvent = Outgoing.UserLeftRoom;
        internal static readonly ushort HeightMapMessageEvent = Outgoing.HeightMap;
        internal static readonly ushort ObjectsMessageEvent = Outgoing.SerializeFloorItems;
        internal static readonly ushort GenericErrorEvent = Outgoing.RoomError;
        internal static readonly ushort UserUpdateMessageEvent = Outgoing.UpdateState;
        internal static readonly ushort ApproveNameMessageEvent = Outgoing.CheckPetName;
        internal static readonly ushort FlatAccessibleMessageEvent = Outgoing.ValidDoorBell;
        internal static readonly ushort YouAreControllerMessageEvent = Outgoing.RoomRightsLevel;
        internal static readonly ushort ItemsMessageEvent = Outgoing.SerializeWallItems;
        internal static readonly ushort RoomPropertyMessageEvent = Outgoing.RoomDecoration;
        internal static readonly ushort YouAreOwnerMessageEvent = Outgoing.HasOwnerRights;
        internal static readonly ushort ItemDataUpdateMessageEvent = Outgoing.OpenPostIt;
        internal static readonly ushort PingMessageEvent = Outgoing.Ping;
        internal static readonly ushort FlatCreatedEvent = Outgoing.OnCreateRoomInfo;
        internal static readonly ushort PurchaseOKMessageEvent = Outgoing.SerializePurchaseInformation;
        internal static readonly ushort RoomReadyMessageEvent = Outgoing.InitialRoomInformation;
        internal static readonly ushort GiftReceiverNotFoundEvent = Outgoing.GiftError;
        internal static readonly ushort ItemAddMessageEvent = Outgoing.UpdateWallItemOnRoom;
        internal static readonly ushort ItemWallAddMessageEvent = Outgoing.AddWallItemToRoom;
        internal static readonly ushort ItemRemoveMessageEvent = Outgoing.PickUpWallItem;
        internal static readonly ushort ItemUpdateMessageEvent = Outgoing.UpdateWallItemOnRoom;
        internal static readonly ushort ObjectDataUpdateMessageEvent = Outgoing.UpdateFloorItemExtraData;
        internal static readonly ushort DoorbellMessageEvent = Outgoing.Doorbell;
        internal static readonly ushort ObjectAddMessageEvent = Outgoing.AddFloorItemToRoom;
        internal static readonly ushort ObjectRemoveMessageEvent = Outgoing.PickUpFloorItem;
        internal static readonly ushort ObjectUpdateMessageEvent = Outgoing.UpdateItemOnRoom;
        internal static readonly ushort FurniListRemoveEvent = Outgoing.RemoveObjectFromInventory;
        internal static readonly ushort FurniListUpdateEvent = Outgoing.UpdateInventary;
        internal static readonly ushort TradingOpenEvent = Outgoing.TradeStart;
        internal static readonly ushort TradingItemListEvent = Outgoing.TradeUpdate;
        internal static readonly ushort TradingAcceptEvent = Outgoing.TradeAcceptUpdate;
        internal static readonly ushort TradingCloseEvent = Outgoing.TradeClose;
        internal static readonly ushort TradingConfirmationEvent = Outgoing.TradeComplete;
        internal static readonly ushort TradingCompletedEvent = Outgoing.TradeCloseClean;
        internal static readonly ushort CatalogIndexMessageEvent = Outgoing.OpenShop;
        internal static readonly ushort CatalogPageMessageEvent = Outgoing.OpenShopPage;
        internal static readonly ushort PresentOpenedMessageEvent = Outgoing.OpenGift;
        internal static readonly ushort NewBuddyRequestEvent = Outgoing.SendFriendRequest;
        internal static readonly ushort NewConsoleMessageEvent = Outgoing.InstantChat;
        internal static readonly ushort RoomInviteEvent = Outgoing.InstantInvite;
        internal static readonly ushort HabboBroadcastMessageEvent = Outgoing.BroadcastMessage;
        internal static readonly ushort FurniListEvent = Outgoing.Inventory;
        internal static readonly ushort ModMessageEvent = Outgoing.SendNotif;
        internal static readonly ushort HeightMapUpdateMessageEvent = Outgoing.UpdateInventary;
        internal static readonly ushort UserFlatCatsEvent = Outgoing.FlatCats;
        internal static readonly ushort CantConnectMessageEvent = Outgoing.RoomErrorToEnter;
        internal static readonly ushort HabboUserBadgesMessageEvent = Outgoing.UpdateBadges;
        internal static readonly ushort BadgesEvent = Outgoing.BadgesInventory;
        internal static readonly ushort SlideObjectBundleMessageEvent = Outgoing.ObjectOnRoller;
        internal static readonly ushort InstantMessageErrorEvent = Outgoing.InstantChatError;
        internal static readonly ushort UserChangeMessageEvent = Outgoing.UpdateUserInformation;
        internal static readonly ushort WardrobeMessageEvent = Outgoing.WardrobeData;
        internal static readonly ushort RoomForwardMessageEvent = Outgoing.FollowBuddy;
        internal static readonly ushort AvailabilityStatusMessageEvent = Outgoing.bools1;
        internal static readonly ushort BuddyRequestsEvent = Outgoing.InitRequests;
        internal static readonly ushort RoomRatingEvent = Outgoing.ScoreMeter;
        internal static readonly ushort UserTagsMessageEvent = Outgoing.GetUserTags;
        internal static readonly ushort UserTypingMessageEvent = Outgoing.TypingStatus;
        internal static readonly ushort RoomDimmerPresetsMessageEvent = Outgoing.DimmerData;
        internal static readonly ushort CanCreateRoomEventEvent = Outgoing.CanCreateEvent;
        internal static readonly ushort RoomEventEvent = Outgoing.RoomEvent;
        internal static readonly ushort IgnoreResultMessageEvent = Outgoing.UpdateIgnoreStatus;
        internal static readonly ushort HabboSearchResultEvent = Outgoing.SearchFriend;
        internal static readonly ushort AchievementsEvent = Outgoing.AchievementList;
        internal static readonly ushort HabboAchievementNotificationMessageEvent = Outgoing.UnlockAchievement;
        internal static readonly ushort HabboActivityPointNotificationMessageEvent = Outgoing.ActivityPoints;
        internal static readonly ushort RespectNotificationMessageEvent = Outgoing.GiveRespect;
        internal static readonly ushort CatalogPublishedMessageEvent = Outgoing.UpdateShop;
        internal static readonly ushort AchievementsScoreEvent = Outgoing.AchievementPoints;
        internal static readonly ushort OfficialRoomsEvent = Outgoing.SerializePublicRooms;
        internal static readonly ushort GuestRoomSearchResultEvent = Outgoing.NavigatorPacket;
        internal static readonly ushort PopularRoomTagsResultEvent = Outgoing.PopularTags;
        internal static readonly ushort GetGuestRoomResultEvent = Outgoing.RoomData;
        internal static readonly ushort NavigatorSettingsEvent = Outgoing.HomeRoom;
        internal static readonly ushort FavouritesEvent = Outgoing.FavouriteRooms;
        internal static readonly ushort FavouriteChangedEvent = Outgoing.FavsUpdate;
        internal static readonly ushort AvatarEffectsMessageEvent = Outgoing.EffectsInventary;
        internal static readonly ushort AvatarEffectAddedMessageEvent = Outgoing.AddEffectToInventary;
        internal static readonly ushort AvatarEffectActivatedMessageEvent = Outgoing.EnableEffect;
        internal static readonly ushort AvatarEffectExpiredMessageEvent = Outgoing.StopEffect;
        internal static readonly ushort RoomSettingsDataEvent = Outgoing.RoomDataEdit;
        internal static readonly ushort RoomSettingsSavedEvent = Outgoing.UpdateRoomOne;
        internal static readonly ushort FloorHeightMapMessageEvent = Outgoing.RelativeMap;
        internal static readonly ushort RoomEntryInfoMessageEvent = Outgoing.ValidRoom;
        internal static readonly ushort RoomVisualizationSettingsEvent = Outgoing.ConfigureWallandFloor;
        internal static readonly ushort DanceMessageEvent = Outgoing.Dance;
        internal static readonly ushort WaveMessageEvent = Outgoing.Action;
        internal static readonly ushort CarryObjectMessageEvent = Outgoing.RespectPet;
        internal static readonly ushort AvatarEffectMessageEvent = Outgoing.ApplyEffects;
        internal static readonly ushort SleepMessageEvent = Outgoing.IdleStatus;
        internal static readonly ushort FlatControllerAddedEvent = Outgoing.GivePowers;
        internal static readonly ushort FlatControllerRemovedEvent = Outgoing.RemovePowers;
        internal static readonly ushort CanCreateRoomEvent = Outgoing.CanCreateRoom;
        internal static readonly ushort FaqClientFaqsMessageEvent = Outgoing.OpenHelpTool;
        internal static readonly ushort AllowancesMessageEvent = Outgoing.Allowances;
        internal static readonly ushort IssueInfoMessageEvent = Outgoing.SerializeIssue;
        internal static readonly ushort ModeratorInitMessageEvent = Outgoing.OpenModTools;
        internal static readonly ushort ModeratorUserInfoEvent = Outgoing.UserTool;
        internal static readonly ushort CfhChatlogEvent = Outgoing.IssueChatlog;
        internal static readonly ushort UserChatlogEvent = Outgoing.UserChatlog;
        internal static readonly ushort ModeratorRoomInfoEvent = Outgoing.RoomTool;
        internal static readonly ushort IssueCloseNotificationMessageEvent = Outgoing.ModResponse;
        internal static readonly ushort PetInventoryEvent = Outgoing.PetInventory;
        internal static readonly ushort PetInfoMessageEvent = Outgoing.PetInformation;
        internal static readonly ushort PetRespectNotificationEvent = Outgoing.RespectPet;
        internal static readonly ushort PetExperienceEvent = Outgoing.AddExperience;
        internal static readonly ushort MarketplaceConfigurationEvent = Outgoing.ShopData1;
        internal static readonly ushort GiftWrappingConfigurationEvent = Outgoing.ShopData2;
        internal static readonly ushort WiredFurniTriggerEvent = Outgoing.WiredTrigger;
        internal static readonly ushort WiredFurniActionEvent = Outgoing.WiredEffect;
        internal static readonly ushort WiredFurniConditionEvent = Outgoing.WiredCondition;
        internal static readonly ushort GamePlayerValueMessageEvent = Outgoing.UpdateFreezeLives;
        internal static readonly ushort MOTDNotificationEvent = Outgoing.SendNotif;
        internal static readonly ushort SellablePetBreedsMessageEvent = Outgoing.PetRace;
        internal static readonly ushort AchievementEvent = Outgoing.AchievementProgress;
        internal static readonly ushort AuthenticationOKMessageEvent = Outgoing.AuthenticationOK;
        internal static readonly ushort SendBannerMessageComposer = Outgoing.SendBannerMessageComposer;
        internal static readonly ushort SecretKeyComposer = Outgoing.SecretKeyComposer;
        internal static readonly ushort AuthenticationOK = Outgoing.AuthenticationOK;
        internal static readonly ushort UniqueIDEvent = Outgoing.UniqueID;
        internal static readonly ushort AuthenticationOKEvent = Outgoing.AuthenticationOK;
        internal static readonly ushort ClubComposerMessageEvent = Outgoing.ClubComposer;
        internal static readonly ushort OfferEvent = Outgoing.Offer;
        internal static readonly ushort FuserightEvent = Outgoing.Fuserights;
        internal static readonly ushort GetPowerList = Outgoing.GetPowerList;
        internal static readonly ushort GetOwnUserInfoEvent = Outgoing.HabboInfomation;
        internal static readonly ushort SerializeClub = Outgoing.SerializeClub;
        internal static readonly ushort PetUpdateEvent = Outgoing.SerializeMontura;
        internal static readonly ushort FlatAccessDeniedMessageEvent = Outgoing.DoorBellNoPerson;
        internal static readonly ushort ScrollNotification = Outgoing.SetCommandsView;
        internal static readonly ushort MarketplaceCanMakeOfferResult = Outgoing.CanSell;
        internal static readonly ushort MarketplaceCancelOfferResultEvent = Outgoing.QuitMarket;
        internal static readonly ushort MarketplaceAddMarket = Outgoing.UpdateInventary;
        internal static readonly ushort MarketplaceMakeOfferResult = Outgoing.AddMarket;
        internal static readonly ushort MarketPlaceOffersEvent = Outgoing.GetOffers;
        internal static readonly ushort MarketPlaceOwnOffersEvent = Outgoing.MySells;
        internal static readonly ushort BuyItemMarket = Outgoing.BuyItemMarket;
        internal static readonly ushort SendPurchaseAlert = Outgoing.SendPurchaseAlert;
        internal static readonly ushort SaveWired = Outgoing.SaveWired;
        internal static readonly ushort CallForHelpResultMessageEvent = Outgoing.HelpRequestAlert;
    }

   #region BCStorm code
   public static class Outgoing
   {
       internal static ushort SendBannerMessageComposer;
       internal static ushort SecretKeyComposer;
       internal static ushort Ping;
       internal static ushort AuthenticationOK;
       internal static ushort RoomMuteAllOut;
       internal static ushort HomeRoom;
       internal static ushort FavouriteRooms;
       internal static ushort FavsUpdate;
       internal static ushort Fuserights;
       internal static ushort bools1;
       internal static ushort EndTalentPractise;
       internal static ushort SendAllowances;
       internal static ushort CitizenshipPanel;
       internal static ushort LoadQuiz;
       internal static ushort WelcomeUser;
       internal static ushort CheckQuiz;
       internal static ushort ActivityPoints;
       internal static ushort CreditsBalance;
       internal static ushort UniqueID;
       internal static ushort HabboInfomation;
       internal static ushort ProfileInformation;
       internal static ushort Allowances;
       internal static ushort AchievementPoints;
       internal static ushort SerializePublicRooms;
       internal static ushort NavigatorPacket;
       internal static ushort OpenShop;
       internal static ushort OpenShopPage;
       internal static ushort ShopData1;
       internal static ushort ShopData2;
       internal static ushort Offer;
       internal static ushort PetRace;
       internal static ushort CheckPetName;
       internal static ushort UpdateShop;
       internal static ushort AchievementList;
       internal static ushort AchievementProgress;
       internal static ushort UnlockAchievement;
       internal static ushort OpenModTools;
       internal static ushort SendNotif;
       internal static ushort ModResponse;
       internal static ushort BroadcastMessage;
       internal static ushort SerializeMontura;
       internal static ushort GiftError;
       internal static ushort UpdateInventary;
       internal static ushort SerializePurchaseInformation;
       internal static ushort SendPurchaseAlert;
       internal static ushort PublicCategories;
       internal static ushort EffectsInventary;
       internal static ushort AddEffectToInventary;
       internal static ushort EnableEffect;
       internal static ushort StopEffect;
       internal static ushort OpenHelpTool;
       internal static ushort CanCreateRoom;
       internal static ushort OnCreateRoomInfo;
       internal static ushort RoomDataEdit;
       internal static ushort UpdateRoomOne;
       internal static ushort RoomAds;
       internal static ushort PrepareRoomForUsers;
       internal static ushort RoomErrorToEnter;
       internal static ushort OutOfRoom;
       internal static ushort RoomError;
       internal static ushort DoorBellNoPerson;
       internal static ushort Doorbell;
       internal static ushort ValidDoorBell;
       internal static ushort InitFriends;
       internal static ushort InitRequests;
       internal static ushort SendFriendRequest;
       internal static ushort FriendUpdate;
       internal static ushort InstantChat;
       internal static ushort InstantInvite;
       internal static ushort InstantChatError;
       internal static ushort InitialRoomInformation;
       internal static ushort FollowBuddy;
       internal static ushort FollowBuddyError;
       internal static ushort SearchFriend;
       internal static ushort TradeStart;
       internal static ushort TradeUpdate;
       internal static ushort TradeAcceptUpdate;
       internal static ushort TradeComplete;
       internal static ushort TradeCloseClean;
       internal static ushort TradeClose;
       internal static ushort RoomDecoration;
       internal static ushort RoomRightsLevel;
       internal static ushort QuitRights;
       internal static ushort HasOwnerRights;
       internal static ushort RateRoom;
       internal static ushort ScoreMeter;
       internal static ushort CanCreateEvent;
       internal static ushort RoomEvent;
       internal static ushort HeightMap;
       internal static ushort RelativeMap;
       internal static ushort OpenGift;
       internal static ushort SerializeFloorItems;
       internal static ushort SerializeWallItems;
       internal static ushort FloodFilter;
       internal static ushort SetRoomUser;
       internal static ushort ConfigureWallandFloor;
       internal static ushort ValidRoom;
       internal static ushort RoomData;
       internal static ushort UpdateState;
       internal static ushort SerializeClub;
       internal static ushort ClubComposer;
       internal static ushort PopularTags;
       internal static ushort FlatCats;
       internal static ushort Talk;
       internal static ushort Shout;
       internal static ushort Whisp;
       internal static ushort UpdateIgnoreStatus;
       internal static ushort GiveRespect;
       internal static ushort PrepareCampaing;
       internal static ushort SendCampaingData;
       internal static ushort UpdateUserInformation;
       internal static ushort Dance;
       internal static ushort Action;
       internal static ushort IdleStatus;
       internal static ushort Inventory;
       internal static ushort PetInventory;
       internal static ushort PlaceBot;
       internal static ushort PetInformation;
       internal static ushort RespectPet;
       internal static ushort AddExperience;
       internal static ushort BadgesInventory;
       internal static ushort UpdateBadges;
       internal static ushort GetUserBadges;
       internal static ushort GetUserTags;
       internal static ushort GivePowers;
       internal static ushort RemovePowers;
       internal static ushort GetPowerList;
       internal static ushort TypingStatus;
       internal static ushort RemoveObjectFromInventory;
       internal static ushort AddFloorItemToRoom;
       internal static ushort AddWallItemToRoom;
       internal static ushort UpdateItemOnRoom;
       internal static ushort UpdateWallItemOnRoom;
       internal static ushort UpdateFloorItemExtraData;
       internal static ushort PickUpFloorItem;
       internal static ushort PickUpWallItem;
       internal static ushort WiredTrigger;
       internal static ushort WiredEffect;
       internal static ushort WiredCondition;
       internal static ushort SaveWired;
       internal static ushort UserLeftRoom;
       internal static ushort RoomTool;
       internal static ushort UserTool;
       internal static ushort RoomChatlog;
       internal static ushort UserChatlog;
       internal static ushort RoomVisits;
       internal static ushort IssueChatlog;
       internal static ushort SerializeIssue;
       internal static ushort UpdateIssue;
       internal static ushort ApplyEffects;
       internal static ushort ApplyCarryItem;
       internal static ushort ObjectOnRoller;
       internal static ushort DimmerData;
       internal static ushort OpenPostIt;
       internal static ushort UpdateFreezeLives;
       internal static ushort InRoomGameStatus;
       internal static ushort WardrobeData;
       internal static ushort HelpRequest;
       internal static ushort SerializeCompetitionWinners;
       internal static ushort InitStream;
       internal static ushort SetCommandsView;
       internal static ushort PetTrainPanel;
       internal static ushort LoadQuests;
       internal static ushort ActivateQuest;
       internal static ushort QuitAlertQ;
       internal static ushort CompleteQuests;
       internal static ushort GetName;
       internal static ushort CheckName;
       internal static ushort ChangePublicName;
       internal static ushort UpdateRoom;
       internal static ushort CanSell;
       internal static ushort AddMarket;
       internal static ushort MySells;
       internal static ushort QuitMarket;
       internal static ushort GetOffers;
       internal static ushort BuyItemMarket;
       internal static ushort AddMarket2;
       internal static ushort ListenPreviewSong;
       internal static ushort SerializeInvSongs;
       internal static ushort SerializeJukeSongs;
       internal static ushort PlayStopMusic;
       internal static ushort SendGuildParts;
       internal static ushort SendGuildElements;
       internal static ushort SendHtmlColors;
       internal static ushort SendRoomAndGroup;
       internal static ushort SendAdvGroupInit;
       internal static ushort SendGestionGroup;
       internal static ushort SendMembersAndPetitions;
       internal static ushort AddNewMember;
       internal static ushort UpdatePetitionsGuild;
       internal static ushort SendGroup;
       internal static ushort RemoveGuildFavorite;
       internal static ushort GetRankInGame;
       internal static ushort CreateWar;
       internal static ushort AddToNewGame;
       internal static ushort LeaveGame;
       internal static ushort StartCounter;
       internal static ushort SetStep1;
       internal static ushort Game2EnterArenaMessageEvent;
       internal static ushort Game2ArenaEnteredMessageEvent;
       internal static ushort Game2StageStillLoadingMessageEvent;
       internal static ushort Game2StageLoadMessageEvent;
       internal static ushort Game2StageStartingMessageEvent;
       internal static ushort Game2GameChatFromPlayerMessageEvent;
       internal static ushort Game2StageRunningMessageEvent;
       internal static ushort Game2PlayerExitedGameArenaMessageEvent;
       internal static ushort Game2GameStatusMessageEvent;
       internal static ushort ProfileRelationships;
       internal static ushort SendRoomForCata;
       internal static ushort Recycle;
       internal static ushort RecycleState;
       internal static ushort BotInventory;
       internal static ushort SerializeSpeechList;
       internal static ushort HelpRequestAlert;
       internal static ushort CitizenshipProgress;
       internal static ushort OpenGamesTab;
       internal static ushort RecyclePrizeList;
       static Outgoing()//  //b = updated
       {
           Outgoing.OpenGamesTab = 664; //ak
           Outgoing.HelpRequestAlert = 3027; //ak
           Outgoing.InRoomGameStatus = 3390; //ak
           Outgoing.CitizenshipProgress = 1795; //ak
           Outgoing.Ping = 2940;//b
           Outgoing.HomeRoom = 854;//ak
           Outgoing.FavouriteRooms = 1135; //ak
           Outgoing.FavsUpdate = 2015;//b
           Outgoing.Fuserights = 325;//b
           Outgoing.bools1 = 2326;//b
           Outgoing.EndTalentPractise = 6589;//b
           Outgoing.SendAllowances = 2680;//b
           Outgoing.CitizenshipPanel = 3372;//b
           Outgoing.LoadQuiz = 3539;//b
           Outgoing.CheckQuiz = 3623;//ak
           Outgoing.ProfileInformation = 3330;//b
           Outgoing.ProfileRelationships = 3570;//ak
           Outgoing.Allowances = 709;//b
           Outgoing.AchievementPoints = 2657;//b
           Outgoing.SerializePublicRooms = 1969;//b
           Outgoing.NavigatorPacket = 1019;//ak
           Outgoing.SendRoomForCata = 78;//b
           Outgoing.OpenShop = 3845;//b si
           Outgoing.OpenShopPage = 3379;//b
           Outgoing.ShopData1 = 747;//b si
           Outgoing.ShopData2 = 2642;//b si
           Outgoing.Offer = 366;//b
           Outgoing.PetRace = 714;//b
           Outgoing.CheckPetName = 204;//b
           Outgoing.UpdateShop = 2879;//b
           Outgoing.Recycle = 3668;//b
           Outgoing.RecycleState = 3997;//b
           Outgoing.RecyclePrizeList = 1878; //ak
           Outgoing.AchievementList = 1432;//b
           Outgoing.AchievementProgress = 1581;//b
           Outgoing.UnlockAchievement = 653;//b
           Outgoing.OpenModTools = 3563;//b
           Outgoing.SendNotif = 700; //ak
           Outgoing.ModResponse = 1991;//b
           Outgoing.BroadcastMessage = 193;//b
           Outgoing.SerializeMontura = 1159; //ak
           Outgoing.GiftError = 2403; //ak
           Outgoing.UpdateInventary = 1507;//b
           Outgoing.SerializePurchaseInformation = 2434;//b
           Outgoing.SendPurchaseAlert = 1860;//1642
           Outgoing.PublicCategories = 1969;//b
           Outgoing.EffectsInventary = 631;//b
           Outgoing.AddEffectToInventary = 2347;//ak
           Outgoing.EnableEffect = 2803;//b
           Outgoing.StopEffect = 1176;//b
           Outgoing.OpenHelpTool = 3466;//b
           Outgoing.CanCreateRoom = 3710;//b
           Outgoing.OnCreateRoomInfo = 2897;//b
           Outgoing.RoomDataEdit = 3367;//b
           Outgoing.UpdateRoomOne = 3713;//b
           Outgoing.RoomAds = 1475; //ak - not used
           Outgoing.PrepareRoomForUsers = 444;// ak
           Outgoing.RoomErrorToEnter = 1819;//b
           Outgoing.OutOfRoom = 1256;//b
           Outgoing.RoomError = 1671;//b
           Outgoing.DoorBellNoPerson = 436;//b
           Outgoing.Doorbell = 2063;//b
           Outgoing.ValidDoorBell = 400;//b
           Outgoing.InitFriends = 1800;//b
           Outgoing.InitRequests = 3540;//b
           Outgoing.SendFriendRequest = 1964;//b
           Outgoing.FriendUpdate = 1710;//b
           Outgoing.InstantChat = 2747;//b
           Outgoing.InstantInvite = 2925;//b
           Outgoing.InstantChatError = 3945;//b
           Outgoing.RoomMuteAllOut = 2132;//b  
           Outgoing.InitialRoomInformation = 206;//b
           Outgoing.FollowBuddy = 1959;//b
           Outgoing.FollowBuddyError = 809;//b
           Outgoing.SearchFriend = 1788;//b
           Outgoing.SerializeSpeechList = 20; //ak
           Outgoing.TradeAcceptUpdate = 299;//ak
           Outgoing.TradeComplete = 2557;//ak
           Outgoing.TradeStart = 2185;//ak
           Outgoing.TradeCloseClean = 387;//ak
           Outgoing.TradeClose = 2024;//ak
           Outgoing.TradeUpdate = 1386;//ak

           Outgoing.RoomDecoration = 2993;//b
           Outgoing.RoomRightsLevel = 8;//b
           Outgoing.QuitRights = 3185;//ak
           Outgoing.HasOwnerRights = 1812;//b
           Outgoing.RateRoom = 3710; //ak
           Outgoing.ScoreMeter = 978;//b
           Outgoing.CanCreateEvent = 2099;
           Outgoing.RoomEvent = 743;
           Outgoing.HeightMap = 3942;//b
           Outgoing.RelativeMap = 2443;//b
           Outgoing.OpenGift = 1208;
           Outgoing.SerializeFloorItems = 2087;//b
           Outgoing.SerializeWallItems = 1348;//b
           Outgoing.FloodFilter = 3410;//b
           Outgoing.SetRoomUser = 610;//b
           Outgoing.ConfigureWallandFloor = 752;//b
           Outgoing.ValidRoom = 1873;//b
           Outgoing.RoomData = 2456;//b
           Outgoing.UpdateState = 1387;//b (a= 2397)
           Outgoing.SerializeClub = 319;//b
           Outgoing.ClubComposer = 2677;//b
           Outgoing.PopularTags = 257;//b
           Outgoing.FlatCats = 1154;
           Outgoing.Talk = 1510;//b
           Outgoing.Shout = 2408;//b
           Outgoing.Whisp = 2732;//b
           Outgoing.UpdateIgnoreStatus = 2288;//b
           Outgoing.GiveRespect = 123;//b
           Outgoing.PrepareCampaing = 769;//b
           Outgoing.SendCampaingData = 2680;//b
           Outgoing.UpdateUserInformation = 2859;//b (14 era 421)
           Outgoing.Dance = 732;//b
           Outgoing.Action = 3984;//b
           Outgoing.IdleStatus = 3689;//b
           Outgoing.Inventory = 3572;//b
           Outgoing.PetInventory = 2304;//b
           Outgoing.PlaceBot = 610;//b
           Outgoing.PetInformation = 2135;//b
           Outgoing.RespectPet = 3395;//b
           Outgoing.AddExperience = 1559;//b
           Outgoing.BadgesInventory = 2356;//b
           Outgoing.UpdateBadges = 833;//b
           Outgoing.GetUserBadges = 833;//b
           Outgoing.GetUserTags = 1574; //ak
           Outgoing.GivePowers = 3158; //ak
           Outgoing.RemovePowers = 3702; //ak
           Outgoing.GetPowerList = 2532; //ak
           Outgoing.TypingStatus = 3218;//b
           Outgoing.RemoveObjectFromInventory = 238;//b
           Outgoing.AddFloorItemToRoom = 3076;//b
           Outgoing.AddWallItemToRoom = 1382;//b
           Outgoing.UpdateItemOnRoom = 3510;//b
           Outgoing.UpdateWallItemOnRoom = 893;//b
           Outgoing.UpdateFloorItemExtraData = 1194;//b
           Outgoing.PickUpFloorItem = 1891;//b
           Outgoing.PickUpWallItem = 1317;//b
           Outgoing.WiredTrigger = 639;//b
           Outgoing.WiredEffect = 1843;//b
           Outgoing.WiredCondition = 3987;//b
           Outgoing.SaveWired = 2992;//b
           Outgoing.UserLeftRoom = 3359;//b
           Outgoing.RoomTool = 2954;//b
           Outgoing.UserTool = 3282;//b
           Outgoing.RoomChatlog = 3619;//b
           Outgoing.UserChatlog = 2981;//b
           Outgoing.RoomVisits = 683;//b
           Outgoing.IssueChatlog = 951;//b
           Outgoing.SerializeIssue = 2740;//b
           Outgoing.UpdateIssue = 993;//b
           Outgoing.ApplyEffects = 3194;//b
           Outgoing.ApplyCarryItem = 3395;//b
           Outgoing.ObjectOnRoller = 106;//b
           Outgoing.DimmerData = 418;//b
           Outgoing.OpenPostIt = 3086;//b
           Outgoing.UpdateFreezeLives = 839;//ak
           Outgoing.WardrobeData = 3255;//b
           Outgoing.HelpRequest = 2553;//b
           Outgoing.SerializeCompetitionWinners = 2945;//b
           //questi sono per ora inutili
           Outgoing.InitStream = 1973;//b
           Outgoing.SetCommandsView = 367;//b
           Outgoing.PetTrainPanel = 2775;//b
           Outgoing.LoadQuests = 2243;//b
           Outgoing.ActivateQuest = 1690;//b
           Outgoing.QuitAlertQ = 1358;//b
           Outgoing.CompleteQuests = 2447;//b
           Outgoing.GetName = 2560;//b probabile 0x0A00
           Outgoing.CheckName = 1770;//b
           Outgoing.ChangePublicName = 2832;//b
           Outgoing.UpdateRoom = 1066;//b
           Outgoing.CanSell = 1254;//b
           Outgoing.AddMarket = 1210;//b
           Outgoing.MySells = 1859;//b
           Outgoing.QuitMarket = 1766;//b
           Outgoing.GetOffers = 2272;//b
           Outgoing.BuyItemMarket = 241;//b
           Outgoing.AddMarket2 = 3586;//outdated,  not gonna deal with marketplaces. Useless stuff IMO
           Outgoing.ListenPreviewSong = 2289;//b
           Outgoing.SerializeInvSongs = 3381;//b
           Outgoing.SerializeJukeSongs = 995;//b
           Outgoing.PlayStopMusic = 216;//ak
           Outgoing.SendGuildParts = 1061;//b
           Outgoing.SendGuildElements = 29;//b
           Outgoing.SendHtmlColors = 2049;//b
           Outgoing.SendRoomAndGroup = 1644;//b
           Outgoing.SendAdvGroupInit = 3225;//b
           Outgoing.SendGestionGroup = 858;//b
           Outgoing.SendMembersAndPetitions = 326;//b
           Outgoing.AddNewMember = 2418; //ak
           Outgoing.UpdatePetitionsGuild = 1647;//b
           Outgoing.SendGroup = 2119;//b
           Outgoing.RemoveGuildFavorite = 1662;//b
           Outgoing.GetRankInGame = 1414;
           Outgoing.CreateWar = 2737;
           Outgoing.AddToNewGame = 2200;
           Outgoing.LeaveGame = 3543;
           Outgoing.StartCounter = 2155;
           Outgoing.SetStep1 = 3828;
           Outgoing.Game2EnterArenaMessageEvent = 811;
           Outgoing.Game2ArenaEnteredMessageEvent = 2312;
           Outgoing.Game2StageStillLoadingMessageEvent = 1048;
           Outgoing.Game2StageLoadMessageEvent = 1125;
           Outgoing.Game2StageStartingMessageEvent = 2942;
           Outgoing.Game2GameChatFromPlayerMessageEvent = 483;
           Outgoing.Game2StageRunningMessageEvent = 2975;
           Outgoing.Game2PlayerExitedGameArenaMessageEvent = 2050;
           Outgoing.Game2GameStatusMessageEvent = 275;
           Outgoing.BotInventory = 1294; //ak -- TESTAR TODOS OS DE INVENTARIO ATE FUNCIONAR !
           //
           Outgoing.SendBannerMessageComposer = 889; //ak
           Outgoing.SecretKeyComposer = 3489; //ak
           Outgoing.AuthenticationOK = 2008; //ak
           Outgoing.ActivityPoints = 1271; //ak
           Outgoing.CreditsBalance = 3412; //ak
           Outgoing.UniqueID = 1212; //ak
           Outgoing.HabboInfomation = 178; //ak
           Outgoing.SendPurchaseAlert = 469; //ak
           Outgoing.FlatCats = 224; //ak
           Outgoing.WelcomeUser = 2933; //ak
           //
       }
   }
   #endregion
}
