﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages.MessageHandling.MessageArgs
{
    struct AdminRoomUserMessageArgs : IMessageArgs
    {
        private GameClient session;
        private bool allowsExecution;
        internal Room Room;
        internal RoomUser RoomUser;

        public AdminRoomUserMessageArgs(GameClient session)
        {
            this.session = session;
            this.RoomUser = null;
            this.allowsExecution = false;
            this.Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room != null)
            {
                this.allowsExecution = Room.CheckRights(session, true);
                this.RoomUser = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);
            }

            if (Room == null || RoomUser == null || !allowsExecution)
                allowsExecution = false;
        }
        
        public GameClient Session
        {
            get
            {
                return session;
            }
        }

        public bool AllowsExecution
        {
            get
            {
                return allowsExecution;
            }
        }
    }
}
