﻿using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages.MessageHandling.MessageArgs
{
    struct ElevatedUserRoomMessageArgs : IMessageArgs
    {
        private GameClient session;
        private bool allowsExecution;
        internal Room Room;

        public ElevatedUserRoomMessageArgs(GameClient session)
        {
            this.session = session;
            this.Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);
            this.allowsExecution = (Room != null && Room.CheckRights(session, false));
        }
        
        public GameClient Session
        {
            get
            {
                return session;
            }
        }

        public bool AllowsExecution
        {
            get
            {
                return allowsExecution;
            }
        }
    }
}
