﻿using ConnectivityAsync;

namespace Butterfly.Messages.Parsing
{
    public class InitialPacketParser : IDataParser
    {
        public delegate void NoParamDelegate();
        public delegate void DualparamDelegate(byte[] data, int amountOfBytes);

        public event NoParamDelegate PolicyRequest;
        public event DualparamDelegate SwitchParserRequest;

        public void handlePacketData(byte[] packet, int bytes)
        {
            if (packet[0] == 60 && PolicyRequest != null)
                PolicyRequest.Invoke();
            else if (packet[0] != 67 && SwitchParserRequest != null)
                SwitchParserRequest.Invoke(packet, bytes);
        }

        public void Dispose()
        {
            this.PolicyRequest = null;
            this.SwitchParserRequest = null;
        }

        public object Clone()
        {
            return new InitialPacketParser();
        }
    }
}
