using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class AddSaddleMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint itemID = request.ReadUInt();
            uint petID = request.ReadUInt();

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || (!Room.AllowPets && !Room.CheckRights(session, true)))
                return;

            RoomUser petUser = Room.GetRoomUserManager().GetPet(petID);

            RoomItem Item = Room.GetRoomItemHandler().GetItem(itemID);
            if (Item == null)
                return;

            if (petUser == null || petUser.PetData == null || !Room.CheckRights(session, false))
                return;

            Room.GetRoomItemHandler().RemoveFurniture(session, Item.Id);

            if (Item.GetBaseItem().Name.Contains("horse_hairdye"))
            {
                string HairType = Item.GetBaseItem().Name.Split('_')[2];
                int HairDye = 48;
                HairDye = HairDye + int.Parse(HairType);
                petUser.PetData.hairDye = HairDye;

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE user_pets SET hair_dye = '" + petUser.PetData.hairDye + "' WHERE id = " + petUser.PetData.petID);
                }
            }
            else if (Item.GetBaseItem().Name.Contains("horse_dye"))
            {
                string Race = Item.GetBaseItem().Name.Split('_')[2];
                int Parse = int.Parse(Race);
                int RaceLast = 2 + (Parse * 4) - 4;
                if (Parse == 13)
                    RaceLast = 61;
                else if (Parse == 14)
                    RaceLast = 65;
                else if (Parse == 15)
                    RaceLast = 69;
                else if (Parse == 16)
                    RaceLast = 73;

                petUser.PetData.race = RaceLast.ToString();

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE user_pets SET race = '" + petUser.PetData.race + "' WHERE id = " + petUser.PetData.petID);
                }
            }
            else if (Item.GetBaseItem().Name.Contains("horse_hairstyle"))
            {
                string HairType = Item.GetBaseItem().Name.Split('_')[2];
                int Parse = 0;
                Parse = Parse + int.Parse(HairType);
                petUser.PetData.hairType = Parse;

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("UPDATE user_pets SET hair_type = '" + petUser.PetData.hairType + "' WHERE id = " + petUser.PetData.petID);
                }
            }
            else
            {
                petUser.gotSaddle = true;
                session.GetHabboDataContainer().GetInventoryComponent().AddNewItem(Item.Id, (ushort)Item.BaseItem, Item.ExtraData, true, true, 0);
                session.GetHabboDataContainer().GetInventoryComponent().UpdateItems(false);
            }

            petUser.PetData.OnRoomUpdate();
        }

    }
}