using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class CheckPetNameMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            ServerMessage response = PacketHandelingManager.GetRecycledItem(OutputCode.ApproveNameMessageEvent);

            string PetName = request.ReadString();
            int len = PetName.Length;
            if (len < 3)
            {
                response.AddInt32(2);
                response.AddString("3");
            }
            else if (len > 15)
            {
                response.AddInt32(1);
                response.AddString("15");
            }
            else if (!ValidPetNameChars(PetName.ToLower(), len))
            {
                response.AddInt32(3);
            }
            else
            {
                response.AddInt32(0);
            }
            response.AddString(string.Empty);

            session.SendMessage(response);
        }
        
        private static bool ValidPetNameChars(string inputStr, int HardCodedLen)
        {
        // To-do: Regex this
            for (int i = 0; i < HardCodedLen; i++)
            {
                if (i == 0)
                {
                    if (inputStr[i] == ' ')
                    {
                        return false;
                    }
                }
                if ((inputStr[i] < 'a' || inputStr[i] > 'z') && (inputStr[i] < '0' || inputStr[i] > '9'))
                {
                    return false;
                }
            }

            return true;
        }
    }
}