using Butterfly.Core;
using Butterfly.HabboHotel.Catalogs;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetCatalogPageMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            int test = request.ReadInt();
            CatalogPage Page = ButterflyEnvironment.Game.GetCatalog().GetPage(test);
            if (Page == null || !Page.Enabled || !Page.Visible || Page.ComingSoon || Page.MinRank > session.GetHabbo().Rank)
            {
                return;
            }

            if (Page.ClubOnly && !session.GetHabboDataContainer().GetSubscriptionManager().HasSubscription(SubscriptionManager.SUBSCRIPTION_TYPE_VIP))
            {
                session.SendNotif(LanguageLocale.GetValue("catalog.missingclubmembership"));
                return;
            }

            session.SendMessage(Page.GetMessage);

            //if (Page.Layout == "recycler")
            //{
            //    ServerMessage message = new ServerMessage(OutputCode.RecyclerStatusMessageEvent);
            //    message.AddBoolean(true);
            //    message.AddBoolean(false);
            //    Session.SendMessage(message);
            //}
            if (Page.Layout.Equals("club_buy"))
            {
                ServerMessage clubBuy = PacketHandelingManager.GetRecycledItem(OutputCode.ClubComposerMessageEvent);
                clubBuy.AddInt32(Page.Items.Values.Count);
                foreach (CatalogItem Item in Page.Items.Values)
                {
                    Item.SerializeClub(clubBuy, session);
                }
                clubBuy.AddInt32(1); // sorry don't know :(!
                session.SendMessage(clubBuy);
            }
        }

    }
}