using Butterfly.Core;
using Butterfly.HabboHotel.Catalogs;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Data;

namespace Butterfly.Messages
{
    class MarketplacePurchaseMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint ItemId = request.ReadUInt();
            DataRow Row = null;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT state, timestamp, total_price, extra_data, item_id, item_type FROM catalog_marketplace_offers WHERE offer_id = " + ItemId + " ");
                Row = dbClient.getRow();
            }

            if (Row == null || (string)Row["state"] != "1" || (double)Row["timestamp"] <= Marketplace.FormatTimestamp())
            {
                session.SendNotif(LanguageLocale.GetValue("catalog.offerexpired"));
                return;
            }

            Item Item = ButterflyEnvironment.Game.GetItemManager().GetItem(Convert.ToUInt32(Row["item_id"]));

            if (Item == null)
            {
                return;
            }

            int prize = (int)Row["total_price"];
            if ((int)Row["total_price"] >= 1)
            {
                session.GetHabbo().Credits -= prize;
                session.GetHabboDataContainer().UpdateCreditsBalance();
            }

            ButterflyEnvironment.Game.GetCatalog().DeliverItems(session, Item, 1, (String)Row["extra_data"]);
            session.GetHabboDataContainer().GetInventoryComponent().RunDBUpdate();

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE catalog_marketplace_offers SET state = 2 WHERE offer_id = " + ItemId + "");
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.BuyItemMarket);
            message.AddInt32(1);
            message.AddUInt32(ItemId);
            message.AddInt32(2);
            message.AddUInt32(ItemId);
            session.SendMessage(message);

            message = PacketHandelingManager.GetRecycledItem(OutputCode.SendPurchaseAlert);
            message.AddInt32(1);
            message.AddInt32((int)Row["item_type"]);
            message.AddInt32(0);
            message.AddUInt32(Item.ItemId);

            session.SendMessage(Marketplace.SerializeOffers(-1, -1, "", 1));
        }

    }
}