using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Data;

namespace Butterfly.Messages
{
    class MarketplaceTakeBackMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint ItemId = request.ReadUInt();
            DataRow Row = null;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT item_id, user_id, extra_data, offer_id, state FROM catalog_marketplace_offers WHERE offer_id = " + ItemId + " LIMIT 1");
                Row = dbClient.getRow();
            }

            if (Row == null || Convert.ToUInt32(Row["user_id"]) != session.GetHabbo().Id || (string)Row["state"] != "1")
            {
                return;
            }

            Item Item = ButterflyEnvironment.Game.GetItemManager().GetItem(Convert.ToUInt32(Row["item_id"]));

            if (Item == null)
            {
                return;
            }

            ButterflyEnvironment.Game.GetCatalog().DeliverItems(session, Item, 1, (String)Row["extra_data"]);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("DELETE FROM catalog_marketplace_offers WHERE offer_id = " + ItemId + "");
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.MarketplaceCancelOfferResultEvent);
            message.AddUInt32(ItemId);
            message.AddBoolean(true);
            session.SendMessage(message);

            message = PacketHandelingManager.GetRecycledItem(OutputCode.MarketplaceAddMarket);
            session.SendMessage(message);
        }

    }
}