using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Pets;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class PetRacesMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            string PetType = request.ReadString();
            int ID = int.Parse(PetType.Substring(6));

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.SellablePetBreedsMessageEvent);
            message.AddString(PetType);

            List<PetRace> races;
            if (PetRaceHandler.TryGetPetRace(TextHandling.Parse(PetType.Substring(6)), out races))
            {
                message.AddInt32(races.Count);
                foreach (PetRace race in races)
                {
                    message.AddInt32(race.petID);
                    message.AddInt32(race.colorPrimary);
                    message.AddInt32(race.colorSecondary);
                    message.AddBoolean(race.hasPrimaryColor);
                    message.AddBoolean(race.hasSecondaryColor);
                }
            }
            else
            {
                session.SendNotif(string.Format("{0} is an unknown pet type", PetType));
                message.AddInt32(0);
            }

            session.SendMessage(message);
        }
    }
}