using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class RemoveSaddleMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint petID = request.ReadUInt();

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || (!Room.AllowPets && !Room.CheckRights(session, true)))
                return;

            RoomUser petUser = Room.GetRoomUserManager().GetPet(petID);

            if (petUser == null || petUser.PetData == null || petUser.PetData.ownerID != session.GetHabbo().Id)
                return;

            petUser.gotSaddle = false;
        }

    }
}