using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class RideMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room currentRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (currentRoom == null)
            {
                return;
            }

            RoomUser currentRoomUser = currentRoom.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);
            if (currentRoomUser == null)
                return;

            uint PetId = request.ReadUInt();
            bool Type = request.ReadBool();
            RoomUser user = currentRoom.GetRoomUserManager().GetPet(PetId);

            if ((user == null && user.PetData == null) || user.PetData.petType != 15)
            {
                return;
            }

            if (!Type)
            {
                currentRoomUser.StopRide();
                currentRoomUser.GetClient().GetHabboDataContainer().GetAvatarEffectsInventoryComponent().ApplyCustomEffect(-1);

                currentRoomUser.AllowOverride = false;
                currentRoomUser.ignoreMap = false;
                currentRoomUser.Statusses.Remove("mv");
            }
            else
            {
                if (user.PetData.currentRidingUser != 0) //Checks if there is someone riding the horse and checks if he is still having fun with it (not orgy)
                {
                    RoomUser currentRidingUser = currentRoom.GetRoomUserManager().GetRoomUserByHabbo(user.PetData.currentRidingUser);
                    if (currentRidingUser == null || currentRidingUser.X != user.X || currentRidingUser.Y != user.Y || currentRidingUser.currentRidingPet != user.PetData.petID) //Not here any more
                    {
                        user.PetData.currentRidingUser = 0;
                    }
                }

                if (user.PetData.currentRidingUser == 0)
                {
                    user.PetData.currentRidingUser = session.GetHabbo().Id;

                    currentRoomUser.currentRidingPet = user.PetData.petID;
                    currentRoomUser.IsWalking = false;

                    currentRoomUser.X = user.X;
                    currentRoomUser.Y = user.Y;
                    currentRoomUser.Z = user.Z + 1;

                    currentRoomUser.SetX = user.X;
                    currentRoomUser.SetY = user.Y;
                    currentRoomUser.SetZ = user.Z + 1;

                    currentRoomUser.RotBody = user.RotBody;
                    currentRoomUser.RotHead = user.RotHead;

                    currentRoomUser.UpdateNeeded = true;
                    currentRoomUser.AllowOverride = true;
                    currentRoomUser.ignoreMap = true;

                    currentRoomUser.GetClient().GetHabboDataContainer().GetAvatarEffectsInventoryComponent().ApplyCustomEffect(77);

					int currentPosition = currentRoomUser.GetDoubleCoordinate();
					currentRoom.GetGameMap().UpdateUserMovement(ref currentPosition, ref currentPosition, currentRoomUser);
                    currentRoom.GetGameMap().GameMap[currentRoomUser.X, currentRoomUser.Y] = currentRoomUser.SqState; // REstore the old one
                    currentRoomUser.SqState = currentRoom.GetGameMap().GameMap[currentRoomUser.SetX, currentRoomUser.SetY];//Backup the new one
                }
                return;
            }
            //user.PetData.OnRoomUpdate();
        }

    }
}