using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class AcceptMemberMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            uint userID = request.ReadUInt();
            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            ServerMessage message;

            group.ApproveMembership(userID, null);

            GameClient user = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(userID);
            if (user != null)
            {
                if (user.GetHabbo().EquippedGroup == 0)
                {
                    if (user.GetHabbo().CurrentRoom != null)
                    {
                        message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGroup);
                        message.AddInt32(1);
                        message.AddUInt32(group.ID);
                        message.AddString(group.image);
                        user.GetHabbo().CurrentRoom.SendMessage(message);

                        RoomUser roomUser = user.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(user.GetHabbo().Id);

                        if (roomUser != null)
                        {
                            message = PacketHandelingManager.GetRecycledItem(Outgoing.SetRoomUser);
                            message.AddInt32(1);
                            roomUser.Serialize(message);
                            user.GetHabbo().CurrentRoom.SendMessage(message);
                        }

                        Room groupHome = ButterflyEnvironment.Game.GetRoomManager().GetRoom(group.ID);
                        if (groupHome != null)
                        {
                            RoomUser groupUser = groupHome.GetRoomUserManager().GetRoomUserByHabbo(userID);
                            if (groupUser != null)
                            {
                                roomUser.AddStatus("flatctrl 1", string.Empty);
                                roomUser.UpdateNeeded = true;
                            }
                        }
                    }
                }

                if (!user.GetHabbo().GroupList.Contains(groupID))
                    user.GetHabbo().GroupList.Add(groupID);

                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);
                message.AddUInt32(group.ID);
                message.AddBoolean(true);
                message.AddInt32((int)group.type);
                message.AddString(group.Name);
                message.AddString(group.Description);
                message.AddString(group.image);
                message.AddUInt32(group.homeRoom);
                message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));

                if (group.IsPendingGroupUser(session.GetHabbo().Id))
                    message.AddInt32(2);
                else if (group.IsMember(session.GetHabbo().Id))
                    message.AddInt32(1);
                else
                    message.AddInt32(0);

                message.AddInt32(group.MemberCount);
                message.AddBoolean(false);
                message.AddString(group.Created);
                message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);
                message.AddBoolean(session.GetHabbo().EquippedGroup == group.ID);
                message.AddString(group.ownerID.Username);
                message.AddBoolean(true);
                message.AddBoolean(true);
                message.AddInt32(group.IsMember(session.GetHabbo().Id) ? group.GetPendingUserCount() : 0);
                user.SendMessage(message);
            }

            List<GroupMember> members = group.GetPendingMembers(string.Empty);

            message = PacketHandelingManager.GetRecycledItem(Outgoing.SendMembersAndPetitions);
            message.AddUInt32(group.ID);
            message.AddString(group.Name);
            message.AddUInt32(group.homeRoom);
            message.AddString(group.image);
            message.AddInt32(members.Count);
            message.AddInt32(members.Count);

            foreach (GroupMember member in members)
            {
                member.Serialize(message);
            }


            GroupMember myMembership = group.GetMembership(session.GetHabbo().Id);
            message.AddBoolean(myMembership != null && myMembership.GetRank() < 2);

            message.AddInt32(14);
            message.AddInt32(0);
            message.AddInt32(2);
            message.AddString(string.Empty);

            session.SendMessage(message);
        }

    }
}