using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class BuyGroupMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            if (session == null || session.GetHabbo().Credits < 10)
                return;

            List<int> gStates = new List<int>();
            string name = request.ReadString();
            string description = request.ReadString();
            int roomid = request.ReadInt();
            int color = request.ReadInt();
            int num3 = request.ReadInt();
            int stateCount = request.ReadInt() - 3;
            int guildBase = request.ReadInt();
            int guildBaseColor = request.ReadInt();
            int num6 = request.ReadInt();

            for (int i = 0; i < stateCount; i++)
            {
                int item = request.ReadInt();
                gStates.Add(item);
            }

            string image = ButterflyEnvironment.Game.GetGroupManager().GenerateGuildImage(guildBase, guildBaseColor, gStates);
            string htmlPrimary = ButterflyEnvironment.Game.GetGroupManager().GetHtmlColor(color);
            string htmlSecondary = ButterflyEnvironment.Game.GetGroupManager().GetHtmlColor(num3);
            
            GroupData newGroup = ButterflyEnvironment.Game.GetGroupManager().RegisterGroup(name, session.GetHabbo().Id,
                description, roomid, image, color, num3, guildBase,
                guildBaseColor, htmlPrimary, htmlSecondary, gStates, session.GetHabbo(), session.GetHabboDataContainer().GetGroupManager());



            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.PurchaseOKMessageEvent);

            message.AddInt32(0x1815);
            message.AddString("CREATE_GUILD");
            message.AddInt32(10);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddBoolean(true);
            message.AddInt32(0);
            message.AddInt32(2);
            message.AddBoolean(false);

            session.SendMessage(message);

            Habbo habbo = session.GetHabbo();
            habbo.Credits -= 10;

            session.GetHabboDataContainer().UpdateCreditsBalance();

            message = PacketHandelingManager.GetRecycledItem(Outgoing.SendHtmlColors);
            message.AddInt32(session.GetHabbo().GroupList.Count);

            foreach (uint groupID in session.GetHabbo().GroupList)
            {
                GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
                message.AddUInt32(group.ID);
                message.AddString(group.Name);
                message.AddString(group.image);
                message.AddString(group.htmlColorPrimary);
                message.AddString(group.htmlColorSecondary);
                message.AddBoolean(group.ID == session.GetHabbo().EquippedGroup);
            }

            session.SendMessage(message);

            

            ServerMessage message4 = PacketHandelingManager.GetRecycledItem(Outgoing.UpdateRoom);
            message4.AddUInt32(newGroup.homeRoom);
            session.SendMessage(message4);

            ServerMessage message6 = PacketHandelingManager.GetRecycledItem(Outgoing.SendRoomAndGroup);
            message6.AddUInt32(newGroup.homeRoom);
            message6.AddUInt32(newGroup.ID);
            session.SendMessage(message6);

            Room groupRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(newGroup.homeRoom);

            if (groupRoom != null)
            {
                if (session.GetHabbo().CurrentRoomId == newGroup.homeRoom)
                {
                    ServerMessage roomMessage = PacketHandelingManager.GetRecycledItem(Outgoing.SetRoomUser);
                    roomMessage.AddInt32(1);
                    groupRoom.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id).Serialize(roomMessage);

                    groupRoom.SendMessage(roomMessage);
                }

                ServerMessage message5 = PacketHandelingManager.GetRecycledItem(Outgoing.ConfigureWallandFloor);
                message5.AddBoolean(groupRoom.Hidewall);
                message5.AddInt32(groupRoom.WallThickness);
                message5.AddInt32(groupRoom.FloorThickness);
                session.SendMessage(message5);

                ServerMessage message7 = PacketHandelingManager.GetRecycledItem(Outgoing.RoomData);
                groupRoom.RoomData.SerializeGuestRoomResults(message7, true);
                message7.AddBoolean(true);
                groupRoom.SendMessage(message7);
            }
        }

    }
}