using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class DisplayGroupDataMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            bool someflag = request.ReadBool();

            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);

            if (group == null)
                return;

            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);

            message.AddUInt32(group.ID);
            message.AddBoolean(!someflag);
            message.AddInt32((int)group.type);
            message.AddString(group.Name);
            message.AddString(group.Description);
            message.AddString(group.image);
            message.AddUInt32(group.homeRoom);
            message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));

            if (group.IsPendingGroupUser(session.GetHabbo().Id))
                message.AddInt32(2);
            else if (session.GetHabbo().GroupList.Contains(groupID))
                message.AddInt32(1);
            else 
                message.AddInt32(0);

            message.AddInt32(group.MemberCount);
            message.AddBoolean(false);
            message.AddString(group.Created);
            
            message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);

            if (session.GetHabbo().GroupList.Contains(group.ID))
            {
                GroupMember membership = group.GetMembership(session.GetHabbo().Id);
                message.AddBoolean(membership.GetRank() < 2);
            }
            else
            {
                message.AddBoolean(false);
            }

            message.AddString(group.ownerID.Username);
            message.AddBoolean(someflag);
            message.AddBoolean(someflag);
            message.AddInt32(group.GetPendingUserCount());
            session.SendMessage(message);
        }

    }
}