using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;
using System.Linq;

namespace Butterfly.Messages
{
    class EditGuildMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            if (!session.GroupColorsSent)
            {
                //To-do: Find a better approach for this "hack"
                new OpenGuildPageMessageEventHandler().HandleEvent(session, request); 
            }

            uint groupID = request.ReadUInt();
            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGestionGroup);
            List<int> states = group.GetStates();

            message.AddInt32(session.GetHabbo().UsersRooms.Count(p => p.GroupID == 0));
            foreach (RoomData room in session.GetHabbo().UsersRooms.Where(p => p.GroupID == 0))
            {
                message.AddUInt32(room.Id);
                message.AddString(room.Name);
                message.AddBoolean(false);
            }

            message.AddBoolean(true);
            message.AddUInt32(group.ID);
            message.AddString(group.Name);
            message.AddString(group.Description);
            message.AddUInt32(group.homeRoom);
            message.AddInt32(group.customColorPrimary);
            message.AddInt32(group.customColorSecondary);
            message.AddInt32((int)group.type);
            message.AddInt32(group.rights);
            message.AddBoolean(false);
            message.AddString("");
            message.AddInt32(5);
            message.AddInt32(group.baseBadge);
            message.AddInt32(group.baseColor);
            message.AddInt32(4);

            foreach (int state in states)
                message.AddInt32(state);

            for (int i = 0; i < 12 - states.Count; i++)
                message.AddInt32(0);

            message.AddString(group.image);
            message.AddInt32(group.members.Count);
            message.AddInt32(group.GetPendingUserCount());

            session.SendMessage(message);
        }

    }
}