using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class ExitGuildMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            uint userID = request.ReadUInt();
            ServerMessage message;

            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);

            if (group == null)
                return;

            GroupMember myMembership = group.GetMembership(session.GetHabbo().Id);
            GroupMember member = group.GetMembership(userID);

            if (myMembership == null || member == null || myMembership.GetRank() < 2)
                return;

            group.RemoveMember(userID, GroupLeaveType.USER_DELETE);
            
            GameClient client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(userID);

            if (client != null)
            {
                client.GetHabbo().GroupList.Remove(groupID);
                if (client.GetHabbo().EquippedGroup == groupID)
                    client.GetHabbo().EquippedGroup = 0;

                if (client.GetHabbo().CurrentRoomId == group.homeRoom)
                {
                    message = PacketHandelingManager.GetRecycledItem(Outgoing.SetRoomUser);
                    message.AddInt32(1);
                    client.GetHabbo().CurrentRoom.UsersWithRights.Remove(userID);
                    RoomUser user = client.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(userID);

                    user.RemoveStatus("flatctrl 1");
                    user.UpdateNeeded = true;
                    user.Serialize(message);

                    client.GetHabbo().CurrentRoom.SendMessage(message);
                }

                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGroup);
                message.AddInt32(0);
                client.SendMessage(message);

                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);
                message.AddUInt32(group.ID);
                message.AddBoolean(true);
                message.AddInt32((int)group.type);
                message.AddString(group.Name);
                message.AddString(group.Description);
                message.AddString(group.image);
                message.AddUInt32(group.homeRoom);
                message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));

                if (group.IsPendingGroupUser(session.GetHabbo().Id))
                    message.AddInt32(2);
                else if (group.IsMember(session.GetHabbo().Id))
                    message.AddInt32(1);
                else
                    message.AddInt32(0);

                message.AddInt32(group.MemberCount);
                message.AddBoolean(false);
                message.AddString(group.Created);
                message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);
                message.AddBoolean(session.GetHabbo().EquippedGroup == group.ID);
                message.AddString(group.ownerID.Username);
                message.AddBoolean(true);
                message.AddBoolean(true);
                message.AddInt32(group.IsMember(session.GetHabbo().Id) ? group.GetPendingUserCount() : 0);
                client.SendMessage(message);
            }
        }

    }
}