using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;
using System.Linq;

namespace Butterfly.Messages
{
    class LoadMembersPetitionsMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            int number2 = request.ReadInt();
            
            string searchPattern = request.ReadString();
            int number3 = request.ReadInt();

            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            List<GroupMember> members = null;

            if (number3 == 0)   // Get all group members
                members = group.GetMembers(searchPattern);
            else if (number3 == 1)  // Get all admins
                members = group.GetMembers(searchPattern).Where(p => p.GetRank() < 2).ToList();
            else  // Get all pending users
                members = group.GetPendingMembers(searchPattern);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendMembersAndPetitions);
            message.AddUInt32(group.ID);
            message.AddString(group.Name);
            message.AddUInt32(group.homeRoom);
            message.AddString(group.image);
            message.AddInt32(members.Count);
            message.AddInt32(number2 == 0 ? members.Count : members.Count - (number2 * 14));

            int counter = 0;
            foreach (GroupMember member in members)
            {
                if (counter++ < number2 * 14) break;
                member.Serialize(message);
            }

            GroupMember myMembership = group.GetMembership(session.GetHabbo().Id);
            message.AddBoolean(myMembership != null && myMembership.GetRank() < 2);

            message.AddInt32(14);
            message.AddInt32(number2);
            message.AddInt32(number3);
            message.AddString(searchPattern);
            session.SendMessage(message);
        }

    }
}