using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users;
using Butterfly.Messages.IOCodes;
using System.Linq;
using System.IO;

namespace Butterfly.Messages
{
    class OpenGuildPageMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Habbo habbo = session.GetHabbo();

            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGuildParts);
            message.AddInt32(10);
            message.AddInt32(habbo.UsersRooms.Count(p => p.GroupID == 0));
            foreach (RoomData data in habbo.UsersRooms)
            {
                if (data.GroupID == 0)
                {
                    message.AddUInt32(data.Id);
                    message.AddString(data.Name);
                    message.AddBoolean(false);
                }
            }

            message.AddInt32(5);
            message.AddInt32(10);
            message.AddInt32(3);
            message.AddInt32(4);
            message.AddInt32(25);
            message.AddInt32(17);
            message.AddInt32(5);
            message.AddInt32(25);
            message.AddInt32(17);
            message.AddInt32(3);
            message.AddInt32(29);
            message.AddInt32(11);
            message.AddInt32(4);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddInt32(0);

            session.SendMessage(message);
            session.SendMessage(ButterflyEnvironment.Game.GetGroupManager().SerializeGuildPage());
            session.GroupColorsSent = true;
        }

    }
}