using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class RejectGuildMemberMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            uint userID = request.ReadUInt();
            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            group.DisapproveMembership(userID);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);
            message.AddUInt32(group.ID);
            message.AddBoolean(true);
            message.AddInt32((int)group.type);
            message.AddString(group.Name);
            message.AddString(group.Description);
            message.AddString(group.image);
            message.AddUInt32(group.homeRoom);
            message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));

            if (group.IsPendingGroupUser(session.GetHabbo().Id))
                message.AddInt32(2);
            else if (group.IsMember(session.GetHabbo().Id))
                message.AddInt32(1);
            else
                message.AddInt32(0);

            message.AddInt32(group.MemberCount);
            message.AddBoolean(false);
            message.AddString(group.Created);
            message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);
            message.AddBoolean(session.GetHabbo().EquippedGroup == group.ID);
            message.AddString(group.ownerID.Username);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddInt32(group.IsMember(session.GetHabbo().Id) ? group.GetPendingUserCount() : 0);
            session.SendMessage(message);

            // to-do: Find a better approach for this "hack"
            new LoadMembersPetitionsMessageEventHandler().HandleEvent(session, request);
        }

    }
}