using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class SaveGroupBadgeMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            int stateCount = request.ReadInt() - 3;
            int groupBase = request.ReadInt();
            int groupBaseColor = request.ReadInt();
            request.ReadInt();
            /*int stateCount = Request.ReadInt(); */
            //stateCount *= 3;

            List<int> states = new List<int>();

            for (int i = 0; i < stateCount; i++)
            {
                int item = request.ReadInt();
                states.Add(item);
            }

            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);

            if (group == null) return;

            int temp2 = request.ReadInt();
            int temp3 = request.ReadInt();
            int temp4 = request.ReadInt();
            int temp5 = request.ReadInt();
            GroupMember membership = group.GetMembership(session.GetHabbo().Id);

            if (membership != null && membership.GetRank() < 2)
            {
                group.SetImage(groupBase, groupBaseColor, states);

                ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);

                message.AddUInt32(group.ID);
                message.AddBoolean(true);
                message.AddInt32((int)group.type);
                message.AddString(group.Name);
                message.AddString(group.Description);
                message.AddString(group.image);
                message.AddUInt32(group.homeRoom);
                message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));

                if (group.IsPendingGroupUser(session.GetHabbo().Id))
                    message.AddInt32(2);
                else if (session.GetHabbo().GroupList.Contains(groupID))
                    message.AddInt32(1);
                else
                    message.AddInt32(0);

                message.AddInt32(group.MemberCount);
                message.AddBoolean(false);
                message.AddString(group.Created);

                message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);

                message.AddBoolean(membership.GetRank() < 2);

                message.AddString(group.ownerID.Username);
                message.AddBoolean(false);
                message.AddBoolean(false);
                message.AddInt32(group.GetPendingUserCount());
                session.SendMessage(message);


                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGroup);
                message.AddInt32(1);
                message.AddUInt32(group.ID);
                message.AddString(group.image);
                session.GetHabbo().CurrentRoom.SendMessage(message);
            }
        }

    }
}