using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class SendRequestGuildMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            ServerMessage message;

            if (group == null)
                return;

            if (group.IsMember(session.GetHabbo().Id))
                return;

            group.RequestMembership(session.GetHabbo(), session.GetHabboDataContainer().GetGroupManager());

            if (group.type == GroupType.Open)
            {
                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGroup);
                message.AddInt32(1);
                message.AddUInt32(group.ID);
                message.AddString(group.image);
                session.SendMessage(message);

                message = PacketHandelingManager.GetRecycledItem(Outgoing.SendHtmlColors);
                message.AddInt32(1);
                message.AddUInt32(group.ID);
                message.AddString(group.Name);
                message.AddString(group.image);
                message.AddString(group.htmlColorPrimary);
                message.AddString(group.htmlColorSecondary);
                message.AddBoolean(false);
                session.SendMessage(message);

                if (session.GetHabbo().CurrentRoomId == group.homeRoom)
                {
                    RoomUser roomUser = session.GetHabbo().CurrentRoom.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);
                    roomUser.AddStatus("flatctrl 1", string.Empty);
                    roomUser.UpdateNeeded = true;
                }
            }

            message = PacketHandelingManager.GetRecycledItem(Outgoing.SendAdvGroupInit);
            message.AddUInt32(group.ID);
            message.AddBoolean(true);
            message.AddInt32((int)group.type);
            message.AddString(group.Name);
            message.AddString(group.Description);
            message.AddString(group.image);
            message.AddUInt32(group.homeRoom);
            message.AddString(ButterflyEnvironment.Game.GetRoomManager().GetRoomName(group.homeRoom));
            
            if (group.IsPendingGroupUser(session.GetHabbo().Id))
                message.AddInt32(2);
            else if (group.IsMember(session.GetHabbo().Id))
                message.AddInt32(1);
            else 
                message.AddInt32(0);

            message.AddInt32(group.MemberCount);
            message.AddBoolean(false);
            message.AddString(group.Created);
            message.AddBoolean(session.GetHabbo().Id == group.ownerID.Id);
            message.AddBoolean(session.GetHabbo().EquippedGroup == group.ID);
            message.AddString(group.ownerID.Username);
            message.AddBoolean(true);
            message.AddBoolean(true);
            message.AddInt32(group.IsMember(session.GetHabbo().Id) ? group.GetPendingUserCount() : 0);
            session.SendMessage(message);
        }

    }
}