using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class SetGuildFavoriteMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);
            ServerMessage message;

            if (group == null || !group.IsMember(session.GetHabbo().Id))
                return;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            { 
                dbClient.runFastQuery("UPDATE users SET group_favorite =" + groupID + " WHERE id = " + session.GetHabbo().Id);
            }
            session.GetHabbo().EquippedGroup = groupID;

            message = PacketHandelingManager.GetRecycledItem(Outgoing.UpdatePetitionsGuild);
            message.AddInt32(0);
            message.AddUInt32(group.ID);
            message.AddInt32(2);
            message.AddString(group.Name);

            if (session.GetHabbo().CurrentRoomId > 0)
                session.GetHabbo().CurrentRoom.SendMessage(message);
            else
                session.SendMessage(message);

            message = PacketHandelingManager.GetRecycledItem(Outgoing.SendGroup);
            message.AddInt32(1);
            message.AddUInt32(group.ID);
            message.AddString(group.image);

            if (session.GetHabbo().CurrentRoomId > 0)
                session.GetHabbo().CurrentRoom.SendMessage(message);
            else
                session.SendMessage(message);

            message = PacketHandelingManager.GetRecycledItem(Outgoing.RemoveGuildFavorite);
            message.AddUInt32(session.GetHabbo().Id);
            session.SendMessage(message);
            session.SendMessage(session.GetHabbo().SendUserInfo(session.GetHabbo().Id, true));
        }

    }
}