using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class UpdateUserToRankGuildMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint groupID = request.ReadUInt();
            uint userID = request.ReadUInt();
            ServerMessage message;

            GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(groupID);

            if (group == null)
                return;

            GroupMember myMembership = group.GetMembership(session.GetHabbo().Id);
            GroupMember membership = group.GetMembership(userID);

            if (myMembership == null || membership == null || myMembership.GetRank() > 1 || userID == group.ownerID.Id)
                return;

            membership.SetRank(membership.GetRank() == 1 ? 2 : 1);

            List<GroupMember> members = group.GetMembers(string.Empty);

            message = PacketHandelingManager.GetRecycledItem(Outgoing.SendMembersAndPetitions);
            message.AddUInt32(group.ID);
            message.AddString(group.Name);
            message.AddUInt32(group.homeRoom);
            message.AddString(group.image);
            message.AddInt32(members.Count);
            message.AddInt32(members.Count);

            foreach (GroupMember member in members)
            {
                member.Serialize(message);
            }

            message.AddBoolean(myMembership != null && myMembership.GetRank() < 2);

            message.AddInt32(14);
            message.AddInt32(0);
            message.AddInt32(2);
            message.AddString(string.Empty);

            session.SendMessage(message);
        }

    }
}