using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class FollowBuddyMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint BuddyId = request.ReadUInt();

            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(BuddyId);

            if (Client == null || Client.GetHabbo() == null || !Client.GetHabbo().InRoom || Client.GetHabbo().CurrentRoomId == session.GetHabbo().CurrentRoomId)
            {
                return;
            }

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(Client.GetHabbo().CurrentRoomId);
            Room currentRoom = session.GetHabbo().CurrentRoom;

            if (Room == null)
                return;

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.RoomForwardMessageEvent);
            message.AddBoolean(false);
            message.AddUInt32(Room.RoomId);
            session.SendMessage(message);


            RoomData Data = Room.RoomData;


            message = PacketHandelingManager.GetRecycledItem(OutputCode.GetGuestRoomResultEvent);
            Data.SerializeGuestRoomResults(message);

            session.SendMessage(message);

            session.PrepareRoomForUser(Client.GetHabbo().CurrentRoomId, "");

        }

    }
}