using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages.IOCodes;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class SendInstantInviteMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            int count = request.ReadInt();

            List<uint> UserIds = new List<uint>();

            for (int i = 0; i < count; i++)
            {
                UserIds.Add(request.ReadUInt());
            }

            string message = TextHandling.FilterInjectionChars(request.ReadString(), true);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.RoomInviteEvent);
            Message.AddUInt32(session.GetHabbo().Id);
            Message.AddString(message);

            foreach (uint Id in UserIds)
            {
                if (!session.GetHabboDataContainer().GetChatMessenger().FriendshipExists(Id))
                    continue;

                GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUserID(Id);

                if (Client == null)
                {
                    return;
                }

                Client.SendMessageWithoutReturning(Message);
            }
            Message.ReturnToOwner();
        }

    }
}