using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class AddFavoriteMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint Id = request.ReadUInt();

            RoomData Data = ButterflyEnvironment.Game.GetRoomManager().GenerateRoomData(Id);

            if (Data == null || session.GetHabbo().FavoriteRooms.Count >= 30 || session.GetHabbo().FavoriteRooms.Contains(Id))
            {
                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.GenericErrorEvent);
                message.AddInt32(-9001);
                session.SendMessage(message);
                return;
            }

            ServerMessage add = PacketHandelingManager.GetRecycledItem(OutputCode.FavouriteChangedEvent);
            add.AddInt32((int)Id);
            add.AddBoolean(true);
            session.SendMessage(add);

            session.GetHabbo().FavoriteRooms.Add(Id);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("INSERT INTO user_favorites (user_id,room_id) VALUES (" + session.GetHabbo().Id + "," + Id + ")");
            }
        }

    }
}