using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class AnswerDoorbellMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session))
            {
                return;
            }

            string Name = request.ReadString();
            bool allowUserToEnter = request.ReadBool();

            GameClient Client = ButterflyEnvironment.Game.GetClientManager().GetClientByUsername(Name);

            if (Client == null)
            {
                return;
            }

            if (allowUserToEnter)
            {
                Client.GetHabbo().LoadingChecksPassed = true;

                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.FlatAccessibleMessageEvent);
                message.AddString(string.Empty);
                Client.SendMessage(message);

                Client.PrepareRoomForUser(Room.RoomId, string.Empty, true);
            }
            else
            {
                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.DoorbellMessageEvent);
                message.AddString(string.Empty);
                Client.SendMessage(message);
            }
        }

    }
}