using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.RoomBots;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System.Text;

namespace Butterfly.Messages
{
    class BotSpeechListMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint botID = request.ReadUInt();
            int skillType = request.ReadInt();

            Room currentRoom = session.GetHabbo().CurrentRoom;
            if (currentRoom == null) 
                return;

            RoomUser botUser = currentRoom.GetRoomUserManager().GetRoomBot(botID);
            if (botUser == null || botUser.BotData.ownerID != session.GetHabbo().Id) 
                return;

            ServerMessage message;

            switch (skillType)
            {
                case 2:
                    StringBuilder responseBuilder = new StringBuilder();

                    foreach (RandomSpeech text in botUser.BotData.RandomSpeech)
                        responseBuilder.Append(text.Message + '\n');

                    responseBuilder.Append(";#;");
                    responseBuilder.Append(botUser.BotData.AutomaticChat ? "true" : "false");
                    responseBuilder.Append(";#;");
                    responseBuilder.Append(botUser.BotData.SpeakingInterval);

                    message = PacketHandelingManager.GetRecycledItem(Outgoing.SerializeSpeechList);
                    message.AddUInt32(botID);
                    message.AddInt32(skillType);
                    message.AddString(responseBuilder.ToString());
                    session.SendMessage(message);
                    break;

                case 5:
                    message = PacketHandelingManager.GetRecycledItem(Outgoing.SerializeSpeechList);
                    message.AddUInt32(botID);
                    message.AddInt32(skillType);
                    message.AddString(botUser.BotData.Name);
                    session.SendMessage(message);
                    break;
            }
        }

    }
}