using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class CreateRoomMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            string RoomName = TextHandling.FilterInjectionChars(request.ReadString());
            string ModelName = request.ReadString();
            string RoomState = request.ReadString(); // unused, room open by default on creation. may be added in later build of Habbo?

            RoomData NewRoom = ButterflyEnvironment.Game.GetRoomManager().CreateRoom(session, RoomName, ModelName);

            if (NewRoom != null)
            {
                ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.FlatCreatedEvent);
                message.AddInt32((int)NewRoom.Id);
                message.AddString(NewRoom.Name);
                session.SendMessage(message);
                //PrepareRoomForUser(NewRoom.Id, string.Empty);
            }
        }

    }
}