using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class DanceMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            int DanceId = request.ReadInt();
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            if (User == null)
            {
                return;
            }

            User.Unidle();

            if (DanceId < 0 || DanceId > 4 || (!session.GetHabboDataContainer().GetSubscriptionManager().HasSubscription(SubscriptionManager.SUBSCRIPTION_TYPE_CLUB) && DanceId > 1))
            {
                DanceId = 0;
            }

            if (DanceId > 0 && User.CarryItemID > 0)
            {
                User.CarryItem(0);
            }

            User.DanceId = DanceId;

            ServerMessage DanceMessage = PacketHandelingManager.GetRecycledItem(OutputCode.DanceMessageEvent);
            DanceMessage.AddInt32(User.VirtualId);
            DanceMessage.AddInt32(DanceId);
            Room.SendMessage(DanceMessage);

            ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.SOCIAL_DANCE);
        }

    }
}