using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Group;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Linq;

namespace Butterfly.Messages
{
    class DeleteRoomMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint RoomId = request.ReadUInt();
            if (session == null || session.GetHabbo() == null || session.GetHabbo().UsersRooms == null)
                return;
            
            //TargetRoom = Session.GetHabbo().CurrentRoom; ;
            Room TargetRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(RoomId);
            if (TargetRoom == null)
                return;
            if (TargetRoom.Owner == session.GetHabbo().Username || session.GetHabbo().Rank > 6)
            {

                if (session.GetHabboDataContainer().GetInventoryComponent() != null)
                {
                    session.GetHabboDataContainer().GetInventoryComponent().AddItemArray(TargetRoom.GetRoomItemHandler().RemoveAllFurniture(session));
                }

                RoomData data = TargetRoom.RoomData;
                ButterflyEnvironment.Game.GetRoomManager().UnloadRoom(TargetRoom);
                ButterflyEnvironment.Game.GetRoomManager().QueueVoteRemove(data);

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.runFastQuery("DELETE FROM rooms WHERE id = " + RoomId);
                    dbClient.runFastQuery("DELETE FROM room_models_customs WHERE roomid = " + RoomId);
                    dbClient.runFastQuery("DELETE FROM user_favorites WHERE room_id = " + RoomId);
                    dbClient.runFastQuery("DELETE items, items_extradata, items_rooms "+
                                            "FROM items_rooms "+
                                            "INNER JOIN items ON (items.item_id = items_rooms.item_id) "+
                                            "LEFT JOIN items_extradata ON (items_extradata.item_id = items.item_id) "+
                                            "WHERE items_rooms.room_id = " + RoomId);
                    dbClient.runFastQuery("DELETE FROM room_rights WHERE room_id = " + RoomId);
                    dbClient.runFastQuery("UPDATE users SET home_room = '0' WHERE home_room = " + RoomId);
                }

                GroupData group = ButterflyEnvironment.Game.GetGroupManager().GetGroup(data.GroupID);
                if (group != null)
                {
                    group.DestroyGroup();   // 100% TOTALLY OVER
                }

                RoomData removedRoom = (from p in session.GetHabbo().UsersRooms
                                        where p.Id == RoomId
                                        select p).SingleOrDefault();
                if (removedRoom != null)
                    session.GetHabbo().UsersRooms.Remove(removedRoom);

                
            }
        }

    }
}