using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using System.Collections;

namespace Butterfly.Messages
{
    class EditEventMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true) || Room.Event == null)
            {
                return;
            }

            int category = request.ReadInt();
            string name = TextHandling.FilterInjectionChars(request.ReadString());
            string descr = TextHandling.FilterInjectionChars(request.ReadString());
            int tagCount = request.ReadInt();

            Room.Event.Category = category;
            Room.Event.Name = name;
            Room.Event.Description = descr;
            Room.Event.Tags = new ArrayList();

            ButterflyEnvironment.Game.GetRoomManager().GetEventManager().QueueUpdateEvent(Room.RoomData, Room.Event.Category);

            for (int i = 0; i < tagCount; i++)
            {
                Room.Event.Tags.Add(TextHandling.FilterInjectionChars(request.ReadString()));
            }

            Room.SendMessage(Room.Event.Serialize(session));
        }

    }
}