using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetMoodlightMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true) || Room.MoodlightData == null)
            {
                return;
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.RoomDimmerPresetsMessageEvent);
            message.AddInt32(Room.MoodlightData.Presets.Count);
            message.AddInt32(Room.MoodlightData.CurrentPreset);

            int i = 0;

            foreach (MoodlightPreset Preset in Room.MoodlightData.Presets)
            {
                i++;

                message.AddInt32(i);
                message.AddInt32(Preset.BackgroundOnly ? 2 : 1);
                message.AddString(Preset.ColorCode);
                message.AddInt32(Preset.ColorIntensity);
            }


            session.SendMessage(message);
        }

    }
}