using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class GetPetInfoMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            if (session.GetHabbo() == null ||session.GetHabbo().CurrentRoom == null)
                return;

            RoomUser pet = session.GetHabbo().CurrentRoom.GetRoomUserManager().GetPet(request.ReadUInt());
            if (pet == null || pet.PetData == null)
            {
                session.SendNotif(LanguageLocale.GetValue("user.petinfoerror"));
                return;
            }

            session.SendMessage(pet.PetData.SerializeInfo());
        }

    }
}