using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System;

namespace Butterfly.Messages
{
    class GetRoomData2MessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            
			Room CurrentLoadingRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().LoadingRoom);
            try
            {
                if (session.GetHabbo().LoadingRoom <= 0 || CurrentLoadingRoom == null)
                    return;

                RoomData Data = CurrentLoadingRoom.RoomData;

                if (Data == null)
                {
                    return;
                }

                if (Data.Model == null)
                {
                    session.SendNotif(LanguageLocale.GetValue("room.missingmodeldata"));
                    session.SendMessage(PacketHandelingManager.GetRecycledItem(OutputCode.CloseConnectionMessageEvent));
                    session.GetHabbo().ClearRoomLoading();
                    return;
                }

                session.SendMessage(CurrentLoadingRoom.GetGameMap().Model.GetHeightmap());
                session.SendMessage(CurrentLoadingRoom.GetGameMap().Model.SerializeRelativeHeightmap());

            }
            catch (Exception e)
            {
                Logging.LogException("Unable to load room ID [" + session.GetHabbo().LoadingRoom + "] " + e.ToString());
                session.SendNotif(LanguageLocale.GetValue("room.roomdataloaderror"));
            }
            session.modeldataSent = true;
        }

        //internal Room CurrentLoadingRoom;
    }
}