using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System.Linq;

namespace Butterfly.Messages
{
    class GetRoomData3MessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            if (!session.modeldataSent)
                return;
            session.modeldataSent = false;

			Room CurrentLoadingRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().LoadingRoom);
            ServerMessage message;
            if (session.GetHabbo().LoadingRoom <= 0 || !session.GetHabbo().LoadingChecksPassed || CurrentLoadingRoom == null)
            {
                return;
            }

            if (CurrentLoadingRoom.UsersNow + 1 > CurrentLoadingRoom.UsersMax && !session.GetHabboDataContainer().HasFuse("fuse_enter_full_rooms"))
            {
                message = PacketHandelingManager.GetRecycledItem(OutputCode.CantConnectMessageEvent);
                message.AddInt32(1);
                session.SendMessage(message);

                message = PacketHandelingManager.GetRecycledItem(OutputCode.CloseConnectionMessageEvent);
                session.SendMessage(message);
                return;
            }


            RoomItem[] floorItems = CurrentLoadingRoom.GetRoomItemHandler().mFloorItems.Values.ToArray();
            RoomItem[] wallItems = CurrentLoadingRoom.GetRoomItemHandler().mWallItems.Values.ToArray();


            message = PacketHandelingManager.GetRecycledItem(OutputCode.ObjectsMessageEvent); //362

            //message.AddInt32(1);
            message.AddInt32(1);
            message.AddUInt32(CurrentLoadingRoom.OwnerId); //Is actually ownerID
            message.AddString(CurrentLoadingRoom.Owner);

            message.AddInt32(floorItems.Length > RoomItem.MAX_ITEM_ALLOWED ? RoomItem.MAX_ITEM_ALLOWED : floorItems.Length);
            //message.AddInt32(0);

            int count = 0;
            foreach (RoomItem Item in floorItems)
            {
                Item.Serialize(message);
                if (count++ > RoomItem.MAX_ITEM_ALLOWED)
                    break;
            }

            session.SendMessage(message);

            //return;

            message = PacketHandelingManager.GetRecycledItem(OutputCode.ItemsMessageEvent);
            message.AddInt32(1);
            message.AddUInt32(CurrentLoadingRoom.OwnerId); //Is actually ownerID
            message.AddString(CurrentLoadingRoom.Owner);

            message.AddInt32(wallItems.Length > RoomItem.MAX_ITEM_ALLOWED ? RoomItem.MAX_ITEM_ALLOWED : wallItems.Length);

            count = 0;
            foreach (RoomItem Item in wallItems)
            {
                Item.Serialize(message);
                if (count++ > RoomItem.MAX_ITEM_ALLOWED)
                    break;
            }

            session.SendMessage(message);

            CurrentLoadingRoom.GetRoomUserManager().AddUserToRoom(session, session.GetHabbo().SpectatorMode);
        }

    }
}