using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using System.Collections;

namespace Butterfly.Messages
{
    class GetRoomEditDataMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true))
            {
                return;
            }
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.RoomSettingsDataEvent);
            message.AddUInt32(Room.RoomId);
            message.AddString(Room.Name);
            message.AddString(Room.Description);
            message.AddInt32(Room.State);
            message.AddInt32(Room.Category);
            message.AddInt32(Room.UsersMax);
            message.AddInt32(100);
            message.AddInt32(Room.TagCount);

            foreach (string Tag in Room.Tags.ToArray())
            {
                message.AddString(Tag);
            }

			message.AddInt32(0);
            message.AddInt32(Room.AllowPets ? 1 : 0); // allows pets in room - pet system lacking, so always off
            message.AddInt32(Room.AllowPetsEating ? 1 : 0); // allows pets to eat your food - pet system lacking, so always off
            message.AddInt32(Room.AllowWalkthrough ? 1 : 0);
            message.AddInt32(Room.Hidewall ? 1 : 0);
            message.AddInt32(Room.WallThickness);
            message.AddInt32(Room.FloorThickness);
            message.AddInt32(0);
            message.AddInt32(0);
            message.AddInt32(0);

            session.SendMessage(message);

			if (Room.UsersWithRights.Count > 0)
			{
				message = PacketHandelingManager.GetRecycledItem(OutputCode.GetPowerList);
				message.AddUInt32(Room.RoomData.Id);
				message.AddInt32(Room.UsersWithRights.Count);
				foreach (DictionaryEntry pair in Room.UsersWithRights)
				{
					message.AddUInt32((uint)pair.Key);
					message.AddString((string)pair.Value);
				}

				session.SendMessage(message);
			}
        }

    }
}