using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Pets;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetTrainerPanelMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint petId = request.ReadUInt();
            Room currentRoom = session.GetHabbo().CurrentRoom;

            if (currentRoom == null)
                return;

            Pet pet = currentRoom.GetRoomUserManager().GetPet(petId).PetData;

            if (pet == null)
                return;

            int level = pet.Level;
            int petTrainNumber = GetPetTrainNumber(level);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(Outgoing.PetTrainPanel);

            message.AddUInt32(petId);
            message.AddInt32(0x11);
            message.AddInt32(0);
            message.AddInt32(14);
            message.AddInt32(0x2b);
            message.AddInt32(0x2c);
            message.AddInt32(2);
            message.AddInt32(3);
            message.AddInt32(6);
            message.AddInt32(7);
            message.AddInt32(10);
            message.AddInt32(12);
            message.AddInt32(11);
            message.AddInt32(15);
            message.AddInt32(0x10);
            message.AddInt32(0x18);
            message.AddInt32(0x19);
            message.AddInt32(0x1a);
            message.AddInt32(0x2d);
            message.AddInt32(petTrainNumber);
            message.AddInt32(0);
            message.AddInt32(14);

            if (level > 0)
            {
                message.AddInt32(0x2b);
                message.AddInt32(0x2c);
            }

            if (level > 1)
                message.AddInt32(2);
            if (level > 2)
                message.AddInt32(3);
            if (level > 3)
                message.AddInt32(6);
            if (level > 4)
                message.AddInt32(7);
            if (level > 5)
                message.AddInt32(10);
            if (level > 6)
                message.AddInt32(12);
            if (level > 7)
                message.AddInt32(11);
            if (level > 8)
                message.AddInt32(15);
            if (level > 9)
                message.AddInt32(0x10);
            if (level > 12)
                message.AddInt32(0x18);
            if (level > 13)
                message.AddInt32(0x19);
            if (level > 15)
                message.AddInt32(0x1a);
            if (level > 0x11)
                message.AddInt32(0x2d);

            session.SendMessage(message);
        }

        private int GetPetTrainNumber(int level)
        {
            switch (level)
            {
                case 0:
                    return 2;

                case 1:
                    return 4;

                case 2:
                    return 5;

                case 3:
                    return 6;

                case 4:
                    return 7;

                case 5:
                    return 8;

                case 6:
                    return 9;

                case 7:
                    return 10;

                case 8:
                    return 11;

                case 9:
                    return 12;

                case 10:
                    return 13;

                case 11:
                    return 13;

                case 12:
                    return 14;

                case 13:
                    return 14;

                case 14:
                    return 15;

                case 15:
                    return 15;

                case 0x10:
                    return 0x10;

                case 0x11:
                    return 0x10;

                case 0x12:
                    return 0x11;

                case 0x13:
                    return 0x11;

                case 20:
                    return 0x11;
            }
            return 0x11;
        }
    }
}