using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users.Badges;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetUserBadgesMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(request.ReadUInt());

            if (User == null || User.IsBot)
                return;
            if (User.GetClient() == null)
                return;

            // CdjUzYZJIACH_RespectEarned1JACH_EmailVerification1E^jUzYZH
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.HabboUserBadgesMessageEvent);
            message.AddInt32((int)User.GetClient().GetHabbo().Id);
            message.AddInt32(User.GetClient().GetHabboDataContainer().GetBadgeComponent().EquippedCount);

            foreach (Badge Badge in User.GetClient().GetHabboDataContainer().GetBadgeComponent().BadgeList.Values)
            {
                if (Badge.Slot <= 0)
                {
                    continue;
                }

                message.AddInt32(Badge.Slot);
                message.AddString(Badge.Code);
            }

            session.SendMessage(message);
        }

    }
}