using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetUserTagsMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(request.ReadUInt());

            if (User == null || User.IsBot)
            {
                return;
            }
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.UserTagsMessageEvent);
            message.AddInt32((int)User.GetClient().GetHabbo().Id);
            message.AddInt32(User.GetClient().GetHabbo().Tags.Count);

            foreach (string Tag in User.GetClient().GetHabbo().Tags)
            {
                message.AddString(Tag);
            }

            session.SendMessage(message);
        }

    }
}