using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class GiveRespectMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || session.GetHabbo().DailyRespectPoints <= 0)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(request.ReadUInt());
            
            if (User == null || User.GetClient().GetHabbo().Id == session.GetHabbo().Id || User.IsBot)
            {
                return;
            }

            ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.SOCIAL_RESPECT);

            ButterflyEnvironment.Game.GetAchievementManager().ProgressUserAchievement(session, "ACH_RespectEarned", 1);
            ButterflyEnvironment.Game.GetAchievementManager().ProgressUserAchievement(User.GetClient(), "ACH_RespectGiven", 1);

            session.GetHabbo().DailyRespectPoints--;
            User.GetClient().GetHabbo().Respect++;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE users SET respect = respect + 1 WHERE id = " + User.GetClient().GetHabbo().Id);
                dbClient.runFastQuery("UPDATE users SET daily_respect_points = daily_respect_points - 1 WHERE id = " + session.GetHabbo().Id);
            }

            RoomUser me = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            ServerMessage mmessage = PacketHandelingManager.GetRecycledItem(OutputCode.WaveMessageEvent);
            mmessage.AddInt32(me.VirtualId);
            mmessage.AddInt32(7);
            Room.SendMessage(mmessage);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.RespectNotificationMessageEvent);
            Message.AddUInt32(User.GetClient().GetHabbo().Id);
            Message.AddInt32(User.GetClient().GetHabbo().Respect);
            Room.SendMessage(Message);
        }

    }
}