using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class GiveRightsMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint UserId = request.ReadUInt();

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);
            if (Room == null)
                return;

            RoomUser RoomUser = Room.GetRoomUserManager().GetRoomUserByHabbo(UserId);

            if (Room == null || !Room.CheckRights(session, true) || RoomUser == null || RoomUser.IsBot)
            {
                return;
            }

            if (Room.UsersWithRights.Contains(UserId))
            {
                session.SendNotif(LanguageLocale.GetValue("user.giverights.error"));
                return;
            }

            Room.UsersWithRights.Add(UserId, RoomUser.GetUsername());

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("INSERT INTO room_rights (room_id,user_id) VALUES (" + Room.RoomId + "," + UserId + ")");
            }

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.FlatControllerAddedEvent);
            message.AddUInt32(Room.RoomId);
            message.AddUInt32(UserId);
            message.AddString(RoomUser.GetClient().GetHabbo().Username);
            session.SendMessage(message);

            RoomUser.AddStatus("flatctrl 1", "");
            RoomUser.UpdateNeeded = true;

            ServerMessage authmsg = PacketHandelingManager.GetRecycledItem(OutputCode.YouAreControllerMessageEvent);
            authmsg.AddInt32(1);
            RoomUser.GetClient().SendMessage(authmsg);
        }

    }
}