using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class IgnoreUserMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {

            Room Room = session.GetHabbo().CurrentRoom;

            if (Room == null)
                return;
            RoomUser rUser = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            string username = request.ReadString();;
            GameClient User = ButterflyEnvironment.Game.GetClientManager().GetClientByUsername(username);

            if (User == null)
                return;
            if (Room.CheckRights(User, true) || User.GetHabboDataContainer().HasFuse("fuse_mod") || User.GetHabboDataContainer().HasFuse("fuse_no_kick"))
            {
                return;
            }
            rUser.IgnoreUser(User.GetHabbo().Id);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.IgnoreResultMessageEvent);
            message.AddInt32(1);
            message.AddString(username);
            session.SendMessage(message);
        }

    }
}