using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class MoveItemMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session))
            {
                return;
            }

            RoomItem Item = Room.GetRoomItemHandler().GetItem(request.ReadUInt());

            if (Item == null)
            {
                return;
            }

            int x = request.ReadInt();
            int y = request.ReadInt();
            int Rotation = request.ReadInt();
            int Junk = request.ReadInt();

            bool UpdateNeeded = false;

            if (Item.GetBaseItem().InteractionType == Butterfly.HabboHotel.Items.InteractionType.teleport)
                UpdateNeeded = true;

            if (x != Item.GetX || y != Item.GetY)
            {
                ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.FURNI_MOVE);
            }

            if (Rotation != Item.Rot)
            {
                ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.FURNI_ROTATE);
            }

            if (!Room.GetRoomItemHandler().SetFloorItem(session, Item, x, y, Rotation, false, false, true))
            {
                ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.ObjectUpdateMessageEvent);
                Item.Serialize(Message);
                session.SendMessage(Message);
            }

            if (Item.GetZ >= 0.1)
            {
                ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.FURNI_STACK);
            }

            if (UpdateNeeded)
            {
                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    Room.GetRoomItemHandler().SaveFurniture(dbClient);
                }
            }
        }

    }
}