using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class MoveMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = session.GetHabbo().CurrentRoom;

            if (Room == null)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            if (User == null || !User.CanWalk)
            {
                return;
            }

            int MoveX = request.ReadInt();
            int MoveY = request.ReadInt();

            if (MoveX == User.X && MoveY == User.Y)
            {
                return;
            }

            if (User.UserIsRidingAHorse())
            {
                User.GetPedRiding().MoveTo(MoveX, MoveY, false);
            }
            else
            {
                User.MoveTo(MoveX, MoveY);
            }
        }

    }
}