using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class MoveWallItemMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session))
            {
                return;
            }

            uint itemID = request.ReadUInt();
            string wallPositionData = request.ReadString();

            RoomItem Item = Room.GetRoomItemHandler().GetItem(itemID);

            if (Item == null)
                return;

            try
            {
                WallCoordinate coordinate = new WallCoordinate(":" + wallPositionData.Split(':')[1]);
                Item.wallCoord = coordinate;
            }
            catch
            {
                //ServerMessage message = new ServerMessage(OutputCode.PlaceObjectErrorMessageEvent);
                //message.AddInt32(11);
                //Session.SendMessage(message);

                return;
            }

            Room.GetRoomItemHandler().UpdateItem(Item);

            //ServerMessage LeaveMessage = new ServerMessage(OutputCode.ItemRemoveMessageEvent);
            //LeaveMessage.AddString(Item.Id.ToString());
            //Room.SendMessage(LeaveMessage);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.ItemAddMessageEvent);
            Item.Serialize(Message);
            Room.SendMessage(Message);
        }

    }
}