using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;
using System;
using System.Data;

namespace Butterfly.Messages
{
    class OpenPresentMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true))
            {
                return;
            }

            RoomItem Present = Room.GetRoomItemHandler().GetItem(request.ReadUInt());

            if (Present == null)
            {
                return;
            }

            DataRow Data = null;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.setQuery("SELECT base_id,amount,extra_data FROM user_presents WHERE item_id = " + Present.Id + "");
                Data = dbClient.getRow();
            }

            if (Data == null)
            {
                return;
            }

            Item BaseItem = ButterflyEnvironment.Game.GetItemManager().GetItem(Convert.ToUInt32(Data["base_id"]));

            if (BaseItem == null)
            {
                return;
            }

            Room.GetRoomItemHandler().RemoveFurniture(session, Present.Id);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.PresentOpenedMessageEvent);
            message.AddChar(BaseItem.Type);
            message.AddInt32(BaseItem.SpriteId);
            message.AddString(BaseItem.Name);
            message.AddInt32(0);
            message.AddChar(BaseItem.Type);
            message.AddBoolean(true);
            message.AddString("");
            session.SendMessage(message);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("DELETE FROM user_presents WHERE item_id = " + Present.Id);
            }

            ButterflyEnvironment.Game.GetCatalog().DeliverItems(session, BaseItem, (int)Data["amount"], (string)Data["extra_data"]);
        }

    }
}