using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Pets;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class PickUpPetMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (session == null || session.GetHabbo() == null || session.GetHabboDataContainer().GetInventoryComponent() == null)
                return;

            if (Room == null || (!Room.AllowPets && !Room.CheckRights(session, true)))
            {
                return;
            }

            uint PetId = request.ReadUInt();
            RoomUser PetUser = Room.GetRoomUserManager().GetPet(PetId);
            if (PetUser == null)
                return;

            if (PetUser.PetData.databaseState != DatabaseUpdateState.PendingInsert)
                PetUser.PetData.databaseState = DatabaseUpdateState.PendingUpdate;
            PetUser.PetData.roomID = 0;

            session.GetHabboDataContainer().GetInventoryComponent().AddPet(PetUser.PetData);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                Room.GetRoomUserManager().SavePets(dbClient);

            Room.GetRoomUserManager().RemoveBot(PetUser.VirtualId, false);
            session.SendMessage(session.GetHabboDataContainer().GetInventoryComponent().SerializePetInventory());
        }

    }
}