using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.RoomBots;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class PlaceBotMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint botID = request.ReadUInt();
            int x = request.ReadInt();
            int y = request.ReadInt();

            RoomBot bot = session.GetHabboDataContainer().GetInventoryComponent().GetBot(botID);
            Room room = session.GetHabboDataContainer().data.CurrentRoom;

            if (bot == null || room == null || !room.GetGameMap().CanWalk(x, y, false))
                return;

            bot.X = x;
            bot.Y = y;
            RoomUser newBot = room.GetRoomUserManager().DeployBot(bot, null);
            //room.GetRoomUserManager().AddRoomUser(newBot);
            session.GetHabboDataContainer().GetInventoryComponent().RemoveBot(botID);
            
            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE bots SET room_id = '" + room.RoomId + "', x = '" + x + "', y = '" + y + "' WHERE id = '" + botID + "'");
            }
           
            session.SendMessage(session.GetHabboDataContainer().GetInventoryComponent().SerializeBotInventory());
        }

    }
}