using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Pets;
using Butterfly.HabboHotel.RoomBots;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Collections.Generic;

namespace Butterfly.Messages
{
    class PlacePetMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || (!Room.AllowPets && !Room.CheckRights(session, true)) || !Room.CheckRights(session, true))
            {
                return;
            }

            uint PetId = request.ReadUInt();

            Pet Pet = session.GetHabboDataContainer().GetInventoryComponent().GetPet(PetId);

            if (Pet == null || Pet.isPlaced)
            {
                return;
            }

            int X = request.ReadInt();
            int Y = request.ReadInt();

            if (!Room.GetGameMap().CanWalk(X, Y, false))
            {
                return;
            }

            //if (Room.GetRoomUserManager().PetCount >= RoomManager.MAX_PETS_PER_ROOM)
            //{
            //    Session.SendNotif(LanguageLocale.GetValue("user.maxpetreached"));
            //    return;
            //}

            RoomUser oldPet = Room.GetRoomUserManager().GetPet(PetId);
            if (oldPet != null)
                Room.GetRoomUserManager().RemoveBot(oldPet.VirtualId, false);

            Pet.isPlaced = true;
            Pet.roomID = Room.RoomId;

            List<RandomSpeech> RndSpeechList = new List<RandomSpeech>();
            List<BotResponse> BotResponse = new List<Butterfly.HabboHotel.RoomBots.BotResponse>();
            RoomUser PetUser = Room.GetRoomUserManager().DeployBot(new RoomBot(Pet.petID, Pet.roomID, AIType.Pet, "freeroam", Pet.name, "", Pet.GetLook, X, Y, 0, 0, 0, 0, 0, 0, 0, 0, false, RndSpeechList, BotResponse), Pet);

            session.GetHabboDataContainer().GetInventoryComponent().MovePetToRoom(Pet.petID);

            if (Pet.databaseState != DatabaseUpdateState.PendingInsert)
                Pet.databaseState = DatabaseUpdateState.PendingUpdate;

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                Room.GetRoomUserManager().SavePets(dbClient);

            session.GetHabboDataContainer().GetInventoryComponent().UpdateItems(false);
        }

    }
}