using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class PlacePostItMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);
            if (Room == null || !Room.CheckRights(session))
            {
                return;
            }

            if (Room.GetRoomItemHandler().mWallItems.Inner.Count >= RoomItem.MAX_ITEM_ALLOWED)
            {
                session.SendNotif(LanguageLocale.GetValue("max.rooms.items.reached"));
                return;
            }
            
            uint itemId = request.ReadUInt();
            string locationData = request.ReadString();

            UserItem item = session.GetHabboDataContainer().GetInventoryComponent().GetItem(itemId);

            if (item == null || Room == null)
                return;

            try
            {
                WallCoordinate coordinate = new WallCoordinate(":" + locationData.Split(':')[1]);

                RoomItem _RoomItem = new RoomItem(item.itemID, Room.RoomId, item.BaseItemID, item.extraData, coordinate, Room);

                if (Room.GetRoomItemHandler().SetWallItem(session, _RoomItem))
                {
                    session.GetHabboDataContainer().GetInventoryComponent().RemoveItem(itemId, true);
                }
            }
            catch
            {
                //ServerMessage message = new ServerMessage(OutputCode.PlaceObjectErrorMessageEvent);
                //message.AddInt32(11);
                //Session.SendMessage(message);
                return;
            }
        }


    }
}