using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class RateRoomMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || session.GetHabbo().RatedRooms.Contains(Room.RoomId) || Room.CheckRights(session, true))
            {
                return;
            }

            int Rating = request.ReadInt();

            switch (Rating)
            {
                case -1:

                    Room.Score--;
                    Room.RoomData.Score--;
                    break;

                case 1:

                    Room.Score++;
                    Room.RoomData.Score++;
                    break;

                default:

                    return;
            }

            ButterflyEnvironment.Game.GetRoomManager().QueueVoteAdd(Room.RoomData);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE rooms SET score = " + Room.Score + " WHERE id = " + Room.RoomId);
            }

            session.GetHabbo().RatedRooms.Add(Room.RoomId);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.RoomRatingEvent);
            message.AddInt32(Room.Score);
            message.AddBoolean(false);
            session.SendMessage(message);
        }

    }
}