using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class RedeemExchangeFurniMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true))
            {
                return;
            }

            RoomItem Exchange = Room.GetRoomItemHandler().GetItem((uint)request.ReadInt());

            if (Exchange == null)
            {
                return;
            }

            if (!Exchange.GetBaseItem().Name.StartsWith("CF_") && !Exchange.GetBaseItem().Name.StartsWith("CFC_"))
            {
                return;
            }
            
            string[] Split = Exchange.GetBaseItem().Name.Split('_');
            int Value = int.Parse(Split[1]);

            if (Value > 0)
            {
                session.GetHabbo().Credits += Value;
                session.GetHabboDataContainer().UpdateCreditsBalance();
            }

            Room.GetRoomItemHandler().RemoveFurniture(null, Exchange.Id);
            session.SendMessage(PacketHandelingManager.GetRecycledItem(OutputCode.HeightMapUpdateMessageEvent));
        }

    }
}