using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class SetLookTransferMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session))
                return;

            uint ItemID = request.ReadUInt();

            string Gender = request.ReadString().ToUpper();
            string Look = TextHandling.FilterInjectionChars(request.ReadString());

            RoomItem RoomItemToSet = Room.GetRoomItemHandler().mFloorItems.GetValue(ItemID);

            if (Gender.Length > 1)
                return;

            if (Gender != "M" && Gender != "F")
                return;

            RoomItemToSet.Figure = TextHandling.FilterFigure(Look);
            RoomItemToSet.Gender = Gender;

            RoomItemToSet.ExtraData = Gender + ":" + Look;
        }

    }
}