using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class SitMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room currentRoom = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (currentRoom == null)
                return;

            RoomUser roomuser = currentRoom.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            if (roomuser == null)
                return;

            if (roomuser.Statusses.ContainsKey("sit"))
                roomuser.Statusses.Remove("sit");
            else
            {
                if (!roomuser.isFacingDiagonal())
                {
                    roomuser.Statusses.Add("sit", TextHandling.GetString(0.5));
                }
            }

            roomuser.UpdateNeeded = true;
        }

    }
}