using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using System.Collections;

namespace Butterfly.Messages
{
    class StartEventMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true) || Room.Event != null || Room.State != 0)
            {
                return;
            }

            int category = request.ReadInt();
            string name = TextHandling.FilterInjectionChars(request.ReadString());
            string descr = TextHandling.FilterInjectionChars(request.ReadString());
            int tagCount = request.ReadInt();

            Room.Event = new RoomEvent(Room.RoomId, name, descr, category, null);
            Room.Event.Tags = new ArrayList();

            for (int i = 0; i < tagCount; i++)
            {
                Room.Event.Tags.Add(TextHandling.FilterInjectionChars(request.ReadString()));
            }

            Room.SendMessage(Room.Event.Serialize(session));

            ButterflyEnvironment.Game.GetRoomManager().GetEventManager().QueueAddEvent(Room.RoomData, Room.Event.Category);
        }

    }
}