using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class TakeBackTradeItemMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CanTradeInRoom)
            {
                return;
            }

            Trade Trade = Room.GetUserTrade(session.GetHabbo().Id);
            UserItem Item = session.GetHabboDataContainer().GetInventoryComponent().GetItem(request.ReadUInt());

            if (Trade == null || Item == null)
            {
                return;
            }

            Trade.TakeBackItem(session.GetHabbo().Id, Item);
        }

    }
}