using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class TakeBotMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            uint botID = request.ReadUInt();

            Room currentRoom = session.GetHabbo().CurrentRoom;
            if (currentRoom == null)
                return;

            RoomUser botUser = currentRoom.GetRoomUserManager().GetRoomBot(botID);
            if (botUser == null || botUser.BotData.ownerID != session.GetHabbo().Id)
                return;

            botUser.RoomId = 0;

            session.GetHabboDataContainer().GetInventoryComponent().AddBot(botUser.BotData);
            currentRoom.GetRoomUserManager().RemoveBot(botUser.InternalRoomID, false);

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                dbClient.runFastQuery("UPDATE bots SET room_id = '0' WHERE id = '" + botID + "' LIMIT 1");

            session.SendMessage(session.GetHabboDataContainer().GetInventoryComponent().SerializeBotInventory());
        }

    }
}