using Butterfly.Core;
using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users.Inventory;

namespace Butterfly.Messages
{
    class TakeItemMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            int junk = request.ReadInt();

            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true))
            {
                return;
            }

            RoomItem Item = Room.GetRoomItemHandler().GetItem((uint)request.ReadInt());

            if (Item == null)
                return;

            if (Item.GetBaseItem().Type == 'i' && session.GetHabboDataContainer().GetInventoryComponent().WallItemCount() > InventoryComponent.MAX_ITEMS_COUNT)
            {
                session.SendNotif(LanguageLocale.GetValue("inventory.max_reached"));
                return;
            }
            else if (Item.GetBaseItem().Type != 'i' && session.GetHabboDataContainer().GetInventoryComponent().FloorItemCount() > InventoryComponent.MAX_ITEMS_COUNT)
            {
                session.SendNotif(LanguageLocale.GetValue("inventory.max_reached"));
                return;
            }

            if (Item.GetBaseItem().InteractionType == Butterfly.HabboHotel.Items.InteractionType.postit)
                return;

            Room.GetRoomItemHandler().RemoveFurniture(session, Item.Id);
            session.GetHabboDataContainer().GetInventoryComponent().AddNewItem(Item.Id, (ushort)Item.BaseItem, Item.ExtraData, true, true, 0);
            session.GetHabboDataContainer().GetInventoryComponent().UpdateItems(false);

            ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.FURNI_PICK);
        }

    }
}