using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;
using System.Text;

namespace Butterfly.Messages
{
    class TakeRightsMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null || !Room.CheckRights(session, true))
            {
                return;
            }

            StringBuilder DeleteParams = new StringBuilder();

            int Amount = request.ReadInt();

            for (int i = 0; i < Amount; i++)
            {
                if (i > 0)
                {
                    DeleteParams.Append(" OR ");
                }

                uint UserId = request.ReadUInt();
                Room.UsersWithRights.Remove(UserId);
                DeleteParams.Append("room_id = '" + Room.RoomId + "' AND user_id = '" + UserId + "'");

                RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(UserId);

                if (User != null && !User.IsBot)
                {
                    ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.YouAreControllerMessageEvent);
                    message.AddInt32(0);
                    session.SendMessage(message);

                    User.RemoveStatus("flatctrl 1");
                    User.UpdateNeeded = true;
                }

                // GhntX]hqu@U
                ServerMessage message2 = PacketHandelingManager.GetRecycledItem(OutputCode.FlatControllerRemovedEvent);
                message2.AddUInt32(Room.RoomId);
                message2.AddUInt32(UserId);
                session.SendMessage(message2);
            }

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("DELETE FROM room_rights WHERE " + DeleteParams.ToString());
            }
        }

    }
}