using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Items;
using Butterfly.HabboHotel.Rooms;

namespace Butterfly.Messages
{
    class TriggerItemDiceSpecialMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            RoomItem Item = Room.GetRoomItemHandler().GetItem(request.ReadUInt());

            if (Item == null)
            {
                return;
            }

            bool hasRights = false;

            if (Room.CheckRights(session))
            {
                hasRights = true;
            }

            Item.Interactor.OnTrigger(session, Item, -1, hasRights);
            Item.OnTrigger(Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id));
        }

    }
}