using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.Users;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class UnignoreUserMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {

            Room Room = session.GetHabbo().CurrentRoom;

            if (Room == null)
                return;

            RoomUser rUser = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            string username = request.ReadString();
            Habbo user = ButterflyEnvironment.Game.GetClientManager().GetClientByUsername(username).GetHabbo();

            if (user == null)
                return;
            uint Id = user.Id;

            rUser.UnIgnoreUser(Id);

            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.IgnoreResultMessageEvent);
            message.AddInt32(3);
            message.AddString(username);
            session.SendMessage(message);
        }

    }
}