using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class WaveMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            Room Room = ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId);

            if (Room == null)
            {
                return;
            }

            RoomUser User = Room.GetRoomUserManager().GetRoomUserByHabbo(session.GetHabbo().Id);

            if (User == null)
                return;

            int waveType = request.ReadInt();

            ServerMessage Message;

            if (waveType == 5)
            {
                User.IsAsleep = true;
                Message = PacketHandelingManager.GetRecycledItem(OutputCode.SleepMessageEvent);
                Message.AddInt32(User.VirtualId);
                Message.AddBoolean(true);
                session.SendMessage(Message);
                return;
            }

            User.Unidle();

            User.DanceId = 0;

            Message = PacketHandelingManager.GetRecycledItem(OutputCode.WaveMessageEvent);
            Message.AddInt32(User.VirtualId);
            Message.AddInt32(waveType);
            Room.SendMessage(Message);

            ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.SOCIAL_WAVE);
        }

    }
}