using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Rooms;
using Butterfly.HabboHotel.SoundMachine;

namespace Butterfly.Messages
{
    class RemovePlaylistItemMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            if (session == null || session.GetHabbo() == null || session.GetHabbo().CurrentRoom == null)
                return;

            Room currentRoom = session.GetHabbo().CurrentRoom;

            if (!currentRoom.CheckRights(session, true) || !currentRoom.GotMusicController())
                return;

            RoomMusicController musicController = currentRoom.GetRoomMusicController();

            SongItem item = musicController.RemoveDisk(request.ReadInt());
            if (item == null)
                return;

            item.RemoveFromDatabase();
            session.GetHabboDataContainer().GetInventoryComponent().AddNewItem(item.itemID, item.baseItem.ItemId, item.songID.ToString(), true, true);
            session.GetHabboDataContainer().GetInventoryComponent().UpdateItems(false);

            //Session.SendMessage(JukeboxComposer.SerializeSongInventory(Session.GetHabboDataContainer().GetInventoryComponent().songDisks));
            //Session.SendMessage(JukeboxComposer.Compose(musicController.PlaylistCapacity, musicController.Playlist.Values.ToList()));
        }

    }
}