using Butterfly.HabboHotel.GameClients;
using Butterfly.Messages.IOCodes;

namespace Butterfly.Messages
{
    class GetOwnUserInformationMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            ServerMessage message = PacketHandelingManager.GetRecycledItem(OutputCode.GetOwnUserInfoEvent);
            message.AddUInt32(session.GetHabbo().Id);
            message.AddString(session.GetHabbo().Username);
            message.AddString(session.GetHabbo().Look);
            message.AddString(session.GetHabbo().Gender.ToUpper());
            message.AddString(session.GetHabbo().Motto);
            message.AddString(session.GetHabbo().RealName);
            message.AddBoolean(false);
            message.AddInt32(session.GetHabbo().Respect);
            message.AddInt32(session.GetHabbo().DailyRespectPoints); // respect to give away
            message.AddInt32(session.GetHabbo().DailyPetRespectPoints);
            message.AddBoolean(true);
            message.AddString(session.GetHabbo().LastOnline);
            message.AddBoolean(false);
            message.AddBoolean(false);
            session.SendMessage(message);

            const bool SAFECHAT = true;
            const bool ISGUIDE = false;
            const bool VOTE_IN_COMP = false;

            message = PacketHandelingManager.GetRecycledItem(OutputCode.AllowancesMessageEvent);
            message.AddInt32(6); // count
            message.AddString("SAFE_CHAT");
            message.AddBoolean(SAFECHAT);
            message.AddString((!SAFECHAT) ? "requirement.unfulfilled.safety_quiz_1" : "");
            message.AddString("USE_GUIDE_TOOL");
            message.AddBoolean(ISGUIDE);
            message.AddString((!ISGUIDE) ? "requirement.unfulfilled.helper_level_4" : "");
            message.AddString("VOTE_IN_COMPETITIONS");
            message.AddBoolean(VOTE_IN_COMP);
            message.AddString((!VOTE_IN_COMP) ? "requirement.unfulfilled.helper_level_2" : "");
            message.AddString("TRADE");
            message.AddBoolean(true);
            message.AddString("");
            message.AddString("FULL_CHAT");
            message.AddBoolean(true);
            message.AddString("");
            message.AddString("CITIZEN");
            message.AddBoolean(true);
            message.AddString("");
            
            session.SendMessage(message);

            message=PacketHandelingManager.GetRecycledItem(OutputCode.AchievementsScoreEvent);
            message.AddInt32(session.GetHabbo().AchievementPoints);
            session.SendMessage(message);

        }

    }
}