using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Users.Subscriptions;
using Butterfly.Messages.IOCodes;
using System;

namespace Butterfly.Messages
{
    class GetSubscriptionDataMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            //string SubscriptionId = Request.ReadString();

            ServerMessage club = PacketHandelingManager.GetRecycledItem(OutputCode.SerializeClub);

            if (session.GetHabboDataContainer().GetSubscriptionManager().HasSubscription(SubscriptionManager.SUBSCRIPTION_TYPE_VIP))
            {
                club.AddString(SubscriptionManager.SUBSCRIPTION_TYPE_CLUB);
                double Expire = session.GetHabboDataContainer().GetSubscriptionManager().GetSubscription().ExpireTime;
                double TimeLeft = Expire - TextHandling.GetUnixTimestamp();
                int TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                int MonthsLeft = TotalDaysLeft / 31;

                if (MonthsLeft >= 1) MonthsLeft--;

                club.AddInt32(TotalDaysLeft);// - (MonthsLeft * 31));
                club.AddInt32(2); // ??
                club.AddInt32(MonthsLeft);
                club.AddInt32(1); // type
                club.AddBoolean(true);
                club.AddBoolean(true);
                club.AddInt32((int)TimeLeft); //Time left HC
                club.AddInt32(0); // days i have on hc
                club.AddInt32(495); // days i have on vip
            }
            else if (session.GetHabboDataContainer().GetSubscriptionManager().HasSubscription(SubscriptionManager.SUBSCRIPTION_TYPE_CLUB))
            {
                club.AddString(SubscriptionManager.SUBSCRIPTION_TYPE_CLUB);
                double Expire = session.GetHabboDataContainer().GetSubscriptionManager().GetSubscription().ExpireTime;
                double TimeLeft = Expire - TextHandling.GetUnixTimestamp();
                int TotalDaysLeft = (int)Math.Ceiling(TimeLeft / 86400);
                int MonthsLeft = TotalDaysLeft / 31;

                if (MonthsLeft >= 1) MonthsLeft--;

                club.AddInt32(0);// - (MonthsLeft * 31));
                club.AddInt32(0); // ??
                club.AddInt32(0);
                club.AddInt32(2); // type
                club.AddBoolean(true);
                club.AddBoolean(false);
                club.AddInt32((int)TimeLeft); //Time left HC
                club.AddInt32(0); // days i have on hc
                club.AddInt32(495); // days i have on vip
            }
            else
            {
                club.AddString(SubscriptionManager.SUBSCRIPTION_TYPE_CLUB);
                club.AddInt32(0);
                club.AddInt32(0); // ??
                club.AddInt32(0);
                club.AddInt32(0); // type
                club.AddBoolean(false);
                club.AddBoolean(true);
                club.AddInt32(0);
                club.AddInt32(0); // days i have on hc
                club.AddInt32(0); // days i have on vip
            }

            session.SendMessage(club);
        }

    }
}