using Butterfly.HabboHotel.GameClients;
using Butterfly.HabboHotel.Users.Badges;
using Butterfly.Messages.IOCodes;
using Database_Manager.Database.Session_Details.Interfaces;

namespace Butterfly.Messages
{
    class UpdateBadgesMessageEventHandler : IMessageEventHandler
    {
        public void HandleEvent(GameClient session, ClientMessage request)
        {
            session.GetHabboDataContainer().GetBadgeComponent().ResetSlots();

            using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
            {
                dbClient.runFastQuery("UPDATE user_badges SET badge_slot = 0 WHERE user_id = " + session.GetHabbo().Id);
            }

            for (int i = 0; i < 5; i++)
            {
                int Slot = request.ReadInt();
                string Badge = request.ReadString();

                if (Badge.Length == 0)
                    continue;

                if (!session.GetHabboDataContainer().GetBadgeComponent().HasBadge(Badge) || Slot < 1 || Slot > 5)
                    return;

                session.GetHabboDataContainer().GetBadgeComponent().GetBadge(Badge).Slot = Slot;

                using (IQueryAdapter dbClient = ButterflyEnvironment.DatabaseManager.getQueryreactor())
                {
                    dbClient.setQuery("UPDATE user_badges SET badge_slot = " + Slot + " WHERE badge_id = @badge AND user_id = " + session.GetHabbo().Id + "");
                    dbClient.addParameter("badge", Badge);
                    dbClient.runQuery();
                }
            }

            ButterflyEnvironment.Game.GetQuestManager().ProgressUserQuest(session, HabboHotel.Quests.QuestType.PROFILE_BADGE);

            ServerMessage Message = PacketHandelingManager.GetRecycledItem(OutputCode.HabboUserBadgesMessageEvent);
            Message.AddInt32((int)session.GetHabbo().Id);
            Message.AddInt32(session.GetHabboDataContainer().GetBadgeComponent().EquippedCount);

            foreach (Badge Badge in session.GetHabboDataContainer().GetBadgeComponent().BadgeList.Values)
            {
                if (Badge.Slot <= 0)
                {
                    continue;
                }

                Message.AddInt32(Badge.Slot);
                Message.AddString(Badge.Code);
            }

            if (session.GetHabbo().InRoom && ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId) != null)
            {
                ButterflyEnvironment.Game.GetRoomManager().GetRoom(session.GetHabbo().CurrentRoomId).SendMessage(Message);
            }
            else
            {
                session.SendMessage(Message);
            }
        }

    }
}