﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Butterfly.Messages.UnitTesting
{
    class ClientMessageUnitTest
    {
        #region Fields
        private int position;
        private byte[] body;

        private static Encoding encoding = Encoding.ASCII;
        #endregion

        public ClientMessageUnitTest(byte[] data)
        {
            this.body = data;
            this.position = 0;
        }

        internal short ReadShort()
        {
            short value = BitConverter.ToInt16(body, position);
            position += 2;

            return value;
        }

        internal string ReadString(int k = 0)
        {
            int stringLength = ReadShort();
            if (stringLength <= 0)
            {
                Console.WriteLine("String => []");
                return string.Empty;
            }

            string value = encoding.GetString(body, position, stringLength);
            position += stringLength;

            Console.WriteLine("String => [{0}]", value);
            return value;
        }

        internal int ReadInt(int index = 0)
        {
            int value = BitConverter.ToInt32(body, position);
            position += 4;

            Console.WriteLine("Int => " + value);
            return value;
        }

        internal uint ReadUInt()
        {
            return (uint)ReadInt();
        }

        internal bool ReadBool()
        {
            bool k = ReadInt() == 1;
            Console.WriteLine("bool => " + k);
            return k;
        }
    }
}
