﻿using Butterfly.Core;
using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Security.Permissions;

namespace Butterfly
{
    internal class Program
    {
        internal static Stopwatch startWatch;

        internal static void Main(string[] arg)
        {
            startWatch = new Stopwatch();
            startWatch.Start();

            Console.ForegroundColor = ConsoleColor.White;
            Console.CursorVisible = false;
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(OnUnhandledException);

            ButterflyEnvironment.Initialize();

            while (true)
            {
                Console.CursorVisible = true;
                if (Logging.DisabledState)
                    Console.Write("bfly> ");
                ConsoleCommandHandeling.InvokeCommand(Console.ReadLine());
            }
        }

        static void OnUnhandledException(object sender, UnhandledExceptionEventArgs args)
        {
            Logging.DisablePrimaryWriting(true);
            Exception e = (Exception)args.ExceptionObject;
            Logging.LogCriticalException("FATAL SYSTEM EXCEPTION: " + e.ToString());
            ButterflyEnvironment.Game.GetClientManager().SendMassMessage("A fatal error crashed the server, server shutting down.");
            ButterflyEnvironment.PreformShutDown(true);
        }
    }
}
