﻿namespace Collections.ModernCollections
{
    public interface ISortable<T, V>
    {
        /// <summary>
        /// The key in the sorted list, will be the value which is used for sorting the list
        /// </summary>
        T Key { get; }
        /// <summary>
        /// Value in the list, eg. a room count as key could have room ID as its value. This is unique.
        /// </summary>
        V Value { get; }
        /// <summary>
        /// Its position in the collection
        /// </summary>
        int Index { get; set; }
    }
}
