﻿using System.Net;
using System.Net.Sockets;

namespace ConnectivityAsync
{
    class RemoteConnection
    {
        private Socket socket;

        public RemoteConnection()
        {
            this.socket = new Socket(SocketType.Stream, ProtocolType.Tcp);
        }

        public void Connect(long ip, int port)
        {
            this.socket.Connect(new IPEndPoint(ip, port));
        }

        public void Close()
        {
            this.socket.Close();
        }

        public bool Send(byte[] buffer, int offset, int size)
        {
            return this.socket.Send(buffer, offset, size, SocketFlags.None) != 0;
        }

        public int Receive(byte[] buffer, int offset, int size)
        {
            return this.socket.Receive(buffer, offset, size, SocketFlags.None);
        }
    }
}
