# Butterfly Emulator r107 (Codename: buttercraft) #
r107 is an iteration of the official 105 release where the main highlight is the added support for non-Windows platforms through .NET Core. Butterfly Emulator is much recognized for being a stable emulator and was during a time ahead of most other emulators in terms of how many users it could support and which feature it was able to emulate. With this release, we are again bringing Butterfly ahead of the curve by being (most likely) the first C# emulator with support for .NET Core. r106 was never released as it was mainly a small patch release of r106 with XML configuration that was more ugly than the .ini configuration bfly (and other bfly-based emus) use.


### Getting started ###

Prerequisites: To build the source, you will need to have installed [.NET Core 2.0 SDK](https://www.microsoft.com/net/core) for your platform. Which platforms you can run bfly on is limited to which platforms .NET Core supports. You will also need to have a MySQL database setup with the database `mainframe.sql` imported in it.

Open a terminal and cd to the `ButterflyEmulator` directory. Then run `dotnet build`. This will build bfly binaries in `ButterflyEmulator/bin/Debug/netcoreapp2.0`. After this, copy the settings folder from `ButterflyEnvironment/Config` and put it together with the generated binary files. You should then have a directory `ButterflyEmulator/bin/Debug/netcoreapp2.0/Settings`  that will contain JSON configuration files for the emulator. In this directory, open `Configuration.json` and update it to fit your database settings. Start the server by running `dotnet ButterflyEmulator.dll` in the `netcoreapp2.0` directory. 

### Vocabulary ###
Butterfly Emulator is shortened as bfly or bfly emu, preferably bfly. Other software distributed among this release is the Butterfly Heartbeat Monitor that displays a graph of the server activity and is usable for performance monitoring.

### Goals of bfly r106 ###
* Fix issues from r105
* Enforce better maintainability by refactoring parts of the server code
* Update code to follow standards for the C# programming language when it comes to naming and code formatting
* Refactor unclear, hairy code
* Update the SWF revision
* Add new features

### Goals of bfly r107 ###
* Targeting .NET Core
* Simplification of configuration files
* Cleanup of some major classes
