﻿using System;
using System.Collections.Generic;
using System.IO;

namespace SharedSendingLib
{
    public class OutgoingPacket : BinaryWriter
    {
        public OutgoingPacket(int code) : this(code, true)
        {
            
        }
        public OutgoingPacket(int code, bool includeDateTime) : base(new MemoryStream(1024))
        {   
            this.Write((short)4);
            this.Write(code);

            if (includeDateTime)
            {
                this.Write(DateTime.UtcNow.ToString());
            }
        }

        public byte[] GetData()
        {
            this.Flush();
            long size = this.OutStream.Position;
            this.OutStream.Position = 0;
            this.Write((short)(size - 2));
            byte[] data = new byte[size];

            this.OutStream.Position = 0;
            this.OutStream.Read(data, 0, (int)size);
            return data;
        }
    }
}
